-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_DESC ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_DESC
(
     p_id VARCHAR2
   , p_label VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_label || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DESC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_DESC(23) : clients.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_DESC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_DESC(31) : clients.sql(36) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DESC', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_DESC(34) : clients.sql(39) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_DESC', 40+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_DESC(41) : clients.sql(46) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      LABEL        = p_label,
      DESCRIPTION  = p_description,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(70) : clients.sql(75) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_DESC', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_DESC(76) : clients.sql(81) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(83) : clients.sql(88) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(95) : clients.sql(100) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_DESC;
ALTER FUNCTION SP_U_CLIENT_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_PUBLIC ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_PUBLIC
(
     p_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_PUBLIC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_PUBLIC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_PUBLIC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_PUBLIC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_PUBLIC(19) : clients.sql(135) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_PUBLIC', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_PUBLIC(25) : clients.sql(141) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_PUBLIC', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_PUBLIC(28) : clients.sql(144) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      PUBLIC_FLAG = p_del_flag,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(50) : clients.sql(166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_PUBLIC', 55+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_PUBLIC(56) : clients.sql(172) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(63) : clients.sql(179) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 74+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(75) : clients.sql(191) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_PUBLIC;
ALTER FUNCTION SP_U_CLIENT_PUBLIC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_CIE ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_address VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_client_more_100_employees PLS_INTEGER
   , p_client_more_1000_employees PLS_INTEGER
   , p_client_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_address || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CIE', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_CIE(45) : clients.sql(252) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_CIE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_CIE(53) : clients.sql(260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CIE', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_CIE(56) : clients.sql(263) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_CIE', 62+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_CIE(63) : clients.sql(270) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      DOMAIN_ID = p_domain_id,
      COMPANY_NAME = p_company_name,
      ADDRESS = p_address,
      PHONE = p_phone,
      FAX = p_fax,
      WEBSITE = p_website,
      OTHER_LOCATION = p_other_location,
      YEAR_IN_BUSINESS = p_year_in_business,
      CLIENT_MORE_100_EMPLOYEES = p_client_more_100_employees,
      CLIENT_MORE_1000_EMPLOYEES = p_client_more_1000_employees,
      CLIENT_MORE_10000_EMPLOYEES = p_client_more_10000_employees,
      NUMBER_EMPLOYEES = p_number_employees,
      CONTACT_NAME = p_contact_name,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(103) : clients.sql(310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_CIE', 108+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_CIE(109) : clients.sql(316) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 115+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(116) : clients.sql(323) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 127+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(128) : clients.sql(335) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_CIE;
ALTER FUNCTION SP_U_CLIENT_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_BKG ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_BKG', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_BKG(45) : clients.sql(396) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_BKG', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_BKG(53) : clients.sql(404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_BKG', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_BKG(56) : clients.sql(407) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_BKG', 62+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_BKG(63) : clients.sql(414) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENTS SET
      ANNUAL_REVENUES = p_annual_revenues,
      BILLING_ADDRESS = p_billing_address,
      BILLING_PHONE = p_billing_phone,
      BILLING_FAX = p_billing_fax,
      BILLING_EMAIL = p_billing_email,
      EQUAL_OPPORTUNITY = p_equal_opportunity,
      COMPANY_BACKGROUND = p_company_background,
      OWNERSHIP = p_ownership,
      SERVICES_OFFERED = p_services_offered,
      SERVICES_SPECIALIZED = p_services_specialized,
      INDUSTRIES_SERVED = p_industries_served,
      HIGHLIGHT = p_highlight,
      LOCATION_SERVED = p_location_served,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(103) : clients.sql(454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_BKG', 108+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_BKG(109) : clients.sql(460) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 115+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(116) : clients.sql(467) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 127+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(128) : clients.sql(479) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_BKG;
ALTER FUNCTION SP_U_CLIENT_BKG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SCP661a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661aa PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661bb PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT_CPLAN(35) : clients.sql(530) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate rec_user id
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CLIENT_CPLAN', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CLIENT_CPLAN(43) : clients.sql(538) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(46) : clients.sql(541) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If ((p_id IS NULL)) Then
      If Coalesce(p_bitflag, 0) = 1 Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_001';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_001
            SELECT RANK, ELEMENT_ID
            FROM TMT_CLIENTS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_CLIENTS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(80) : clients.sql(575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 A, PMO_TMP_CLIENTS_001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 105+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(106) : clients.sql(601) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661a FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = PMO_CNST.SC_RESOURCE) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,                    
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T
         JOIN PMO_TMP_CLIENTS_002 ASS ON ASS.ELEMENT_ID=T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0, 13) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 129+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(130) : clients.sql(625) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661a;
      Else
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_001';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_001
            SELECT RANK, ELEMENT_ID
            FROM TMT_CLIENTS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_CLIENTS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND
            RA.ELEMENT_TYPE = 11 AND
            RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(163) : clients.sql(658) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 A, PMO_TMP_CLIENTS_001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(189) : clients.sql(684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661aa FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T JOIN PMO_TMP_CLIENTS_002 ASS ON ASS.ELEMENT_ID = T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 210+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(211) : clients.sql(706) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661aa;
      End If;
   Else
      h_id := p_id;
      --VALIDATE_EXISTENCE(TMT_CLIENTS, h_id, h_rec_status);
      
      BEGIN
         SELECT RANK, LEVEL_ID,REC_STATUS
         INTO h_rank,h_level_id,h_rec_status
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 229+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(230) : clients.sql(725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_CPLAN', 236+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_CPLAN(237) : clients.sql(732) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 239+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(240) : clients.sql(735) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
      End If;
      
      If Coalesce(p_bitflag, 0) = 1 Then
         OPEN SCP661b FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,                        
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS C WHERE C.RANK LIKE h_rank || '%'
         AND ((T.RANK >= SUBSTR(C.RANK, 1, 8) AND T.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(T.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(T.RANK) END ) = T.RANK) AND TYPE_ID = PMO_CNST.SC_RESOURCE) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,                       
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         '' AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T
         WHERE (T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2 )
         AND T.TYPE_ID NOT IN (0, 13)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 267+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(268) : clients.sql(763) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661b;
      Else
         OPEN SCP661bb FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,                        
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_CLIENTS T
         WHERE T.TYPE_ID > 0
         AND T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 301+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(302) : clients.sql(797) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661bb;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 311+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(312) : clients.sql(807) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 323+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(324) : clients.sql(819) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT_CPLAN;
ALTER FUNCTION SP_S_CLIENT_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_CLIENT ==
CREATE OR REPLACE FUNCTION SP_CKOUT_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_CLIENT(22) : clients.sql(857) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(27) : clients.sql(862) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(30) : clients.sql(865) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(36) : clients.sql(871) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(39) : clients.sql(874) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_rec_user, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(56) : clients.sql(891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(62) : clients.sql(897) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(65) : clients.sql(900) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id2, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(79) : clients.sql(914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(87) : clients.sql(922) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(90) : clients.sql(925) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_OUT, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(97) : clients.sql(932) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(100) : clients.sql(935) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 106+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(107) : clients.sql(942) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 109+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(110) : clients.sql(945) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id2, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(130) : clients.sql(965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENTS SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(149) : clients.sql(984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_CLIENT', 155+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_CLIENT(156) : clients.sql(991) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 162+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(163) : clients.sql(998) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 174+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(175) : clients.sql(1010) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_CLIENT;
ALTER FUNCTION SP_CKOUT_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_CLIENT ==
CREATE OR REPLACE FUNCTION SP_CKIN_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE RESOURCE_ID = p_id
         ) WHERE ROWNUM<=1;

      CURSOR CH1P IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_CLIENTS
         WHERE ELEMENT_ID = p_id
         ) WHERE ROWNUM<=1;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_CLIENT(39) : clients.sql(1065) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(44) : clients.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CLIENT(47) : clients.sql(1073) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   
   BEGIN
      SELECT TYPE_ID, REC_STATUS INTO h_type_id, h_rec_status
      FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(65) : clients.sql(1091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 70+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(71) : clients.sql(1097) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CLIENT(74) : clients.sql(1100) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(87) : clients.sql(1113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 94+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(95) : clients.sql(1121) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CLIENT(98) : clients.sql(1124) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 104+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(105) : clients.sql(1131) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 107+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CLIENT(108) : clients.sql(1134) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_IN, h_id, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 114+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(115) : clients.sql(1141) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 117+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CLIENT(118) : clients.sql(1144) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := p_bitflag;
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 148+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(149) : clients.sql(1175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 166+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(167) : clients.sql(1193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 179+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(180) : clients.sql(1206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(201) : clients.sql(1227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 218+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(219) : clients.sql(1245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 236+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(237) : clients.sql(1263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES SELECT h_uniqueID, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 258+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(259) : clients.sql(1285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REVISION_HISTORY = Null WHERE RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 275+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(276) : clients.sql(1302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := p_bitflag;
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(311) : clients.sql(1337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 328+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(329) : clients.sql(1355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(342) : clients.sql(1368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 362+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(363) : clients.sql(1389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 380+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(381) : clients.sql(1407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_CLIENTS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 398+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(399) : clients.sql(1425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_CLIENTS SELECT h_uniqueID, A.* FROM TMT_CLIENTS A WHERE A.ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 420+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(421) : clients.sql(1447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 437+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(438) : clients.sql(1464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_CLIENTS';
         --SC_STATE = FC_D_REVISION(h_id,h_bitflag_revision,h_table_name);
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_CLIENT', 450+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_CLIENT(451) : clients.sql(1477) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 457+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(458) : clients.sql(1484) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 469+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(470) : clients.sql(1496) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_CLIENT;
ALTER FUNCTION SP_CKIN_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_CLIENT ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_CLIENT(20) : clients.sql(1532) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CLIENT', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CLIENT(25) : clients.sql(1537) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CLIENT(28) : clients.sql(1540) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(43) : clients.sql(1555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CLIENT', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CLIENT(49) : clients.sql(1561) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CLIENT(52) : clients.sql(1564) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_CLIENTS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_CLIENTS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_CLIENTS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(75) : clients.sql(1587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_CLIENT', 80+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_CLIENT(81) : clients.sql(1593) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CLIENT(84) : clients.sql(1596) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_UNDO_CHECKOUT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_CLIENT', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_CLIENT(90) : clients.sql(1602) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(97) : clients.sql(1609) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(109) : clients.sql(1621) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_CLIENT;
ALTER FUNCTION SP_UCKOUT_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_REVISION(27) : clients.sql(1664) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_REVISION(33) : clients.sql(1670) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_REVISION(36) : clients.sql(1673) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_REVISION', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_REVISION(43) : clients.sql(1680) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(70) : clients.sql(1707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_REVISION', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_REVISION(76) : clients.sql(1713) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(83) : clients.sql(1720) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(95) : clients.sql(1732) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_REVISION;
ALTER FUNCTION SP_U_CLIENT_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_CLIENTS)
*                           id = ELEMENT_ID in TMT_CLIENTS table, select from HISTORY_CLIENTS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_CLIENTS table, select from HISTORY_CLIENTS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT_REVISION(24) : clients.sql(1781) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(29) : clients.sql(1786) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(32) : clients.sql(1789) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(53) : clients.sql(1810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(59) : clients.sql(1816) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(62) : clients.sql(1819) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      --      h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, "
      --          "REVISION_TYPE, REC_DATETIME, AUTHOR FROM(
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_CLIENTS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID WHERE ELEMENT_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID INTO h_rank, h_level_id, h_parent_id FROM HISTORY_CLIENTS WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(87) : clients.sql(1844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 92+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(93) : clients.sql(1850) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 95+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(96) : clients.sql(1853) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      --      h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, "
      --          "REVISION_TYPE, REC_DATETIME, AUTHOR FROM(
      h_sql := 
            ' SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_CLIENTS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''' ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(133) : clients.sql(1890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 138+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(139) : clients.sql(1896) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 141+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(142) : clients.sql(1899) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(155) : clients.sql(1912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 160+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(161) : clients.sql(1918) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 163+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(164) : clients.sql(1921) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 178+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(179) : clients.sql(1936) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 181+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(182) : clients.sql(1939) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 189+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(190) : clients.sql(1947) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 201+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(202) : clients.sql(1959) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT_REVISION;
ALTER FUNCTION SP_S_CLIENT_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_CLIENT_DOC ==
CREATE OR REPLACE FUNCTION FC_I_CLIENT_DOC
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rankBase64 VARCHAR2(8);
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CLIENT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CLIENT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CLIENT_DOC(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CLIENT_DOC(21) : clients.sql(1996) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CLIENT_DOCUMENTS
      (ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      REC_USER, RANK, PARENT_RANK)
      VALUES
      (h_uniqueID, h_uniqueID, h_name, PMO_CNST.SC_CUSTOM_FOLDER, 0,
      h_rec_user, h_rankBase64, 'CLN#' || h_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT_DOC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT_DOC(46) : clients.sql(2021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT_DOC', 51+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CLIENT_DOC(52) : clients.sql(2027) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CLIENT_DOC;
ALTER FUNCTION FC_I_CLIENT_DOC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_CLIENT
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CLIENT(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CLIENT(29) : clients.sql(2066) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_uniqueID IS NULL) Then
      h_uniqueID := SYS_GUID();
   End If;
   
   -- Validate parent_id
   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENTS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(54) : clients.sql(2091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_CLIENTS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         REC_USER,
         LOCAL)
         VALUES(
         h_rank,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         h_level_id,
         h_rec_user,
         h_rec_user,
         h_local);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(90) : clients.sql(2127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(109) : clients.sql(2146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_rank %s",h_rank);//trace_flush();
      --trace_printf(" h_parent_id %s",h_parent_id);//trace_flush();
      --trace_printf(" h_uniqueID %s",h_uniqueID);//trace_flush();
      --trace_printf(" h_name %s",h_name);//trace_flush();
      --trace_printf(" h_type_id %d",h_type_id);//trace_flush();
      --trace_printf(" h_level_id %d",h_level_id);//trace_flush();
      --trace_printf(" h_rec_user %s",h_rec_user);//trace_flush();
      --trace_printf(" h_rec_user %s",h_rec_user);//trace_flush();
      BEGIN
         INSERT INTO TMT_CLIENTS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         REC_USER,
         LOCAL)
         VALUES (
         h_rank,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         h_level_id,
         h_rec_user,
         h_rec_user,
         h_local);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(153) : clients.sql(2190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      h_temp_sc_state := FC_I_CLIENT_DOC(h_name, h_uniqueID, h_rank, h_rec_user);
   End If;
   
   h_rate_id := SYS_GUID();
   
   BEGIN
      INSERT INTO HISTORY_CLIENTS SELECT h_rate_id, A.* FROM TMT_CLIENTS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(178) : clients.sql(2215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_CLIENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(195) : clients.sql(2232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(212) : clients.sql(2249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CLIENT(218) : clients.sql(2255) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CLIENT;
ALTER FUNCTION FC_I_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_DOC_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_DOC_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      CURSOR c_all_child IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_CLIENTS
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLIENT', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_CLIENT(30) : clients.sql(2295) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_host_table := PMO_CNST.SC_TABLE_CLN;
   h_del_flag := 'X';
   h_null_id := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
   Else
      OPEN c_all_child;
      
      FETCH c_all_child INTO h_id, h_type_id;
      IF c_all_child%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
            PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
         End If;
         
         FETCH c_all_child INTO h_id, h_type_id;
         IF c_all_child%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      END LOOP;
      
      BEGIN
         CLOSE c_all_child ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLIENT', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLIENT(74) : clients.sql(2339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLIENT', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLIENT(81) : clients.sql(2346) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_CLIENT;
ALTER FUNCTION FC_D_DOC_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_del_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_found_cri VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 11;
   h_count PLS_INTEGER := 0;
   h_client_id VARCHAR2(32);
   h_cri_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
-- Declare Cursors
      CURSOR CRI_CLIENTS IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE CLIENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%')
         ) WHERE ROWNUM<=1;

      CURSOR CHARGEBACK_CLIENTS IS
         SELECT * FROM (SELECT PROJECT_ID
         FROM PROJECT_CHARGEBACK
         WHERE CLIENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%')
         ) WHERE ROWNUM<=1;

      CURSOR DEL_CRI_CLIENTS IS
         SELECT C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.PARENT_ID
         FROM TMT_CLIENTS C
         WHERE C.LOCAL = 'Y'
         AND EXISTS (SELECT 1 FROM TMT_CRI WHERE PROJECT_ID = h_project_id AND RANK LIKE h_cri_rank || '%' AND CLIENT_ID = C.ELEMENT_ID)
         AND NOT EXISTS (SELECT 1 FROM TMT_CRI WHERE PROJECT_ID = h_project_id AND RANK NOT LIKE h_cri_rank || '%' AND CLIENT_ID = C.ELEMENT_ID)
         AND NOT EXISTS (SELECT 1 FROM PROJECT_CHARGEBACK WHERE PROJECT_ID = h_project_id AND CLIENT_ID = C.ELEMENT_ID);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_CLIENT(49) : clients.sql(2405) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   --trace_printf("h_id: %s, h_bitflag: %d\n",h_id,h_bitflag);
   If Coalesce(h_bitflag, 0) <> 2 Then
      --  h_id is ELEMENT_ID in TMT_CLIENTS
      BEGIN
         SELECT LOCAL, TYPE_ID, RANK, CHILD_COUNT, PARENT_ID
         INTO h_local, h_type_id, h_rank, h_count, h_parent_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(68) : clients.sql(2424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 75+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(76) : clients.sql(2432) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   CASE h_bitflag
      WHEN 0 THEN
         --delete called by client
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            -- check if the client is referenced in TMT_CRI
            
            OPEN CRI_CLIENTS;
            
            FETCH CRI_CLIENTS INTO h_found_cri;
            IF CRI_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  CLOSE CRI_CLIENTS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 104+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(105) : clients.sql(2461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(111) : clients.sql(2467) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            BEGIN
               CLOSE CRI_CLIENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 123+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(124) : clients.sql(2480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            
            OPEN CHARGEBACK_CLIENTS;
            
            FETCH CHARGEBACK_CLIENTS INTO h_found_cri;
            IF CHARGEBACK_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  CLOSE CHARGEBACK_CLIENTS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 148+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(149) : clients.sql(2505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(155) : clients.sql(2511) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            BEGIN
               CLOSE CHARGEBACK_CLIENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 167+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(168) : clients.sql(2524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(189) : clients.sql(2545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               DELETE FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(220) : clients.sql(2576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            -- check if the client is referenced in TMT_CRI
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(236) : clients.sql(2592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(243) : clients.sql(2599) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_CHARGEBACK
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(259) : clients.sql(2615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 265+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(266) : clients.sql(2622) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 285+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(286) : clients.sql(2642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 302+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(303) : clients.sql(2659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (h_parent_id IS NOT NULL) Then
            BEGIN
               UPDATE TMT_CLIENTS
               SET CHILD_COUNT = CHILD_COUNT - 1,
               DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 324+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(325) : clients.sql(2681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         
      
      WHEN 1 THEN
         --delete project called by wbs when a project is deleted
         If SubStr(h_local, 1, 1) = 'Y' Then
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 351+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(352) : clients.sql(2708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               DELETE FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 382+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(383) : clients.sql(2739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 403+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(404) : clients.sql(2760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 410+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(411) : clients.sql(2767) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         End If;
         
      
      WHEN 2 THEN
         --delete client called by CRI when a CRI is deleted
         --  h_id is ELEMENT_ID in TMT_CRI
         BEGIN
            SELECT RANK, PROJECT_ID INTO h_cri_rank, h_project_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 429+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(430) : clients.sql(2786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN DEL_CRI_CLIENTS;
         LOOP
            FETCH DEL_CRI_CLIENTS INTO h_client_id, h_type_id, h_rank, h_parent_id;
            IF DEL_CRI_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            --trace_printf("h_client_id: %s, h_type_id: %d\n",h_client_id,h_type_id);
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_client_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_client_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 463+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(464) : clients.sql(2820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_client_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 480+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(481) : clients.sql(2837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 501+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(502) : clients.sql(2858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE DEL_CRI_CLIENTS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 515+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(516) : clients.sql(2872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 3 THEN
         --delete called by SP_U_CRI_CLIENT
         If SubStr(h_local, 1, 1) = 'Y' Then
            -- check if the client is referenced in TMT_CRI
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 533+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(534) : clients.sql(2890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 540+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(541) : clients.sql(2897) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_CHARGEBACK
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 556+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(557) : clients.sql(2913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 563+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(564) : clients.sql(2920) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 583+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(584) : clients.sql(2940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 600+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(601) : clients.sql(2957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 621+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(622) : clients.sql(2978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 628+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(629) : clients.sql(2985) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         End If;
         
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 638+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(639) : clients.sql(2995) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_CLIENT;
ALTER FUNCTION FC_D_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_MERGE_CLIENT ==
CREATE OR REPLACE FUNCTION FC_MERGE_CLIENT
(
     h_target IN OUT NOCOPY VARCHAR2
   , h_source IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MERGE_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MERGE_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_MERGE_CLIENT(' || 
       '''' || h_target || ''''
          || ', ' || '''' || h_source || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MERGE_CLIENT(19) : clients.sql(3024) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   --validate source
   BEGIN
      SELECT ELEMENT_NAME INTO h_name
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_target;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_CLIENT', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_CLIENT(35) : clients.sql(3040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_CLIENT(42) : clients.sql(3047) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_NAME = h_name,
      ELEMENT_ID   = h_target,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_source;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_CLIENT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_CLIENT(65) : clients.sql(3070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_bitflag := 0;
   PMO_DB2M.SC_STATE := FC_D_CLIENT(h_source, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 73+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_CLIENT(74) : clients.sql(3079) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MERGE_CLIENT;
ALTER FUNCTION FC_MERGE_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION FC_U_CLIENT_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_CLIENT_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_CLIENT_NAME(20) : clients.sql(3109) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID INTO h_type_id
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CLIENT_NAME', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CLIENT_NAME(33) : clients.sql(3122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_CLIENT_NAME(40) : clients.sql(3129) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_CLN;
   
   PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN(h_host_table, h_id, h_name, h_rec_user, h_error_id);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN_DOC(h_host_table, h_id, h_name, h_rec_user, h_error_id);
      
      -- Execute Update Statement
      BEGIN
         UPDATE TMT_CRI
         SET CLIENT_NAME = RTRIM(LTRIM(h_name)),
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = h_rec_user
         WHERE CLIENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CLIENT_NAME', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CLIENT_NAME(69) : clients.sql(3158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_CLIENT_NAME(80) : clients.sql(3169) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_CLIENT_NAME;
ALTER FUNCTION FC_U_CLIENT_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_NAME', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_NAME(23) : clients.sql(3202) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_NAME', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_NAME(31) : clients.sql(3210) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_NAME', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_NAME(34) : clients.sql(3213) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_CLIENT_NAME(h_id, h_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_NAME', 45+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_NAME(46) : clients.sql(3225) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_NAME', 52+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_NAME(53) : clients.sql(3232) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_NAME', 64+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_NAME(65) : clients.sql(3244) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_NAME;
ALTER FUNCTION SP_U_CLIENT_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_CLIENT ==
CREATE OR REPLACE FUNCTION SP_I_CLIENT
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CLIENT(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CLIENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CLIENT(26) : clients.sql(3286) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   h_uniqueID := NULL;
   
   PMO_DB2M.SC_STATE := FC_I_CLIENT(h_name, h_uniqueID, h_parent_id, h_type_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CLIENT', 39+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CLIENT(40) : clients.sql(3300) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CLIENT', 46+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CLIENT(47) : clients.sql(3307) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CLIENT', 58+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CLIENT(59) : clients.sql(3319) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CLIENT;
ALTER FUNCTION SP_I_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_MERGE_CLIENT ==
CREATE OR REPLACE FUNCTION SP_MERGE_CLIENT
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target VARCHAR2(32);
   h_source VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_MERGE_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_MERGE_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_MERGE_CLIENT(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_MERGE_CLIENT(22) : clients.sql(3357) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   h_target := p_target;
   h_source := p_source;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_MERGE_CLIENT(h_target, h_source, h_rec_user);
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_MERGE_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_MERGE_CLIENT(35) : clients.sql(3370) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_target || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_target, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_CLIENT(42) : clients.sql(3377) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_CLIENT', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_CLIENT(54) : clients.sql(3389) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_MERGE_CLIENT;
ALTER FUNCTION SP_MERGE_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_FIND ==
CREATE OR REPLACE FUNCTION SP_FIND
(
     p_name VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(4000);
   h_name VARCHAR2(255);
   h_project_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND(' || 
       '''' || p_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND(24) : clients.sql(3429) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_project_id := p_project_id;
   
   --Return a resultset
   h_xsql := 'SELECT ELEMENT_NAME, TYPE_ID, ELEMENT_ID ';
   h_xsql := h_xsql || 'FROM TMT_CLIENTS ';
   h_xsql := h_xsql || 'WHERE TYPE_ID = ';
   h_xsql := h_xsql || TO_CHAR(PMO_CNST.SC_CLIENTS);
   h_xsql := h_xsql || ' AND UPPER(ELEMENT_NAME) LIKE UPPER(''';
   h_xsql := h_xsql || h_name;
   h_xsql := h_xsql || '%%'') AND (LOCAL = ''N'' OR PARENT_ID = ''';
   h_xsql := h_xsql || h_project_id;
   h_xsql := h_xsql || ''') ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 43+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND(44) : clients.sql(3449) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND(47) : clients.sql(3452) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND(55) : clients.sql(3460) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND(67) : clients.sql(3472) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND;
ALTER FUNCTION SP_FIND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CSnull PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS0 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      client_refresh PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT(35) : clients.sql(3523) : ' || SYSTIMESTAMP);
   END IF; 

   h_count := 0;
   If (p_id IS NULL) Then
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENTS
         WHERE RANK LIKE 'qqqq%' AND LEVEL_ID = 0 AND CHILD_COUNT > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 49+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(50) : clients.sql(3538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN CSnull FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN h_count ELSE T.CHILD_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.PARENT_ID IS NULL
      AND T.RANK <> '0000'
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(68) : clients.sql(3556) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CSnull;
   ElsIf Coalesce(p_bitflag, 0) = 0 Then
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank,h_level_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(82) : clients.sql(3570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT', 88+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT(89) : clients.sql(3577) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 91+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(92) : clients.sql(3580) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENTS
         WHERE RANK LIKE 'qqqq%' AND LEVEL_ID = 0 AND CHILD_COUNT > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(107) : clients.sql(3595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN CS0 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN h_count ELSE T.CHILD_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      AND (SUBSTR(T.RANK,1,4) <> 'qqqq' OR T.LEVEL_ID > 1 OR T.CHILD_COUNT > 0)
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 124+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(125) : clients.sql(3613) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS0;
   ElsIf Coalesce(p_bitflag, 0) = 1 Then
      OPEN CS1 FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.RANK LIKE '0000%' AND LEVEL_ID = 0 
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      
      UNION ALL
      
      SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = p_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 152+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(153) : clients.sql(3641) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS1;
   ElsIf Coalesce(p_bitflag, 0) = 2 Then
      OPEN CS2 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT CHILD_COUNT FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE (T.PARENT_ID = p_id OR T.RANK = 'qqqq')
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 168+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(169) : clients.sql(3657) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS2;
   ElsIf Coalesce(p_bitflag, 0) = 5 Then
      OPEN client_refresh FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT CHILD_COUNT FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = p_id
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 184+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(185) : clients.sql(3673) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN client_refresh;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 193+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(194) : clients.sql(3682) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 205+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(206) : clients.sql(3694) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT;
ALTER FUNCTION SP_S_CLIENT COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting clients and Resources:
    if exists(resource assignments)
        cannot delete clients
        cannot delete resource
    else
        do delete clients and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_CLIENT ==
CREATE OR REPLACE FUNCTION SP_D_CLIENT
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CLIENT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CLIENT(24) : clients.sql(3741) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_id := p_id;
   h_bitflag := 0;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_D_CLIENT(h_id, h_bitflag, h_rec_user);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CLIENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CLIENT(39) : clients.sql(3756) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CLIENT', 45+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CLIENT(46) : clients.sql(3763) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CLIENT', 57+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CLIENT(58) : clients.sql(3775) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CLIENT;
ALTER FUNCTION SP_D_CLIENT COMPILE DEBUG;

/*******************************************************************/

Prompt == FUNCTION FC_M_CLIENT ==
CREATE OR REPLACE FUNCTION FC_M_CLIENT
(
     h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_target_rank VARCHAR2(200);
   h_target_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_prefix VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_M_CLIENT(' || 
       '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CLIENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_CLIENT(39) : clients.sql(3830) : ' || SYSTIMESTAMP);
   END IF; 

   h_prefix := 'CLN#';
   
   BEGIN
      SELECT PARENT_ID, RANK, LEVEL_ID
      INTO h_source_parent_id, h_source_rank, h_source_level
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(55) : clients.sql(3846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_target_id IS NULL) Then
      BEGIN
         SELECT PARENT_ID, RANK, LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(72) : clients.sql(3863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARENT_ID, RANK,LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(88) : clients.sql(3879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      If (((h_target_parent_id IS NULL)) AND ((h_source_parent_id IS NULL))) OR (PMO_ORASTD.strcmp(
            h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH) Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_UP_CLN(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                        , h_prefix, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_DOWN_CLN(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                          , h_prefix, h_rec_user);
         End If;
      Else
         PMO_DB2M.SC_STATE := FC_SMP_MOVE_DIF_CLN(h_target_level, h_source_level, h_target_rank
                                         , h_source_rank, h_target_parent_id, h_new_rank, h_prefix
                                         , h_rec_user);
         
         BEGIN
            UPDATE TMT_CLIENTS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 122+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(123) : clients.sql(3914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --update source hierarchy
      If (h_source_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CLIENTS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(145) : clients.sql(3936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_target_id IS NULL) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENTS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := 0;
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      Else
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := Coalesce(h_target_level, 0) + 1;
         h_level_id := Coalesce(h_level_id, 0);
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      End If;
      
      h_len := Coalesce(Length(h_source_rank), 0);
      h_len := Coalesce(h_len, 0);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_source_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_source_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = 'CLN#' || h_rank || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN ''
         ELSE SUBSTR(PARENT_RANK, h_len + 5, LENGTH(PARENT_RANK) - h_len - 4) END
         WHERE PARENT_RANK LIKE 'CLN#' || h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(200) : clients.sql(3991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET LEVEL_ID = LEVEL_ID + h_level_id - h_source_level,
         RANK = h_rank || CASE WHEN LENGTH(RANK) = h_len THEN '' ELSE SUBSTR(RANK, h_len + 1, LENGTH(RANK) - h_len) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id ELSE PARENT_ID END,
         
         
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 225+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(226) : clients.sql(4017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CLIENT', 235+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_CLIENT(236) : clients.sql(4027) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_CLIENT;
ALTER FUNCTION FC_M_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PUBLISH_LOCAL_CLIENT ==
CREATE OR REPLACE FUNCTION FC_PUBLISH_LOCAL_CLIENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PUBLISH_LOCAL_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PUBLISH_LOCAL_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_PUBLISH_LOCAL_CLIENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PUBLISH_LOCAL_CLIENT', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PUBLISH_LOCAL_CLIENT(20) : clients.sql(4057) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := NULL;
   h_bitflag := 4;
   PMO_DB2M.SC_STATE := FC_M_CLIENT(h_target_id, h_element_id, h_bitflag, h_rec_user);
   
   If PMO_DB2M.SC_STATE = 0 Then
      BEGIN
         UPDATE TMT_CLIENTS 
         SET CHILD_COUNT = case when CHILD_COUNT > 0 then CHILD_COUNT - 1 else 0 end
         WHERE ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PUBLISH_LOCAL_CLIENT', 41+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PUBLISH_LOCAL_CLIENT(42) : clients.sql(4079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PUBLISH_LOCAL_CLIENT', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PUBLISH_LOCAL_CLIENT(53) : clients.sql(4090) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PUBLISH_LOCAL_CLIENT;
ALTER FUNCTION FC_PUBLISH_LOCAL_CLIENT COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION SP_M_CLIENT ==
CREATE OR REPLACE FUNCTION SP_M_CLIENT
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CLIENT(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CLIENT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CLIENT(25) : clients.sql(4125) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := p_target;
   h_source_id := p_source;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_M_CLIENT(h_target_id, h_source_id, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CLIENT', 35+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CLIENT(36) : clients.sql(4136) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_source_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(44) : clients.sql(4144) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(56) : clients.sql(4156) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CLIENT;
ALTER FUNCTION SP_M_CLIENT COMPILE DEBUG;

/****************************************************************************************/

--SC_SQL_API SP_M_CLIENT

--(

--    SC_WCHAR        *p_target,

--    SC_WCHAR        *p_source,

--    SC_LONG_PARAM   *p_bitflag,

--    SC_WCHAR        *p_rec_user,

--    SC_LONG_PARAM   *nullIndicator

--)

--{

--    PMO_BEGIN_FUNCTION(SP_M_CLIENT);

--

--    struct ind_m_client_struct {

--        short p_target;

--        short p_source;

--        short p_bitflag;

--        short p_rec_user;

--    } *ind_m_client = (ind_m_client_struct *) nullIndicator;

--

--    //Local host variables

--    SC_CHAR(h_id, SC_H_ID);

--    SC_LONG(h_level_id);

--    SC_CHAR(h_local, SC_H_FLAG);

--    SC_LONG(h_max_rank);

--    SC_LONG(h_source_level);

--    SC_CHAR(h_parent_id, SC_H_ID);

--    SC_CHAR(h_rec_user, SC_H_ID);

--    SC_CHAR(h_source_rank, SC_H_FULL_RANK);

--    SC_CHAR(h_rank, SC_H_FULL_RANK);

--    SC_CHAR(h_new_rank, SC_H_FULL_RANK);

--    SC_CHAR(h_rankBase64, SC_H_PART_RANK);

--    SC_CHAR(h_source_parent_id, SC_H_ID);

--    SC_CHAR(h_target_parent_id, SC_H_ID);

--    SC_CHAR(h_extend_rank, SC_H_FULL_RANK);

--    SC_CHAR(h_next_rank, SC_H_FULL_RANK);

--    SC_CHAR(h_cur_rank, SC_H_FULL_RANK);

--    SC_CHAR(h_target_rank, SC_H_FULL_RANK);

--    SC_LONG(h_target_level);

--    SC_LONG(h_len);

--    SC_CHAR(h_target_id, SC_H_ID);

--    SC_CHAR(h_source_id, SC_H_ID);

--    SC_LONG(h_bitflag);

--    SC_CHAR(h_prefix, SC_H_FULL_RANK);

--

--    InitializeHost(SC_PARAM(h_target_id), p_target,ind_m_client->p_target);

--    InitializeHost(SC_PARAM(h_source_id), p_source,ind_m_client->p_source);

--    InitializeHost(SC_PARAM(h_bitflag), *p_bitflag,ind_m_client->p_bitflag);

--    InitializeHost(SC_PARAM(h_rec_user), p_rec_user,ind_m_client->p_rec_user);

--    InitializeHost(SC_PARAM(h_prefix), "CLN#");

--

--    BEGIN_SQL

--        SELECT PARENT_ID, RANK, LEVEL_ID

--        INTO HOST(h_source_parent_id), HOST(h_source_rank), HOST(h_source_level)

--        FROM TMT_CLIENTS

--        WHERE ELEMENT_ID = HOST(h_source_id) ;

--    END_SQL;

--

--    if (IsNullParam(h_target_id))

--    {

--        BEGIN_SQL

--            SELECT PARENT_ID, RANK, LEVEL_ID

--            INTO HOST(h_target_parent_id), HOST(h_target_rank), HOST(h_target_level)

--            FROM TMT_CLIENTS

--            WHERE ELEMENT_ID IS NuLL;

--        END_SQL;

--    }

--    else

--    {

--       BEGIN_SQL

--            SELECT PARENT_ID, RANK,LEVEL_ID

--            INTO HOST(h_target_parent_id), HOST(h_target_rank), HOST(h_target_level)

--            FROM TMT_CLIENTS

--            WHERE ELEMENT_ID = HOST(h_target_id) ;

--        END_SQL;

--    }

--//trace_printf("p2-----SC_STATE :%d\n",SC_STATE);

--

--//  trace_printf("p3---h_target_parent_id_Ind:%d,h_source_parent_id:%d\n",h_target_parent_id_Ind,h_source_parent_id_Ind);

--    if ((h_bitflag  1) == 1)

--    {

--        if (((IsNullParam(h_target_parent_id)) (IsNullParam(h_source_parent_id))) ||

--            (strcmp(h_target_parent_id, h_source_parent_id) == SC_MATCH))

--        {

--            if (strcmp(h_source_rank, h_target_rank) > SC_MATCH)

--            {

--                SC_STATE = FC_SMP_MOVE_UP_CLN(SC_PARAM(h_target_level), SC_PARAM(h_target_rank), SC_PARAM(h_source_rank), SC_PARAM(h_new_rank), SC_PARAM(h_prefix), SC_PARAM(h_rec_user));

--            }

--            else        // moving an element down

--            {

--                SC_STATE = FC_SMP_MOVE_DOWN_CLN(SC_PARAM(h_target_level), SC_PARAM(h_target_rank), SC_PARAM(h_source_rank), SC_PARAM(h_new_rank), SC_PARAM(h_prefix), SC_PARAM(h_rec_user));

--            }

--        }

--        else

--        {

--            SC_STATE = FC_SMP_MOVE_DIF_CLN(SC_PARAM(h_target_level), SC_PARAM(h_source_level),

--                SC_PARAM(h_target_rank), SC_PARAM(h_source_rank),

--                SC_PARAM(h_target_parent_id), SC_PARAM(h_new_rank), SC_PARAM(h_prefix), SC_PARAM(h_rec_user));

--

--            BEGIN_SQL

--                UPDATE TMT_CLIENTS

--                SET CHILD_COUNT = CHILD_COUNT - 1

--                WHERE ELEMENT_ID = HOST(h_source_parent_id) ;

--            END_SQL;

--        }

--    }

--    else

--    {

--        //update source hierarchy

--        if (IsNotNullParam(h_source_parent_id))

--        {

--            BEGIN_SQL

--                UPDATE TMT_CLIENTS

--                SET CHILD_COUNT = CHILD_COUNT - 1

--                WHERE ELEMENT_ID = HOST(h_source_parent_id);

--            END_SQL;

--        }

--

--        if (IsNullParam(h_target_id))

--        {

--            GET_ROOT_MAX_RANK(CMPRJ1, TMT_CLIENTS, h_max_rank);

--            toBase64(h_max_rank, h_rankBase64);

--

--            InitializeHost(SC_PARAM(h_level_id), 0);

--            sprintf(h_rank, "%s%s", h_target_rank, h_rankBase64);

--            InitializeHost(SC_PARAM(h_rank), h_rank);

--        }

--        else

--        {

--            GET_MAX_RANK(CMPRJ2, TMT_CLIENTS, h_target_id, h_max_rank);

--            toBase64(h_max_rank, h_rankBase64);

--

--            h_level_id = h_target_level + 1;

--            InitializeHost(SC_PARAM(h_level_id), h_level_id);

--            sprintf(h_rank, "%s%s", h_target_rank, h_rankBase64);

--            InitializeHost(SC_PARAM(h_rank), h_rank);

--        }

--

--        h_len = strlen(h_source_rank);

--        InitializeHost(SC_PARAM(h_len), h_len);

--

--PMO_VERIFY_RANK(h_source_rank, 0);

--        BEGIN_SQL

--            UPDATE TMT_CLIENT_DOCUMENTS

--            SET PARENT_RANK = 'CLN#' || HOST(h_rank) ||

--                CASE WHEN LENGTH(PARENT_RANK) = HOST(h_len)+4 THEN ''

--                    ELSE SUBSTR(PARENT_RANK, HOST(h_len) + 5, LENGTH(PARENT_RANK)-HOST(h_len)-4) END

--            WHERE PARENT_RANK LIKE 'CLN#' || HOST(h_source_rank) || '%';

--        END_SQL;

--

--        BEGIN_SQL

--            UPDATE TMT_CLIENTS

--            SET LEVEL_ID = LEVEL_ID + HOST(h_level_id) - HOST(h_source_level),

--                RANK = HOST(h_rank) || CASE WHEN LENGTH(RANK) = HOST(h_len) THEN ''

--                    ELSE SUBSTR(RANK, HOST(h_len) + 1, LENGTH(RANK)-HOST(h_len)) END,

--               PARENT_ID = CASE WHEN ELEMENT_ID = HOST(h_source_id) THEN HOST(h_target_id)

--                    ELSE PARENT_ID END,

--                REC_USER     = HOST(h_rec_user),

--                REC_STATUS   = 'U',

--                REC_DATETIME = SC_NOW

--           WHERE RANK LIKE HOST(h_source_rank) || '%';

--        END_SQL;

--    }

--

--    if (SC_NODATA)

--    {

--        SC_STATE = 0;

--    }

--

--    RETURN_STATUS(SC_STATE, *p_source);

--    PMO_END_FUNCTION;

--}

