-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_I_DOC_RES ==
CREATE OR REPLACE FUNCTION FC_I_DOC_RES
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_RES(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_RES(49) : doc_func.sql(52) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'RES';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(71) : doc_func.sql(74) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(78) : doc_func.sql(81) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(86) : doc_func.sql(89) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(105) : doc_func.sql(108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(112) : doc_func.sql(115) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(132) : doc_func.sql(135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(168) : doc_func.sql(171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_RESOURCE_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_RESOURCE_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(193) : doc_func.sql(196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(212) : doc_func.sql(215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(229) : doc_func.sql(232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_RESOURCE_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(349) : doc_func.sql(352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_RESOURCE_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(366) : doc_func.sql(369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(383) : doc_func.sql(386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(414) : doc_func.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(421) : doc_func.sql(424) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(425) : doc_func.sql(428) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_RES;
ALTER FUNCTION FC_I_DOC_RES COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_POOL ==
CREATE OR REPLACE FUNCTION FC_I_DOC_POOL
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_POOL(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_POOL(49) : doc_func.sql(485) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'POL';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(71) : doc_func.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(78) : doc_func.sql(514) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(86) : doc_func.sql(522) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(105) : doc_func.sql(541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(112) : doc_func.sql(548) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(132) : doc_func.sql(568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(168) : doc_func.sql(604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_POOL_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_POOL_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(193) : doc_func.sql(629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(212) : doc_func.sql(648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(229) : doc_func.sql(665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_POOL_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_POOL_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(349) : doc_func.sql(785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_POOL_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(366) : doc_func.sql(802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(383) : doc_func.sql(819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(414) : doc_func.sql(850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(421) : doc_func.sql(857) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(425) : doc_func.sql(861) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_POOL;
ALTER FUNCTION FC_I_DOC_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_ASSET ==
CREATE OR REPLACE FUNCTION FC_I_DOC_ASSET
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_ASSET(49) : doc_func.sql(918) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'AST';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(71) : doc_func.sql(940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(78) : doc_func.sql(947) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(86) : doc_func.sql(955) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(105) : doc_func.sql(974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(112) : doc_func.sql(981) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_ASSETS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(132) : doc_func.sql(1001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(168) : doc_func.sql(1037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSET_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_ASSET_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(193) : doc_func.sql(1062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(212) : doc_func.sql(1081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(229) : doc_func.sql(1098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_ASSET_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_ASSET_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(349) : doc_func.sql(1218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_ASSET_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(366) : doc_func.sql(1235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(383) : doc_func.sql(1252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(414) : doc_func.sql(1283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(421) : doc_func.sql(1290) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(425) : doc_func.sql(1294) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_ASSET;
ALTER FUNCTION FC_I_DOC_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_VENDOR ==
CREATE OR REPLACE FUNCTION FC_I_DOC_VENDOR
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_VENDOR(49) : doc_func.sql(1351) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'VDR';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(71) : doc_func.sql(1373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(78) : doc_func.sql(1380) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(86) : doc_func.sql(1388) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(105) : doc_func.sql(1407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(112) : doc_func.sql(1414) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_VENDORS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(132) : doc_func.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(168) : doc_func.sql(1470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDOR_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_VENDOR_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(193) : doc_func.sql(1495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(212) : doc_func.sql(1514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(229) : doc_func.sql(1531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_VENDOR_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_VENDOR_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(349) : doc_func.sql(1651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_VENDOR_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(366) : doc_func.sql(1668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(383) : doc_func.sql(1685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(414) : doc_func.sql(1716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(421) : doc_func.sql(1723) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(425) : doc_func.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_VENDOR;
ALTER FUNCTION FC_I_DOC_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_DOC_CLIENT
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_CLIENT(49) : doc_func.sql(1784) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CLN';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(71) : doc_func.sql(1806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(78) : doc_func.sql(1813) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(86) : doc_func.sql(1821) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(105) : doc_func.sql(1840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(112) : doc_func.sql(1847) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CLIENTS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(132) : doc_func.sql(1867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(168) : doc_func.sql(1903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CLIENT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(193) : doc_func.sql(1928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(212) : doc_func.sql(1947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(229) : doc_func.sql(1964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_CLIENT_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_CLIENT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(349) : doc_func.sql(2084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_CLIENT_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(366) : doc_func.sql(2101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(383) : doc_func.sql(2118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(414) : doc_func.sql(2149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(421) : doc_func.sql(2156) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(425) : doc_func.sql(2160) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_CLIENT;
ALTER FUNCTION FC_I_DOC_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_I_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_DOC(49) : doc_func.sql(2217) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(71) : doc_func.sql(2239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(78) : doc_func.sql(2246) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(86) : doc_func.sql(2254) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(105) : doc_func.sql(2273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(112) : doc_func.sql(2280) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(132) : doc_func.sql(2300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(168) : doc_func.sql(2336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(193) : doc_func.sql(2361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(212) : doc_func.sql(2380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(229) : doc_func.sql(2397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(349) : doc_func.sql(2517) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(366) : doc_func.sql(2534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(383) : doc_func.sql(2551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(414) : doc_func.sql(2582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(421) : doc_func.sql(2589) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(425) : doc_func.sql(2593) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_DOC;
ALTER FUNCTION FC_I_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_WBS ==
CREATE OR REPLACE FUNCTION FC_I_DOC_WBS
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_WBS(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_WBS(49) : doc_func.sql(2650) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(71) : doc_func.sql(2672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_parent_id: %s, h_rec_status: %s\n", SC_STATE,h_parent_id,h_rec_status);
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(79) : doc_func.sql(2680) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(87) : doc_func.sql(2688) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(106) : doc_func.sql(2707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 112+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(113) : doc_func.sql(2714) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_WBS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(133) : doc_func.sql(2734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(170) : doc_func.sql(2771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(195) : doc_func.sql(2796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(214) : doc_func.sql(2815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(231) : doc_func.sql(2832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 350+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(351) : doc_func.sql(2952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 367+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(368) : doc_func.sql(2969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 384+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(385) : doc_func.sql(2986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 415+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(416) : doc_func.sql(3017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 422+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(423) : doc_func.sql(3024) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 426+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(427) : doc_func.sql(3028) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_WBS;
ALTER FUNCTION FC_I_DOC_WBS COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_I_DOC_CRI ==
CREATE OR REPLACE FUNCTION FC_I_DOC_CRI
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_CRI(50) : doc_func.sql(3088) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CRI';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(72) : doc_func.sql(3110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(79) : doc_func.sql(3117) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(87) : doc_func.sql(3125) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      h_wbs_id := '';
      
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID, WBS_ID
         INTO h_parent_rank, h_parent_type_id, h_wbs_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_foreign_id
         AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(107) : doc_func.sql(3145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 113+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(114) : doc_func.sql(3152) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CRI
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(134) : doc_func.sql(3172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_wbs_id IS NOT NULL)) AND (PMO_ORASTD.strcmp(h_wbs_id, h_foreign_id) = 0) Then
         BEGIN
            UPDATE TMT_WBS
            SET DOC_COUNT = DOC_COUNT + 1
            WHERE ELEMENT_ID = h_foreign_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(154) : doc_func.sql(3192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 191+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(192) : doc_func.sql(3230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(217) : doc_func.sql(3255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 235+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(236) : doc_func.sql(3274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 252+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(253) : doc_func.sql(3291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 372+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(373) : doc_func.sql(3411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 389+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(390) : doc_func.sql(3428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 406+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(407) : doc_func.sql(3445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 437+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(438) : doc_func.sql(3476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 444+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(445) : doc_func.sql(3483) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 448+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(449) : doc_func.sql(3487) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_CRI;
ALTER FUNCTION FC_I_DOC_CRI COMPILE DEBUG;

/****************************************************************************************************/

Prompt == FUNCTION FC_ISOUT_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTd PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_DOC(23) : doc_func.sql(3520) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTd FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_DOC(30) : doc_func.sql(3527) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTd;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_DOC(38) : doc_func.sql(3535) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_DOC(50) : doc_func.sql(3547) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_DOC;
ALTER FUNCTION FC_ISOUT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_RES_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_RES_DOC(23) : doc_func.sql(3584) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTr FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_RESOURCE_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_RES_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_RES_DOC(30) : doc_func.sql(3591) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTr;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_RES_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_RES_DOC(38) : doc_func.sql(3599) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_RES_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_RES_DOC(50) : doc_func.sql(3611) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_RES_DOC;
ALTER FUNCTION FC_ISOUT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTp PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_POL_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_POL_DOC(23) : doc_func.sql(3648) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTp FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_POOL_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_POL_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_POL_DOC(30) : doc_func.sql(3655) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTp;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_POL_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_POL_DOC(38) : doc_func.sql(3663) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_POL_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_POL_DOC(50) : doc_func.sql(3675) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_POL_DOC;
ALTER FUNCTION FC_ISOUT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTa PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_AST_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_AST_DOC(23) : doc_func.sql(3712) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTa FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_ASSET_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_AST_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_AST_DOC(30) : doc_func.sql(3719) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTa;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_AST_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_AST_DOC(38) : doc_func.sql(3727) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_AST_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_AST_DOC(50) : doc_func.sql(3739) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_AST_DOC;
ALTER FUNCTION FC_ISOUT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTv PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_VDR_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_VDR_DOC(23) : doc_func.sql(3776) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTv FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_VENDOR_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_VDR_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_VDR_DOC(30) : doc_func.sql(3783) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTv;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_VDR_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_VDR_DOC(38) : doc_func.sql(3791) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_VDR_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_VDR_DOC(50) : doc_func.sql(3803) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_VDR_DOC;
ALTER FUNCTION FC_ISOUT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTc PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_CLN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_CLN_DOC(23) : doc_func.sql(3840) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTc FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_CLIENT_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_CLN_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_CLN_DOC(30) : doc_func.sql(3847) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTc;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_CLN_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_CLN_DOC(38) : doc_func.sql(3855) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_CLN_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_CLN_DOC(50) : doc_func.sql(3867) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_CLN_DOC;
ALTER FUNCTION FC_ISOUT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_DOC(24) : doc_func.sql(3905) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_DOC(37) : doc_func.sql(3918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(44) : doc_func.sql(3925) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(51) : doc_func.sql(3932) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(58) : doc_func.sql(3939) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_DOC(79) : doc_func.sql(3960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(85) : doc_func.sql(3966) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_DOC;
ALTER FUNCTION FC_CHECK_OUT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_RES_DOC(24) : doc_func.sql(3998) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_RES_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_RES_DOC(37) : doc_func.sql(4011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(44) : doc_func.sql(4018) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(51) : doc_func.sql(4025) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(58) : doc_func.sql(4032) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_RES_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_RES_DOC(79) : doc_func.sql(4053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(85) : doc_func.sql(4059) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_RES_DOC;
ALTER FUNCTION FC_CHECK_OUT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_POL_DOC(24) : doc_func.sql(4091) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_POL_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_POL_DOC(37) : doc_func.sql(4104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(44) : doc_func.sql(4111) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(51) : doc_func.sql(4118) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(58) : doc_func.sql(4125) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_POL_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_POL_DOC(79) : doc_func.sql(4146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(85) : doc_func.sql(4152) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_POL_DOC;
ALTER FUNCTION FC_CHECK_OUT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_AST_DOC(24) : doc_func.sql(4184) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_AST_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_AST_DOC(37) : doc_func.sql(4197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(44) : doc_func.sql(4204) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(51) : doc_func.sql(4211) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(58) : doc_func.sql(4218) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_AST_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_AST_DOC(79) : doc_func.sql(4239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(85) : doc_func.sql(4245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_AST_DOC;
ALTER FUNCTION FC_CHECK_OUT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_VDR_DOC(24) : doc_func.sql(4277) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_VDR_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_VDR_DOC(37) : doc_func.sql(4290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(44) : doc_func.sql(4297) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(51) : doc_func.sql(4304) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(58) : doc_func.sql(4311) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_VDR_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_VDR_DOC(79) : doc_func.sql(4332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(85) : doc_func.sql(4338) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_VDR_DOC;
ALTER FUNCTION FC_CHECK_OUT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_CLN_DOC(24) : doc_func.sql(4370) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_CLN_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_CLN_DOC(37) : doc_func.sql(4383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(44) : doc_func.sql(4390) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(51) : doc_func.sql(4397) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(58) : doc_func.sql(4404) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_CLN_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_CLN_DOC(79) : doc_func.sql(4425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(85) : doc_func.sql(4431) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_CLN_DOC;
ALTER FUNCTION FC_CHECK_OUT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKINd IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_DOC(39) : doc_func.sql(4478) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS, BLOB_ID, LINK_DOC
      INTO h_type_id, h_rank, h_status_id, h_max_revision,
      h_rec_status, h_blob_id, h_link_doc
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(54) : doc_func.sql(4493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(61) : doc_func.sql(4500) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(68) : doc_func.sql(4507) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINd;
   
   FETCH CKINd INTO h_min_revision;
   IF CKINd%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINd ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(97) : doc_func.sql(4536) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(119) : doc_func.sql(4558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINd ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(132) : doc_func.sql(4571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 156+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(157) : doc_func.sql(4596) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 179+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(180) : doc_func.sql(4619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 201+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(202) : doc_func.sql(4641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(347) : doc_func.sql(4786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 370+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(371) : doc_func.sql(4810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_blob_id IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_link_doc, 'P', 1) = 0) Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET (APPROVED_DATE, REF_NUMBER, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION,
            ATTACHED_ID, KEYWORDS, SUMMARY, LAST_CHECKIN,
            AUTHOR_CHECKOUT, ACTIVE, PRIORITY, SCOPE_RANK_ID, STAGE_ID,
            DOCUMENT_SIZE, COMPRESSED_SIZE, PRIVATE, VISIBLE_AT_PARENT,
            REVISION_TYPE, REVISION_IMPACT, REVISION_HISTORY,
            REC_DATETIME) =
            (SELECT APPROVED_DATE, REF_NUMBER, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION,
            ATTACHED_ID, KEYWORDS, SUMMARY, LAST_CHECKIN,
            AUTHOR_CHECKOUT, ACTIVE, PRIORITY, SCOPE_RANK_ID, STAGE_ID,
            DOCUMENT_SIZE, COMPRESSED_SIZE, PRIVATE, VISIBLE_AT_PARENT,
            REVISION_TYPE, REVISION_IMPACT, REVISION_HISTORY,
            REC_DATETIME
            FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_id)
            WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 402+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(403) : doc_func.sql(4842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 409+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(410) : doc_func.sql(4849) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 413+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(414) : doc_func.sql(4853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINr IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_RES_DOC(36) : doc_func.sql(4897) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(50) : doc_func.sql(4911) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(57) : doc_func.sql(4918) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(64) : doc_func.sql(4925) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINr;
   
   FETCH CKINr INTO h_min_revision;
   IF CKINr%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINr ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(93) : doc_func.sql(4954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(115) : doc_func.sql(4976) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINr ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(128) : doc_func.sql(4989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(153) : doc_func.sql(5014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(176) : doc_func.sql(5037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(198) : doc_func.sql(5059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_RESOURCE_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 342+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(343) : doc_func.sql(5204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_RESOURCE_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 366+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(367) : doc_func.sql(5228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 372+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(373) : doc_func.sql(5234) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 376+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(377) : doc_func.sql(5238) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_RES_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINp IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_POL_DOC(36) : doc_func.sql(5282) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(50) : doc_func.sql(5296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(57) : doc_func.sql(5303) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(64) : doc_func.sql(5310) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINp;
   
   FETCH CKINp INTO h_min_revision;
   IF CKINp%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(93) : doc_func.sql(5339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(115) : doc_func.sql(5361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(128) : doc_func.sql(5374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(153) : doc_func.sql(5399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(176) : doc_func.sql(5422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(198) : doc_func.sql(5444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_POOL_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_POOL_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 342+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(343) : doc_func.sql(5589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_POOL_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 366+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(367) : doc_func.sql(5613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 372+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(373) : doc_func.sql(5619) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 376+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(377) : doc_func.sql(5623) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_POL_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINa IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_AST_DOC(36) : doc_func.sql(5667) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(50) : doc_func.sql(5681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(57) : doc_func.sql(5688) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(64) : doc_func.sql(5695) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINa;
   
   FETCH CKINa INTO h_min_revision;
   IF CKINa%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINa ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(93) : doc_func.sql(5724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(115) : doc_func.sql(5746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINa ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(128) : doc_func.sql(5759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(153) : doc_func.sql(5784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(176) : doc_func.sql(5807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(198) : doc_func.sql(5829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_ASSET_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_ASSET_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 342+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(343) : doc_func.sql(5974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_ASSET_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 366+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(367) : doc_func.sql(5998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 372+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(373) : doc_func.sql(6004) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 376+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(377) : doc_func.sql(6008) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_AST_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINv IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_VDR_DOC(36) : doc_func.sql(6052) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(50) : doc_func.sql(6066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(57) : doc_func.sql(6073) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(64) : doc_func.sql(6080) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINv;
   
   FETCH CKINv INTO h_min_revision;
   IF CKINv%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINv ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(93) : doc_func.sql(6109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(115) : doc_func.sql(6131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINv ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(128) : doc_func.sql(6144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(153) : doc_func.sql(6169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(176) : doc_func.sql(6192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(198) : doc_func.sql(6214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_VENDOR_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_VENDOR_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 342+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(343) : doc_func.sql(6359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_VENDOR_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 366+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(367) : doc_func.sql(6383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 372+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(373) : doc_func.sql(6389) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 376+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(377) : doc_func.sql(6393) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_VDR_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINc IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_CLN_DOC(36) : doc_func.sql(6437) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(50) : doc_func.sql(6451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(57) : doc_func.sql(6458) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(64) : doc_func.sql(6465) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINc;
   
   FETCH CKINc INTO h_min_revision;
   IF CKINc%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         CLOSE CKINc ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(93) : doc_func.sql(6494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(115) : doc_func.sql(6516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINc ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(128) : doc_func.sql(6529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(153) : doc_func.sql(6554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(176) : doc_func.sql(6577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(198) : doc_func.sql(6599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_CLIENT_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_CLIENT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 342+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(343) : doc_func.sql(6744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_CLIENT_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 366+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(367) : doc_func.sql(6768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 372+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(373) : doc_func.sql(6774) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 376+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(377) : doc_func.sql(6778) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_CLN_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_DOC(21) : doc_func.sql(6807) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(34) : doc_func.sql(6820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(42) : doc_func.sql(6828) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(48) : doc_func.sql(6834) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(63) : doc_func.sql(6849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(71) : doc_func.sql(6857) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(90) : doc_func.sql(6876) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(96) : doc_func.sql(6882) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(100) : doc_func.sql(6886) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_DOC;
ALTER FUNCTION FC_A_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_RES_DOC(21) : doc_func.sql(6915) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(34) : doc_func.sql(6928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(42) : doc_func.sql(6936) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(48) : doc_func.sql(6942) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(63) : doc_func.sql(6957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(71) : doc_func.sql(6965) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_RESOURCE_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(90) : doc_func.sql(6984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(96) : doc_func.sql(6990) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(100) : doc_func.sql(6994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_RES_DOC;
ALTER FUNCTION FC_A_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_POL_DOC(21) : doc_func.sql(7023) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(34) : doc_func.sql(7036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(42) : doc_func.sql(7044) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(48) : doc_func.sql(7050) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(63) : doc_func.sql(7065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(71) : doc_func.sql(7073) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_POOL_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(90) : doc_func.sql(7092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(96) : doc_func.sql(7098) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(100) : doc_func.sql(7102) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_POL_DOC;
ALTER FUNCTION FC_A_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_AST_DOC(21) : doc_func.sql(7131) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(34) : doc_func.sql(7144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(42) : doc_func.sql(7152) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(48) : doc_func.sql(7158) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(63) : doc_func.sql(7173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(71) : doc_func.sql(7181) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_ASSET_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(90) : doc_func.sql(7200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(96) : doc_func.sql(7206) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(100) : doc_func.sql(7210) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_AST_DOC;
ALTER FUNCTION FC_A_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_VDR_DOC(21) : doc_func.sql(7239) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(34) : doc_func.sql(7252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(42) : doc_func.sql(7260) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(48) : doc_func.sql(7266) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(63) : doc_func.sql(7281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(71) : doc_func.sql(7289) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_VENDOR_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(90) : doc_func.sql(7308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(96) : doc_func.sql(7314) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(100) : doc_func.sql(7318) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_VDR_DOC;
ALTER FUNCTION FC_A_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_CLN_DOC(21) : doc_func.sql(7347) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(34) : doc_func.sql(7360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(42) : doc_func.sql(7368) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(48) : doc_func.sql(7374) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(63) : doc_func.sql(7389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(71) : doc_func.sql(7397) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_CLIENT_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(90) : doc_func.sql(7416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(96) : doc_func.sql(7422) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(100) : doc_func.sql(7426) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_CLN_DOC;
ALTER FUNCTION FC_A_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_DOC(27) : doc_func.sql(7461) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(49) : doc_func.sql(7483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(64) : doc_func.sql(7498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(84) : doc_func.sql(7518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            REF_NUMBER = h_ref_number,
            AUTHOR_CHECKOUT = h_author_checkout,
            PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE BLOB_ID = h_BLOB_ID AND LINK_DOC = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 106+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(107) : doc_func.sql(7541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_DOC(116) : doc_func.sql(7550) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 119+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_DOC(120) : doc_func.sql(7554) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_DOC;
ALTER FUNCTION FC_U_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_RES_DOC(27) : doc_func.sql(7589) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(49) : doc_func.sql(7611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(64) : doc_func.sql(7626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(84) : doc_func.sql(7646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_RES_DOC(93) : doc_func.sql(7655) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_RES_DOC(97) : doc_func.sql(7659) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_RES_DOC;
ALTER FUNCTION FC_U_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_POL_DOC(27) : doc_func.sql(7694) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(49) : doc_func.sql(7716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(64) : doc_func.sql(7731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(84) : doc_func.sql(7751) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_POL_DOC(93) : doc_func.sql(7760) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_POL_DOC(97) : doc_func.sql(7764) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_POL_DOC;
ALTER FUNCTION FC_U_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_AST_DOC(27) : doc_func.sql(7799) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(49) : doc_func.sql(7821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(64) : doc_func.sql(7836) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(84) : doc_func.sql(7856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_AST_DOC(93) : doc_func.sql(7865) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_AST_DOC(97) : doc_func.sql(7869) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_AST_DOC;
ALTER FUNCTION FC_U_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_VDR_DOC(27) : doc_func.sql(7904) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(49) : doc_func.sql(7926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(64) : doc_func.sql(7941) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(84) : doc_func.sql(7961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_VDR_DOC(93) : doc_func.sql(7970) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_VDR_DOC(97) : doc_func.sql(7974) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_VDR_DOC;
ALTER FUNCTION FC_U_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_CLN_DOC(27) : doc_func.sql(8009) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(49) : doc_func.sql(8031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(64) : doc_func.sql(8046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(84) : doc_func.sql(8066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_CLN_DOC(93) : doc_func.sql(8075) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_CLN_DOC(97) : doc_func.sql(8079) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_CLN_DOC;
ALTER FUNCTION FC_U_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_DOC(23) : doc_func.sql(8110) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_DOC(27) : doc_func.sql(8114) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_DOC(48) : doc_func.sql(8135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(56) : doc_func.sql(8143) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_DOC(75) : doc_func.sql(8162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(80) : doc_func.sql(8167) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(84) : doc_func.sql(8171) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_RES_DOC(23) : doc_func.sql(8202) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_RES_DOC(27) : doc_func.sql(8206) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_RESOURCE_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_RESOURCE_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_RES_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_RES_DOC(48) : doc_func.sql(8227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(56) : doc_func.sql(8235) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_RES_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_RES_DOC(75) : doc_func.sql(8254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(80) : doc_func.sql(8259) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(84) : doc_func.sql(8263) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_RES_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_POL_DOC(23) : doc_func.sql(8294) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_POL_DOC(27) : doc_func.sql(8298) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOL_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_POOL_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_POL_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_POL_DOC(48) : doc_func.sql(8319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(56) : doc_func.sql(8327) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_POL_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_POL_DOC(75) : doc_func.sql(8346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(80) : doc_func.sql(8351) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(84) : doc_func.sql(8355) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_POL_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_AST_DOC(23) : doc_func.sql(8386) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_AST_DOC(27) : doc_func.sql(8390) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSET_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSET_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST_DOC(48) : doc_func.sql(8411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(56) : doc_func.sql(8419) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST_DOC(75) : doc_func.sql(8438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(80) : doc_func.sql(8443) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(84) : doc_func.sql(8447) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_AST_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_VDR_DOC(23) : doc_func.sql(8478) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_VDR_DOC(27) : doc_func.sql(8482) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDOR_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDOR_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_VDR_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_VDR_DOC(48) : doc_func.sql(8503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(56) : doc_func.sql(8511) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_VDR_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_VDR_DOC(75) : doc_func.sql(8530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(80) : doc_func.sql(8535) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(84) : doc_func.sql(8539) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_VDR_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_CLN_DOC(23) : doc_func.sql(8570) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_CLN_DOC(27) : doc_func.sql(8574) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN_DOC(48) : doc_func.sql(8595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(56) : doc_func.sql(8603) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN_DOC(75) : doc_func.sql(8622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(80) : doc_func.sql(8627) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(84) : doc_func.sql(8631) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_CLN_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_DOC(25) : doc_func.sql(8664) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_DOC(29) : doc_func.sql(8668) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_DOC(50) : doc_func.sql(8689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(58) : doc_func.sql(8697) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_DOC(78) : doc_func.sql(8717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(83) : doc_func.sql(8722) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(87) : doc_func.sql(8726) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_DOC;
ALTER FUNCTION FC_U_PRIVATE_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_RES_DOC(25) : doc_func.sql(8759) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_RES_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_RES_DOC(29) : doc_func.sql(8763) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_RESOURCE_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_RESOURCE_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_RES_DOC(50) : doc_func.sql(8784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(58) : doc_func.sql(8792) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_RES_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_RES_DOC(78) : doc_func.sql(8812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(83) : doc_func.sql(8817) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(87) : doc_func.sql(8821) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_RES_DOC;
ALTER FUNCTION FC_U_PRIVATE_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_POL_DOC(25) : doc_func.sql(8854) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_POL_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_POL_DOC(29) : doc_func.sql(8858) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOL_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_POOL_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_POL_DOC(50) : doc_func.sql(8879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(58) : doc_func.sql(8887) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_POL_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_POL_DOC(78) : doc_func.sql(8907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(83) : doc_func.sql(8912) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(87) : doc_func.sql(8916) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_POL_DOC;
ALTER FUNCTION FC_U_PRIVATE_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_AST_DOC(25) : doc_func.sql(8949) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_AST_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_AST_DOC(29) : doc_func.sql(8953) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSET_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSET_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_AST_DOC(50) : doc_func.sql(8974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(58) : doc_func.sql(8982) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_AST_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_AST_DOC(78) : doc_func.sql(9002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(83) : doc_func.sql(9007) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(87) : doc_func.sql(9011) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_AST_DOC;
ALTER FUNCTION FC_U_PRIVATE_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_VDR_DOC(25) : doc_func.sql(9044) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_VDR_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_VDR_DOC(29) : doc_func.sql(9048) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDOR_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDOR_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_VDR_DOC(50) : doc_func.sql(9069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(58) : doc_func.sql(9077) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_VDR_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_VDR_DOC(78) : doc_func.sql(9097) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(83) : doc_func.sql(9102) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(87) : doc_func.sql(9106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_VDR_DOC;
ALTER FUNCTION FC_U_PRIVATE_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_CLN_DOC(25) : doc_func.sql(9139) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_CLN_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_CLN_DOC(29) : doc_func.sql(9143) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CLN_DOC(50) : doc_func.sql(9164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(58) : doc_func.sql(9172) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CLN_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CLN_DOC(78) : doc_func.sql(9192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(83) : doc_func.sql(9197) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(87) : doc_func.sql(9201) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_CLN_DOC;
ALTER FUNCTION FC_U_PRIVATE_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_DOC(27) : doc_func.sql(9236) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_DOC(47) : doc_func.sql(9256) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(54) : doc_func.sql(9263) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(60) : doc_func.sql(9269) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(64) : doc_func.sql(9273) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_RES_DOC(27) : doc_func.sql(9308) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_RES_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_RES_DOC(47) : doc_func.sql(9328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(54) : doc_func.sql(9335) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(60) : doc_func.sql(9341) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(64) : doc_func.sql(9345) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_RES_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_POL_DOC(27) : doc_func.sql(9380) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_POL_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_POL_DOC(47) : doc_func.sql(9400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(54) : doc_func.sql(9407) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(60) : doc_func.sql(9413) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(64) : doc_func.sql(9417) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_POL_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_AST_DOC(27) : doc_func.sql(9452) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_AST_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_AST_DOC(47) : doc_func.sql(9472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(54) : doc_func.sql(9479) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(60) : doc_func.sql(9485) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(64) : doc_func.sql(9489) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_AST_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_VDR_DOC(27) : doc_func.sql(9524) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_VDR_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_VDR_DOC(47) : doc_func.sql(9544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(54) : doc_func.sql(9551) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(60) : doc_func.sql(9557) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(64) : doc_func.sql(9561) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_CLN_DOC(27) : doc_func.sql(9596) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_CLN_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_CLN_DOC(47) : doc_func.sql(9616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(54) : doc_func.sql(9623) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(60) : doc_func.sql(9629) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(64) : doc_func.sql(9633) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_blob_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_DOC(37) : doc_func.sql(9678) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS, BLOB_ID, LINK_DOC
      INTO h_rec_status, h_blob_id, h_link_doc
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(52) : doc_func.sql(9693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(60) : doc_func.sql(9701) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(85) : doc_func.sql(9726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(92) : doc_func.sql(9733) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   ElsIf ((h_blob_id IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_link_doc, 'P', 1) = 0) Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET (REVISION_IMPACT,REVISION_TYPE,REVISION_HISTORY,STAGE_ID,REC_DATETIME,REC_USER) =
         (SELECT REVISION_IMPACT,REVISION_TYPE,REVISION_HISTORY,STAGE_ID,REC_DATETIME,REC_USER
         FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_id)
         WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(111) : doc_func.sql(9752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(118) : doc_func.sql(9759) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 121+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(122) : doc_func.sql(9763) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_DOC;
ALTER FUNCTION FC_U_REVISION_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_RES_DOC(35) : doc_func.sql(9806) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_RES_DOC(49) : doc_func.sql(9820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(57) : doc_func.sql(9828) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_RES_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_RES_DOC(82) : doc_func.sql(9853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(89) : doc_func.sql(9860) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(94) : doc_func.sql(9865) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(98) : doc_func.sql(9869) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_RES_DOC;
ALTER FUNCTION FC_U_REVISION_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_POL_DOC(35) : doc_func.sql(9912) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_POL_DOC(49) : doc_func.sql(9926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(57) : doc_func.sql(9934) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_POL_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_POL_DOC(82) : doc_func.sql(9959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(89) : doc_func.sql(9966) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(94) : doc_func.sql(9971) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(98) : doc_func.sql(9975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_POL_DOC;
ALTER FUNCTION FC_U_REVISION_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_AST_DOC(35) : doc_func.sql(10018) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_AST_DOC(49) : doc_func.sql(10032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(57) : doc_func.sql(10040) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_AST_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_AST_DOC(82) : doc_func.sql(10065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(89) : doc_func.sql(10072) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(94) : doc_func.sql(10077) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(98) : doc_func.sql(10081) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_AST_DOC;
ALTER FUNCTION FC_U_REVISION_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_VDR_DOC(35) : doc_func.sql(10124) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_VDR_DOC(49) : doc_func.sql(10138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(57) : doc_func.sql(10146) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_VDR_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_VDR_DOC(82) : doc_func.sql(10171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(89) : doc_func.sql(10178) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(94) : doc_func.sql(10183) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(98) : doc_func.sql(10187) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_VDR_DOC;
ALTER FUNCTION FC_U_REVISION_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_CLN_DOC(35) : doc_func.sql(10230) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_CLN_DOC(49) : doc_func.sql(10244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(57) : doc_func.sql(10252) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_CLN_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_CLN_DOC(82) : doc_func.sql(10277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(89) : doc_func.sql(10284) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(94) : doc_func.sql(10289) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(98) : doc_func.sql(10293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_CLN_DOC;
ALTER FUNCTION FC_U_REVISION_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_DOC IS
         SELECT a.ELEMENT_ID FROM TMT_DOCUMENTS a, TMT_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_DOC IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID = h_current_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_DOC(37) : doc_func.sql(10338) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_DOC;
   
   LOOP
      FETCH CKALL1_DOC INTO h_current_id;
      IF CKALL1_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_DOC;
      
      FETCH CKALL2_DOC INTO h_min_revision;
      IF CKALL2_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_DOC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(77) : doc_func.sql(10378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(99) : doc_func.sql(10400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_DOC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(112) : doc_func.sql(10413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(137) : doc_func.sql(10438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(161) : doc_func.sql(10462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(183) : doc_func.sql(10484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(298) : doc_func.sql(10599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(316) : doc_func.sql(10617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(331) : doc_func.sql(10632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_DOC(337) : doc_func.sql(10638) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_DOC(341) : doc_func.sql(10642) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_RES IS
         SELECT a.ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS a, TMT_RESOURCE_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_RES IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_current_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_RES_DOC(37) : doc_func.sql(10687) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_RES;
   
   LOOP
      FETCH CKALL1_RES INTO h_current_id;
      IF CKALL1_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_RES;
      
      FETCH CKALL2_RES INTO h_min_revision;
      IF CKALL2_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(77) : doc_func.sql(10727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(99) : doc_func.sql(10749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(112) : doc_func.sql(10762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(137) : doc_func.sql(10787) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(161) : doc_func.sql(10811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(183) : doc_func.sql(10833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_RESOURCE_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(298) : doc_func.sql(10948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(316) : doc_func.sql(10966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_RES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(331) : doc_func.sql(10981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_RES_DOC(337) : doc_func.sql(10987) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_RES_DOC(341) : doc_func.sql(10991) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_RES_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_POL IS
         SELECT a.ELEMENT_ID FROM TMT_POOL_DOCUMENTS a, TMT_POOL_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_POL IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_current_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_POL_DOC(37) : doc_func.sql(11036) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_POL;
   
   LOOP
      FETCH CKALL1_POL INTO h_current_id;
      IF CKALL1_POL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_POL;
      
      FETCH CKALL2_POL INTO h_min_revision;
      IF CKALL2_POL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_POL ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(77) : doc_func.sql(11076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(99) : doc_func.sql(11098) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_POL ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(112) : doc_func.sql(11111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(137) : doc_func.sql(11136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(161) : doc_func.sql(11160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(183) : doc_func.sql(11182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_POOL_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_POOL_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(298) : doc_func.sql(11297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(316) : doc_func.sql(11315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_POL ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(331) : doc_func.sql(11330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_POL_DOC(337) : doc_func.sql(11336) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_POL_DOC(341) : doc_func.sql(11340) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_POL_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_AST IS
         SELECT a.ELEMENT_ID FROM TMT_ASSET_DOCUMENTS a, TMT_ASSET_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_AST IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_current_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_AST_DOC(37) : doc_func.sql(11385) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_AST;
   
   LOOP
      FETCH CKALL1_AST INTO h_current_id;
      IF CKALL1_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_AST;
      
      FETCH CKALL2_AST INTO h_min_revision;
      IF CKALL2_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_AST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(77) : doc_func.sql(11425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(99) : doc_func.sql(11447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_AST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(112) : doc_func.sql(11460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(137) : doc_func.sql(11485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(161) : doc_func.sql(11509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(183) : doc_func.sql(11531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_ASSET_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_ASSET_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(298) : doc_func.sql(11646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(316) : doc_func.sql(11664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_AST ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(331) : doc_func.sql(11679) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_AST_DOC(337) : doc_func.sql(11685) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_AST_DOC(341) : doc_func.sql(11689) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_AST_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_VDR IS
         SELECT a.ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS a, TMT_VENDOR_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_VDR IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_current_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_VDR_DOC(37) : doc_func.sql(11734) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_VDR;
   
   LOOP
      FETCH CKALL1_VDR INTO h_current_id;
      IF CKALL1_VDR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_VDR;
      
      FETCH CKALL2_VDR INTO h_min_revision;
      IF CKALL2_VDR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_VDR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(77) : doc_func.sql(11774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(99) : doc_func.sql(11796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_VDR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(112) : doc_func.sql(11809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(137) : doc_func.sql(11834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(161) : doc_func.sql(11858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(183) : doc_func.sql(11880) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_VENDOR_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_VENDOR_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(298) : doc_func.sql(11995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(316) : doc_func.sql(12013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_VDR ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(331) : doc_func.sql(12028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_VDR_DOC(337) : doc_func.sql(12034) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_VDR_DOC(341) : doc_func.sql(12038) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_VDR_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_CLN IS
         SELECT a.ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS a, TMT_CLIENT_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_CLN IS
         SELECT * FROM (SELECT MINOR_REVISION
         FROM HISTORY_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_current_id
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_CLN_DOC(37) : doc_func.sql(12083) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_CLN;
   
   LOOP
      FETCH CKALL1_CLN INTO h_current_id;
      IF CKALL1_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      OPEN CKALL2_CLN;
      
      FETCH CKALL2_CLN INTO h_min_revision;
      IF CKALL2_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            CLOSE CKALL2_CLN ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(77) : doc_func.sql(12123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(99) : doc_func.sql(12145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_CLN ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(112) : doc_func.sql(12158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(137) : doc_func.sql(12183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(161) : doc_func.sql(12207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(183) : doc_func.sql(12229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_CLIENT_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_CLIENT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(298) : doc_func.sql(12344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(316) : doc_func.sql(12362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 330+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(331) : doc_func.sql(12377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_CLN_DOC(337) : doc_func.sql(12383) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_CLN_DOC(341) : doc_func.sql(12387) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_CLN_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_DOC(24) : doc_func.sql(12419) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_DOC(40) : doc_func.sql(12435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(48) : doc_func.sql(12443) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_DOC(74) : doc_func.sql(12469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(80) : doc_func.sql(12475) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(84) : doc_func.sql(12479) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_DOC;
ALTER FUNCTION FC_UNDO_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_RES_DOC(24) : doc_func.sql(12511) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_RES_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_RES_DOC(40) : doc_func.sql(12527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(48) : doc_func.sql(12535) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_RES_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_RES_DOC(74) : doc_func.sql(12561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(80) : doc_func.sql(12567) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(84) : doc_func.sql(12571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_RES_DOC;
ALTER FUNCTION FC_UNDO_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_POL_DOC(24) : doc_func.sql(12603) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_POL_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_POL_DOC(40) : doc_func.sql(12619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(48) : doc_func.sql(12627) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_POL_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_POL_DOC(74) : doc_func.sql(12653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(80) : doc_func.sql(12659) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(84) : doc_func.sql(12663) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_POL_DOC;
ALTER FUNCTION FC_UNDO_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_AST_DOC(24) : doc_func.sql(12695) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_AST_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_AST_DOC(40) : doc_func.sql(12711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(48) : doc_func.sql(12719) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_AST_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_AST_DOC(74) : doc_func.sql(12745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(80) : doc_func.sql(12751) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(84) : doc_func.sql(12755) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_AST_DOC;
ALTER FUNCTION FC_UNDO_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_VDR_DOC(24) : doc_func.sql(12787) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_VDR_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_VDR_DOC(40) : doc_func.sql(12803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(48) : doc_func.sql(12811) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_VDR_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_VDR_DOC(74) : doc_func.sql(12837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(80) : doc_func.sql(12843) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(84) : doc_func.sql(12847) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_VDR_DOC;
ALTER FUNCTION FC_UNDO_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_CLN_DOC(24) : doc_func.sql(12879) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_CLN_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_CLN_DOC(40) : doc_func.sql(12895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(48) : doc_func.sql(12903) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_CLN_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_CLN_DOC(74) : doc_func.sql(12929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(80) : doc_func.sql(12935) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(84) : doc_func.sql(12939) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_CLN_DOC;
ALTER FUNCTION FC_UNDO_DOC_CLN_DOC COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_D_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_published VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
   h_link_doc VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DEL_BLOB IS
         SELECT BLOB_ID, LINK_DOC
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC IN ('Y', 'P');

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 62+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_DOC(63) : doc_func.sql(13012) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(70) : doc_func.sql(13019) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS, TYPE_ID
      INTO h_doc_rec_status, h_parent_type_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(88) : doc_func.sql(13037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_doc_rec_status: %s, h_parent_id: %d %s\n",SC_STATE,h_doc_rec_status,h_parent_id_Ind,h_parent_id);
   
   If (Coalesce(h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER0) Then
      If (h_id IS NULL) Then
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE T_PARENT_ID = ''' 
               || h_parent_id || '''';
      Else
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
               || h_id || ''' AND T_PARENT_ID = ''' || h_parent_id || '''';
      End If;
   Else
      If (h_id IS NULL) Then
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE PARENT_ID = ''' 
               || h_parent_id || '''';
      Else
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
               || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
      End If;
   End If;
   
   h_xsql := h_xsql || '  ';
   --trace_printf("\n%s\n",(char *) h_xsql);
   
   OPEN DELD_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_DOC INTO h_element_id, h_rank, h_rec_status, h_t_parent_id, h_parent_type_id, h_published, h_type_id;
      IF DELD_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELAT_DOC;
      
      LOOP
         FETCH DELAT_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(175) : doc_func.sql(13124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 190+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(191) : doc_func.sql(13140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(224) : doc_func.sql(13173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If (SubStr(h_doc_rec_status, 1, 1) = 'D') OR (Coalesce(
            h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 247+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(248) : doc_func.sql(13197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --trace_printf("\n h_parent_id:%s", h_parent_id);
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 269+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(270) : doc_func.sql(13219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 288+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(289) : doc_func.sql(13238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("\n SC_STATE:%s", SC_STATE);
      End If;
      --trace_printf("SC_STATE: %d, h_rank: %s, h_parent_id: %s, h_doc_rec_status: %s\n", SC_STATE,h_rank,h_parent_id,h_doc_rec_status);
      
      If (SubStr(h_published, 1, 1) = 'Y') AND (Coalesce(
            h_parent_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_t_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(315) : doc_func.sql(13264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("SC_STATE: %d, h_t_parent_id: %s, h_parent_type_id: %d, h_published: %s\n", SC_STATE,h_t_parent_id,h_parent_type_id, h_published);
      
      COMMIT;
      
      -- delete blob_documents
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DEL_BLOB;
      
      LOOP
         FETCH DEL_BLOB INTO h_blob_id, h_link_doc;
         IF DEL_BLOB%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_count := 0;
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE BLOB_ID = h_blob_id
            AND RANK NOT LIKE h_rank || '%';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 376+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(377) : doc_func.sql(13326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("DEL_BLOB: SC_STATE: %d, h_blob_id: %s, h_count: %d\n", SC_STATE,h_blob_id,h_count);
         
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               DELETE FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 395+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(396) : doc_func.sql(13345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_DOCUMENTS WHERE BLOB_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 412+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(413) : doc_func.sql(13362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf (Coalesce(h_count, 0) = 1) AND (PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0) Then
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET LINK_DOC = 'N'
               WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'P';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 431+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(432) : doc_func.sql(13381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE DEL_BLOB ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 446+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(447) : doc_func.sql(13396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 480+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(481) : doc_func.sql(13430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 514+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(515) : doc_func.sql(13464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 548+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(549) : doc_func.sql(13498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_table_type := PMO_CNST.SC_TABLE_DOC;
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_DECREASE_WBS_CHILD_COUNT(Coalesce(h_table_type, 0), h_rank);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
      
      h_table_type := PMO_CNST.SC_TABLE_DOC;
      ora_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_DELETE_ATTACHED_WKF(h_table_type, h_element_id, h_rank, h_rec_user);
      PMO_DB2M.SC_STATE := ora_temp_sc_state;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 588+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(589) : doc_func.sql(13538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 604+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(605) : doc_func.sql(13554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 622+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(623) : doc_func.sql(13572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 629+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(630) : doc_func.sql(13579) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 633+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(634) : doc_func.sql(13583) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_DOC;
ALTER FUNCTION FC_D_DOC_DOC COMPILE DEBUG;

/******************************************************************************************/

Prompt == FUNCTION FC_D_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_RES_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_RES_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_RES_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_RES_DOC(55) : doc_func.sql(13648) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(62) : doc_func.sql(13655) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(80) : doc_func.sql(13673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_RESOURCE_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_RES_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_RES_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELAT_RES_DOC;
      
      LOOP
         FETCH DELAT_RES_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(152) : doc_func.sql(13745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 167+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(168) : doc_func.sql(13761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 198+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(199) : doc_func.sql(13792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 221+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(222) : doc_func.sql(13815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 240+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(241) : doc_func.sql(13834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(275) : doc_func.sql(13868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(308) : doc_func.sql(13901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELW_RES_DOC;
      
      LOOP
         FETCH DELW_RES_DOC INTO h_cur_rank;
         IF DELW_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(370) : doc_func.sql(13963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 402+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(403) : doc_func.sql(13996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 417+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(418) : doc_func.sql(14011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 448+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(449) : doc_func.sql(14042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 478+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(479) : doc_func.sql(14072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 494+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(495) : doc_func.sql(14088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 512+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(513) : doc_func.sql(14106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 519+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(520) : doc_func.sql(14113) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 523+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(524) : doc_func.sql(14117) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_RES_DOC;
ALTER FUNCTION FC_D_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_POL_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_POL_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_POL_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_POL_DOC(55) : doc_func.sql(14180) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(62) : doc_func.sql(14187) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(80) : doc_func.sql(14205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_POOL_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_POL_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_POL_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELAT_POL_DOC;
      
      LOOP
         FETCH DELAT_POL_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(150) : doc_func.sql(14275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(166) : doc_func.sql(14291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(197) : doc_func.sql(14322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 219+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(220) : doc_func.sql(14345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 238+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(239) : doc_func.sql(14364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(275) : doc_func.sql(14400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_POOL_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(308) : doc_func.sql(14433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELW_POL_DOC;
      
      LOOP
         FETCH DELW_POL_DOC INTO h_cur_rank;
         IF DELW_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(370) : doc_func.sql(14495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 402+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(403) : doc_func.sql(14528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 417+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(418) : doc_func.sql(14543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 449+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(450) : doc_func.sql(14575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(480) : doc_func.sql(14605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 495+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(496) : doc_func.sql(14621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 513+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(514) : doc_func.sql(14639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 520+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(521) : doc_func.sql(14646) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 524+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(525) : doc_func.sql(14650) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_POL_DOC;
ALTER FUNCTION FC_D_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_AST_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_AST_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_AST_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_AST_DOC(55) : doc_func.sql(14713) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(62) : doc_func.sql(14720) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(80) : doc_func.sql(14738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_ASSET_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_AST_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_AST_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELAT_AST_DOC;
      
      LOOP
         FETCH DELAT_AST_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(150) : doc_func.sql(14808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(166) : doc_func.sql(14824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(197) : doc_func.sql(14855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 219+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(220) : doc_func.sql(14878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 238+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(239) : doc_func.sql(14897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(275) : doc_func.sql(14933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_ASSET_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(308) : doc_func.sql(14966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELW_AST_DOC;
      
      LOOP
         FETCH DELW_AST_DOC INTO h_cur_rank;
         IF DELW_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(370) : doc_func.sql(15028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 402+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(403) : doc_func.sql(15061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 417+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(418) : doc_func.sql(15076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 449+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(450) : doc_func.sql(15108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(480) : doc_func.sql(15138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 495+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(496) : doc_func.sql(15154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 513+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(514) : doc_func.sql(15172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 520+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(521) : doc_func.sql(15179) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 524+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(525) : doc_func.sql(15183) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_AST_DOC;
ALTER FUNCTION FC_D_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_VDR_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_VDR_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_VDR_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_VDR_DOC(55) : doc_func.sql(15246) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(62) : doc_func.sql(15253) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(80) : doc_func.sql(15271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_VENDOR_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_VDR_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_VDR_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELAT_VDR_DOC;
      
      LOOP
         FETCH DELAT_VDR_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(150) : doc_func.sql(15341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(166) : doc_func.sql(15357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(197) : doc_func.sql(15388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 219+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(220) : doc_func.sql(15411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 238+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(239) : doc_func.sql(15430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(275) : doc_func.sql(15466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(308) : doc_func.sql(15499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELW_VDR_DOC;
      
      LOOP
         FETCH DELW_VDR_DOC INTO h_cur_rank;
         IF DELW_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(370) : doc_func.sql(15561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 402+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(403) : doc_func.sql(15594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 417+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(418) : doc_func.sql(15609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 449+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(450) : doc_func.sql(15641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(480) : doc_func.sql(15671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 495+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(496) : doc_func.sql(15687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 513+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(514) : doc_func.sql(15705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 520+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(521) : doc_func.sql(15712) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 524+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(525) : doc_func.sql(15716) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_VDR_DOC;
ALTER FUNCTION FC_D_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_CLN_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_CLN_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_CLN_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_CLN_DOC(55) : doc_func.sql(15779) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(62) : doc_func.sql(15786) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(80) : doc_func.sql(15804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_CLIENT_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := h_xsql || '  ';
   
   OPEN DELD_CLN_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_CLN_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELAT_CLN_DOC;
      
      LOOP
         FETCH DELAT_CLN_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(150) : doc_func.sql(15874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(166) : doc_func.sql(15890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(197) : doc_func.sql(15921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 219+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(220) : doc_func.sql(15944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 238+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(239) : doc_func.sql(15963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(275) : doc_func.sql(15999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(308) : doc_func.sql(16032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN DELW_CLN_DOC;
      
      LOOP
         FETCH DELW_CLN_DOC INTO h_cur_rank;
         IF DELW_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(370) : doc_func.sql(16094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 402+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(403) : doc_func.sql(16127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 417+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(418) : doc_func.sql(16142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 449+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(450) : doc_func.sql(16174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(480) : doc_func.sql(16204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 495+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(496) : doc_func.sql(16220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 513+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(514) : doc_func.sql(16238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 520+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(521) : doc_func.sql(16245) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 524+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(525) : doc_func.sql(16249) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_CLN_DOC;
ALTER FUNCTION FC_D_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_DOC(27) : doc_func.sql(16284) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_DOC(41) : doc_func.sql(16298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(49) : doc_func.sql(16306) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_DOC(71) : doc_func.sql(16328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(79) : doc_func.sql(16336) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(84) : doc_func.sql(16341) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(88) : doc_func.sql(16345) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_RES_DOC(27) : doc_func.sql(16380) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_RES_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_RES_DOC(41) : doc_func.sql(16394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(49) : doc_func.sql(16402) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_RES_DOC(71) : doc_func.sql(16424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(79) : doc_func.sql(16432) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(84) : doc_func.sql(16437) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(88) : doc_func.sql(16441) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_RES_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_POL_DOC(27) : doc_func.sql(16476) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_POL_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_POL_DOC(41) : doc_func.sql(16490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(49) : doc_func.sql(16498) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_POL_DOC(71) : doc_func.sql(16520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(79) : doc_func.sql(16528) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(84) : doc_func.sql(16533) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(88) : doc_func.sql(16537) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_POL_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_AST_DOC(27) : doc_func.sql(16572) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_AST_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_AST_DOC(41) : doc_func.sql(16586) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(49) : doc_func.sql(16594) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_AST_DOC(71) : doc_func.sql(16616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(79) : doc_func.sql(16624) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(84) : doc_func.sql(16629) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(88) : doc_func.sql(16633) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_AST_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_VDR_DOC(27) : doc_func.sql(16668) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_VDR_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_VDR_DOC(41) : doc_func.sql(16682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(49) : doc_func.sql(16690) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_VDR_DOC(71) : doc_func.sql(16712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(79) : doc_func.sql(16720) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(84) : doc_func.sql(16725) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(88) : doc_func.sql(16729) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_VDR_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_CLN_DOC(27) : doc_func.sql(16764) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_CLN_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_CLN_DOC(41) : doc_func.sql(16778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(49) : doc_func.sql(16786) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_CLN_DOC(71) : doc_func.sql(16808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(79) : doc_func.sql(16816) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(84) : doc_func.sql(16821) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(88) : doc_func.sql(16825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_CLN_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_published VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_DOC(40) : doc_func.sql(16873) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED
      INTO h_parent_id, h_rank, h_t_parent_id, h_parent_type_id, h_published
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(54) : doc_func.sql(16887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(70) : doc_func.sql(16903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(77) : doc_func.sql(16910) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(107) : doc_func.sql(16940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 113+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(114) : doc_func.sql(16947) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         INSERT INTO PMO_TMP_DEL_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(154) : doc_func.sql(16987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 185+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(186) : doc_func.sql(17019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 224+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(225) : doc_func.sql(17058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 247+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(248) : doc_func.sql(17081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 267+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(268) : doc_func.sql(17101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (SubStr(h_published, 1, 1) = 'Y') AND ((h_t_parent_id IS NOT NULL)) Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_t_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 287+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(288) : doc_func.sql(17121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN C_TMP_DEL_DOC;
      
      LOOP
         FETCH C_TMP_DEL_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(332) : doc_func.sql(17165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 354+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(355) : doc_func.sql(17188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 373+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(374) : doc_func.sql(17207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 387+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(388) : doc_func.sql(17221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 407+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(408) : doc_func.sql(17241) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 424+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(425) : doc_func.sql(17258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 431+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(432) : doc_func.sql(17265) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 435+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(436) : doc_func.sql(17269) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_RES_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_RES_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_RES_DOC(37) : doc_func.sql(17314) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(50) : doc_func.sql(17327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(66) : doc_func.sql(17343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(73) : doc_func.sql(17350) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(103) : doc_func.sql(17380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 109+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(110) : doc_func.sql(17387) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_RES_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         INSERT INTO PMO_TMP_DEL_RES_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(150) : doc_func.sql(17427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(182) : doc_func.sql(17459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(221) : doc_func.sql(17498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(244) : doc_func.sql(17521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(264) : doc_func.sql(17541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN C_TMP_DEL_RES_DOC;
      
      LOOP
         FETCH C_TMP_DEL_RES_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_RES_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(307) : doc_func.sql(17584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(330) : doc_func.sql(17607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 348+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(349) : doc_func.sql(17626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 362+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(363) : doc_func.sql(17640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 382+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(383) : doc_func.sql(17660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(400) : doc_func.sql(17677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(407) : doc_func.sql(17684) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 410+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(411) : doc_func.sql(17688) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_RES_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_POL_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_POL_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_POL_DOC(37) : doc_func.sql(17733) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(50) : doc_func.sql(17746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(66) : doc_func.sql(17762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(73) : doc_func.sql(17769) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(103) : doc_func.sql(17799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 109+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(110) : doc_func.sql(17806) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_POL_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         INSERT INTO PMO_TMP_DEL_POL_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(150) : doc_func.sql(17846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(182) : doc_func.sql(17878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(221) : doc_func.sql(17917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(244) : doc_func.sql(17940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(264) : doc_func.sql(17960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN C_TMP_DEL_POL_DOC;
      
      LOOP
         FETCH C_TMP_DEL_POL_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_POL_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(307) : doc_func.sql(18003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(330) : doc_func.sql(18026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 348+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(349) : doc_func.sql(18045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 362+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(363) : doc_func.sql(18059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 382+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(383) : doc_func.sql(18079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(400) : doc_func.sql(18096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(407) : doc_func.sql(18103) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 410+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(411) : doc_func.sql(18107) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_POL_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_AST_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_AST_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_AST_DOC(37) : doc_func.sql(18152) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(50) : doc_func.sql(18165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(66) : doc_func.sql(18181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(73) : doc_func.sql(18188) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(103) : doc_func.sql(18218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 109+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(110) : doc_func.sql(18225) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_AST_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         INSERT INTO PMO_TMP_DEL_AST_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(150) : doc_func.sql(18265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(182) : doc_func.sql(18297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(221) : doc_func.sql(18336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(244) : doc_func.sql(18359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(264) : doc_func.sql(18379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN C_TMP_DEL_AST_DOC;
      
      LOOP
         FETCH C_TMP_DEL_AST_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_AST_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(307) : doc_func.sql(18422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(330) : doc_func.sql(18445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 348+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(349) : doc_func.sql(18464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 362+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(363) : doc_func.sql(18478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 382+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(383) : doc_func.sql(18498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(400) : doc_func.sql(18515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(407) : doc_func.sql(18522) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 410+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(411) : doc_func.sql(18526) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_AST_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_VDR_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_VDR_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_VDR_DOC(37) : doc_func.sql(18571) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(50) : doc_func.sql(18584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(66) : doc_func.sql(18600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(73) : doc_func.sql(18607) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(103) : doc_func.sql(18637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 109+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(110) : doc_func.sql(18644) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_VDR_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         INSERT INTO PMO_TMP_DEL_VDR_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(150) : doc_func.sql(18684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(182) : doc_func.sql(18716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(221) : doc_func.sql(18755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(244) : doc_func.sql(18778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(264) : doc_func.sql(18798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN C_TMP_DEL_VDR_DOC;
      
      LOOP
         FETCH C_TMP_DEL_VDR_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_VDR_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(307) : doc_func.sql(18841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(330) : doc_func.sql(18864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 348+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(349) : doc_func.sql(18883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 362+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(363) : doc_func.sql(18897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 382+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(383) : doc_func.sql(18917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(400) : doc_func.sql(18934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(407) : doc_func.sql(18941) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 410+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(411) : doc_func.sql(18945) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_VDR_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_CLN_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_CLN_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_CLN_DOC(37) : doc_func.sql(18990) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(50) : doc_func.sql(19003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(66) : doc_func.sql(19019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(73) : doc_func.sql(19026) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(103) : doc_func.sql(19056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 109+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(110) : doc_func.sql(19063) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_CLN_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         INSERT INTO PMO_TMP_DEL_CLN_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(150) : doc_func.sql(19103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(182) : doc_func.sql(19135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(221) : doc_func.sql(19174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(244) : doc_func.sql(19197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(264) : doc_func.sql(19217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      OPEN C_TMP_DEL_CLN_DOC;
      
      LOOP
         FETCH C_TMP_DEL_CLN_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_CLN_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(307) : doc_func.sql(19260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 329+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(330) : doc_func.sql(19283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 348+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(349) : doc_func.sql(19302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 362+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(363) : doc_func.sql(19316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 382+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(383) : doc_func.sql(19336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(400) : doc_func.sql(19353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 406+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(407) : doc_func.sql(19360) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 410+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(411) : doc_func.sql(19364) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_CLN_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_DOC(28) : doc_func.sql(19400) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(44) : doc_func.sql(19416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(52) : doc_func.sql(19424) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(59) : doc_func.sql(19431) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(87) : doc_func.sql(19459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(94) : doc_func.sql(19466) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(128) : doc_func.sql(19500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(143) : doc_func.sql(19515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(150) : doc_func.sql(19522) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(185) : doc_func.sql(19557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(206) : doc_func.sql(19578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(214) : doc_func.sql(19586) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_DOC;
ALTER FUNCTION FC_LOCK_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_RES_DOC(28) : doc_func.sql(19622) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(44) : doc_func.sql(19638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(52) : doc_func.sql(19646) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(59) : doc_func.sql(19653) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(87) : doc_func.sql(19681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(94) : doc_func.sql(19688) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(128) : doc_func.sql(19722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(143) : doc_func.sql(19737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(150) : doc_func.sql(19744) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(185) : doc_func.sql(19779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(206) : doc_func.sql(19800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(214) : doc_func.sql(19808) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_RES_DOC;
ALTER FUNCTION FC_LOCK_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_POL_DOC(28) : doc_func.sql(19844) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(44) : doc_func.sql(19860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(52) : doc_func.sql(19868) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(59) : doc_func.sql(19875) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(87) : doc_func.sql(19903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(94) : doc_func.sql(19910) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(128) : doc_func.sql(19944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(143) : doc_func.sql(19959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(150) : doc_func.sql(19966) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(185) : doc_func.sql(20001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(206) : doc_func.sql(20022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(214) : doc_func.sql(20030) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_POL_DOC;
ALTER FUNCTION FC_LOCK_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_AST_DOC(28) : doc_func.sql(20066) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(44) : doc_func.sql(20082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(52) : doc_func.sql(20090) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(59) : doc_func.sql(20097) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(87) : doc_func.sql(20125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(94) : doc_func.sql(20132) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(128) : doc_func.sql(20166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(143) : doc_func.sql(20181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(150) : doc_func.sql(20188) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(185) : doc_func.sql(20223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(206) : doc_func.sql(20244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(214) : doc_func.sql(20252) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_AST_DOC;
ALTER FUNCTION FC_LOCK_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_VDR_DOC(28) : doc_func.sql(20288) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(44) : doc_func.sql(20304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(52) : doc_func.sql(20312) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(59) : doc_func.sql(20319) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(87) : doc_func.sql(20347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(94) : doc_func.sql(20354) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(128) : doc_func.sql(20388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(143) : doc_func.sql(20403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(150) : doc_func.sql(20410) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(185) : doc_func.sql(20445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(206) : doc_func.sql(20466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(214) : doc_func.sql(20474) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_VDR_DOC;
ALTER FUNCTION FC_LOCK_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_CLN_DOC(28) : doc_func.sql(20510) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(44) : doc_func.sql(20526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(52) : doc_func.sql(20534) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(59) : doc_func.sql(20541) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(87) : doc_func.sql(20569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(94) : doc_func.sql(20576) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(128) : doc_func.sql(20610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(143) : doc_func.sql(20625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(150) : doc_func.sql(20632) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(185) : doc_func.sql(20667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(206) : doc_func.sql(20688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 213+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(214) : doc_func.sql(20696) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_CLN_DOC;
ALTER FUNCTION FC_LOCK_CLN_DOC COMPILE DEBUG;

