-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_U_ATTACHMENT_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_DOC(24) : doc_move_func.sql(27) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_DOC(28) : doc_move_func.sql(31) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_DOC(32) : doc_move_func.sql(35) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_RES_DOC(24) : doc_move_func.sql(67) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_RES_DOC(28) : doc_move_func.sql(71) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_RES_DOC(32) : doc_move_func.sql(75) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_RES_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_POL_DOC(24) : doc_move_func.sql(107) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_POL_DOC(28) : doc_move_func.sql(111) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_POL_DOC(32) : doc_move_func.sql(115) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_POL_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_AST_DOC(24) : doc_move_func.sql(147) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_AST_DOC(28) : doc_move_func.sql(151) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_AST_DOC(32) : doc_move_func.sql(155) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_AST_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_VDR_DOC(24) : doc_move_func.sql(187) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_VDR_DOC(28) : doc_move_func.sql(191) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_VDR_DOC(32) : doc_move_func.sql(195) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_VDR_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_CLN_DOC(24) : doc_move_func.sql(227) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CLN_DOC(28) : doc_move_func.sql(231) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CLN_DOC(32) : doc_move_func.sql(235) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_CLN_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_DOC(31) : doc_move_func.sql(274) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(47) : doc_move_func.sql(290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(67) : doc_move_func.sql(310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(89) : doc_move_func.sql(332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(108) : doc_move_func.sql(351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(132) : doc_move_func.sql(375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(151) : doc_move_func.sql(394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(174) : doc_move_func.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(193) : doc_move_func.sql(436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(219) : doc_move_func.sql(462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(238) : doc_move_func.sql(481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_DOC(248) : doc_move_func.sql(491) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_DOC(252) : doc_move_func.sql(495) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_RES_DOC(31) : doc_move_func.sql(534) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(47) : doc_move_func.sql(550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(67) : doc_move_func.sql(570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(89) : doc_move_func.sql(592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(108) : doc_move_func.sql(611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(132) : doc_move_func.sql(635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(151) : doc_move_func.sql(654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(174) : doc_move_func.sql(677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(193) : doc_move_func.sql(696) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(219) : doc_move_func.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(238) : doc_move_func.sql(741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_RES_DOC(248) : doc_move_func.sql(751) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_RES_DOC(252) : doc_move_func.sql(755) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_POL_DOC(31) : doc_move_func.sql(794) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(47) : doc_move_func.sql(810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(67) : doc_move_func.sql(830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(89) : doc_move_func.sql(852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(108) : doc_move_func.sql(871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(132) : doc_move_func.sql(895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(151) : doc_move_func.sql(914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(174) : doc_move_func.sql(937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(193) : doc_move_func.sql(956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(219) : doc_move_func.sql(982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(238) : doc_move_func.sql(1001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_POL_DOC(248) : doc_move_func.sql(1011) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_POL_DOC(252) : doc_move_func.sql(1015) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_AST_DOC(31) : doc_move_func.sql(1054) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(47) : doc_move_func.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(67) : doc_move_func.sql(1090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(89) : doc_move_func.sql(1112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(108) : doc_move_func.sql(1131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(132) : doc_move_func.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(151) : doc_move_func.sql(1174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(174) : doc_move_func.sql(1197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(193) : doc_move_func.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(219) : doc_move_func.sql(1242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(238) : doc_move_func.sql(1261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_AST_DOC(248) : doc_move_func.sql(1271) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_AST_DOC(252) : doc_move_func.sql(1275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_VDR_DOC(31) : doc_move_func.sql(1314) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(47) : doc_move_func.sql(1330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(67) : doc_move_func.sql(1350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(89) : doc_move_func.sql(1372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(108) : doc_move_func.sql(1391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(132) : doc_move_func.sql(1415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(151) : doc_move_func.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(174) : doc_move_func.sql(1457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(193) : doc_move_func.sql(1476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(219) : doc_move_func.sql(1502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(238) : doc_move_func.sql(1521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_VDR_DOC(248) : doc_move_func.sql(1531) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_VDR_DOC(252) : doc_move_func.sql(1535) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_CLN_DOC(31) : doc_move_func.sql(1574) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(47) : doc_move_func.sql(1590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(67) : doc_move_func.sql(1610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(89) : doc_move_func.sql(1632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(108) : doc_move_func.sql(1651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(132) : doc_move_func.sql(1675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(151) : doc_move_func.sql(1694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(174) : doc_move_func.sql(1717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(193) : doc_move_func.sql(1736) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(219) : doc_move_func.sql(1762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(238) : doc_move_func.sql(1781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CLN_DOC(248) : doc_move_func.sql(1791) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CLN_DOC(252) : doc_move_func.sql(1795) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_DOC IS
         SELECT RANK
         FROM TMT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_DOC(36) : doc_move_func.sql(1839) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(50) : doc_move_func.sql(1853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_DOC INTO h_cur_rank;
      IF MVUP_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                         , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(104) : doc_move_func.sql(1907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(119) : doc_move_func.sql(1922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(152) : doc_move_func.sql(1955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_DOC(158) : doc_move_func.sql(1961) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_DOC(162) : doc_move_func.sql(1965) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_DOC;
ALTER FUNCTION FC_MOVE_UP_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_RES_DOC IS
         SELECT RANK
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_RES_DOC(36) : doc_move_func.sql(2009) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(50) : doc_move_func.sql(2023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_RES_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_RES_DOC INTO h_cur_rank;
      IF MVUP_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(104) : doc_move_func.sql(2077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(119) : doc_move_func.sql(2092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(152) : doc_move_func.sql(2125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_RES_DOC(158) : doc_move_func.sql(2131) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_RES_DOC(162) : doc_move_func.sql(2135) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_RES_DOC;
ALTER FUNCTION FC_MOVE_UP_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_POL_DOC IS
         SELECT RANK
         FROM TMT_POOL_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_POL_DOC(36) : doc_move_func.sql(2179) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(50) : doc_move_func.sql(2193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_POL_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_POL_DOC INTO h_cur_rank;
      IF MVUP_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(104) : doc_move_func.sql(2247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(119) : doc_move_func.sql(2262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(152) : doc_move_func.sql(2295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_POL_DOC(158) : doc_move_func.sql(2301) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_POL_DOC(162) : doc_move_func.sql(2305) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_POL_DOC;
ALTER FUNCTION FC_MOVE_UP_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_AST_DOC IS
         SELECT RANK
         FROM TMT_ASSET_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_AST_DOC(36) : doc_move_func.sql(2349) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(50) : doc_move_func.sql(2363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_AST_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_AST_DOC INTO h_cur_rank;
      IF MVUP_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(104) : doc_move_func.sql(2417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(119) : doc_move_func.sql(2432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(152) : doc_move_func.sql(2465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_AST_DOC(158) : doc_move_func.sql(2471) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_AST_DOC(162) : doc_move_func.sql(2475) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_AST_DOC;
ALTER FUNCTION FC_MOVE_UP_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_VDR_DOC IS
         SELECT RANK
         FROM TMT_VENDOR_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_VDR_DOC(36) : doc_move_func.sql(2519) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(50) : doc_move_func.sql(2533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_VDR_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_VDR_DOC INTO h_cur_rank;
      IF MVUP_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(104) : doc_move_func.sql(2587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(119) : doc_move_func.sql(2602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(152) : doc_move_func.sql(2635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_VDR_DOC(158) : doc_move_func.sql(2641) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_VDR_DOC(162) : doc_move_func.sql(2645) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_VDR_DOC;
ALTER FUNCTION FC_MOVE_UP_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CLN_DOC IS
         SELECT RANK
         FROM TMT_CLIENT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_CLN_DOC(36) : doc_move_func.sql(2689) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(50) : doc_move_func.sql(2703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CLN_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_CLN_DOC INTO h_cur_rank;
      IF MVUP_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(104) : doc_move_func.sql(2757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(119) : doc_move_func.sql(2772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(152) : doc_move_func.sql(2805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CLN_DOC(158) : doc_move_func.sql(2811) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CLN_DOC(162) : doc_move_func.sql(2815) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_CLN_DOC;
ALTER FUNCTION FC_MOVE_UP_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_DOC IS
         SELECT RANK
         FROM TMT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_DOC(36) : doc_move_func.sql(2859) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(50) : doc_move_func.sql(2873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_DOC INTO h_cur_rank;
      IF MVDOWN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(102) : doc_move_func.sql(2925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(117) : doc_move_func.sql(2940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(150) : doc_move_func.sql(2973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_DOC(156) : doc_move_func.sql(2979) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_DOC(160) : doc_move_func.sql(2983) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_DOC;
ALTER FUNCTION FC_MOVE_DOWN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_RES_DOC IS
         SELECT RANK
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_RES_DOC(36) : doc_move_func.sql(3027) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(50) : doc_move_func.sql(3041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_RES_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_RES_DOC INTO h_cur_rank;
      IF MVDOWN_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(102) : doc_move_func.sql(3093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(117) : doc_move_func.sql(3108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(150) : doc_move_func.sql(3141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_RES_DOC(156) : doc_move_func.sql(3147) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_RES_DOC(160) : doc_move_func.sql(3151) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_RES_DOC;
ALTER FUNCTION FC_MOVE_DOWN_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_POL_DOC IS
         SELECT RANK
         FROM TMT_POOL_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_POL_DOC(36) : doc_move_func.sql(3195) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(50) : doc_move_func.sql(3209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_POL_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_POL_DOC INTO h_cur_rank;
      IF MVDOWN_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(102) : doc_move_func.sql(3261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(117) : doc_move_func.sql(3276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(150) : doc_move_func.sql(3309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_POL_DOC(156) : doc_move_func.sql(3315) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_POL_DOC(160) : doc_move_func.sql(3319) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_POL_DOC;
ALTER FUNCTION FC_MOVE_DOWN_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_AST_DOC IS
         SELECT RANK
         FROM TMT_ASSET_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_AST_DOC(36) : doc_move_func.sql(3363) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(50) : doc_move_func.sql(3377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_AST_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_AST_DOC INTO h_cur_rank;
      IF MVDOWN_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(102) : doc_move_func.sql(3429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(117) : doc_move_func.sql(3444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(150) : doc_move_func.sql(3477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_AST_DOC(156) : doc_move_func.sql(3483) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_AST_DOC(160) : doc_move_func.sql(3487) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_AST_DOC;
ALTER FUNCTION FC_MOVE_DOWN_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_VDR_DOC IS
         SELECT RANK
         FROM TMT_VENDOR_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_VDR_DOC(36) : doc_move_func.sql(3531) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(50) : doc_move_func.sql(3545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_VDR_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_VDR_DOC INTO h_cur_rank;
      IF MVDOWN_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(102) : doc_move_func.sql(3597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(117) : doc_move_func.sql(3612) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(150) : doc_move_func.sql(3645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_VDR_DOC(156) : doc_move_func.sql(3651) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_VDR_DOC(160) : doc_move_func.sql(3655) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_VDR_DOC;
ALTER FUNCTION FC_MOVE_DOWN_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CLN_DOC IS
         SELECT RANK
         FROM TMT_CLIENT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_CLN_DOC(36) : doc_move_func.sql(3699) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(50) : doc_move_func.sql(3713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CLN_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_CLN_DOC INTO h_cur_rank;
      IF MVDOWN_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(102) : doc_move_func.sql(3765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(117) : doc_move_func.sql(3780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(150) : doc_move_func.sql(3813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CLN_DOC(156) : doc_move_func.sql(3819) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CLN_DOC(160) : doc_move_func.sql(3823) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_CLN_DOC;
ALTER FUNCTION FC_MOVE_DOWN_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_DOC(46) : doc_move_func.sql(3877) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(107) : doc_move_func.sql(3938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(127) : doc_move_func.sql(3958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(142) : doc_move_func.sql(3973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_source_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_source_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = CASE WHEN T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(193) : doc_move_func.sql(4024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                         , h_source_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_source_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_source_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = CASE WHEN REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(237) : doc_move_func.sql(4068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 243+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_DOC(244) : doc_move_func.sql(4075) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_DOC(248) : doc_move_func.sql(4079) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_DOC;
ALTER FUNCTION FC_MOVE_APPEND_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_RES_DOC(46) : doc_move_func.sql(4133) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(107) : doc_move_func.sql(4194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(127) : doc_move_func.sql(4214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(142) : doc_move_func.sql(4229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = CASE WHEN T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(180) : doc_move_func.sql(4267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = CASE WHEN REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(211) : doc_move_func.sql(4298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_RES_DOC(218) : doc_move_func.sql(4305) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 221+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_RES_DOC(222) : doc_move_func.sql(4309) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_RES_DOC;
ALTER FUNCTION FC_MOVE_APPEND_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_POL_DOC(46) : doc_move_func.sql(4363) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(107) : doc_move_func.sql(4424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(127) : doc_move_func.sql(4444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(142) : doc_move_func.sql(4459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(180) : doc_move_func.sql(4497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(211) : doc_move_func.sql(4528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_POL_DOC(218) : doc_move_func.sql(4535) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 221+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_POL_DOC(222) : doc_move_func.sql(4539) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_POL_DOC;
ALTER FUNCTION FC_MOVE_APPEND_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_AST_DOC(46) : doc_move_func.sql(4593) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(107) : doc_move_func.sql(4654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(127) : doc_move_func.sql(4674) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(142) : doc_move_func.sql(4689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(180) : doc_move_func.sql(4727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(211) : doc_move_func.sql(4758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_AST_DOC(218) : doc_move_func.sql(4765) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 221+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_AST_DOC(222) : doc_move_func.sql(4769) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_AST_DOC;
ALTER FUNCTION FC_MOVE_APPEND_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_VDR_DOC(46) : doc_move_func.sql(4823) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(107) : doc_move_func.sql(4884) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(127) : doc_move_func.sql(4904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(142) : doc_move_func.sql(4919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(180) : doc_move_func.sql(4957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(211) : doc_move_func.sql(4988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_VDR_DOC(218) : doc_move_func.sql(4995) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 221+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_VDR_DOC(222) : doc_move_func.sql(4999) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_VDR_DOC;
ALTER FUNCTION FC_MOVE_APPEND_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_CLN_DOC(46) : doc_move_func.sql(5053) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(107) : doc_move_func.sql(5114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(127) : doc_move_func.sql(5134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(142) : doc_move_func.sql(5149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(180) : doc_move_func.sql(5187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := h_temp_rank || h_rankBase64;
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(211) : doc_move_func.sql(5218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CLN_DOC(218) : doc_move_func.sql(5225) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 221+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CLN_DOC(222) : doc_move_func.sql(5229) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_CLN_DOC;
ALTER FUNCTION FC_MOVE_APPEND_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_source_stage_id PLS_INTEGER := 0;
   h_target_stage_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_DOC(52) : doc_move_func.sql(5289) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID, STAGE_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id,
      h_project_id, h_target_stage_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(74) : doc_move_func.sql(5311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(82) : doc_move_func.sql(5319) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(90) : doc_move_func.sql(5327) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   h_source_stage_id := 0;
   h_source_type_id := 0;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID, STAGE_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id, h_source_stage_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(113) : doc_move_func.sql(5350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 120+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(121) : doc_move_func.sql(5358) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If IsDOCSystemFolder(Coalesce(h_source_type_id, 0), Coalesce(h_source_stage_id, 0)) = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 127+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(128) : doc_move_func.sql(5365) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
   End If;
   
   If NOT ((Coalesce(h_target_type_id, 0) = PMO_CNST.SC_FOLDER) AND (Coalesce(
                  h_target_stage_id, 0) = PMO_CNST.SC_PROJECT)) Then
      If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
            , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
         If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 139+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(140) : doc_move_func.sql(5377) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
         End If;
      End If;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 149+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(150) : doc_move_func.sql(5387) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(169) : doc_move_func.sql(5406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(185) : doc_move_func.sql(5422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 202+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(203) : doc_move_func.sql(5440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(219) : doc_move_func.sql(5456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 226+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(227) : doc_move_func.sql(5464) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(243) : doc_move_func.sql(5480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 260+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(261) : doc_move_func.sql(5498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 276+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(277) : doc_move_func.sql(5514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 284+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(285) : doc_move_func.sql(5522) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 298+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(299) : doc_move_func.sql(5536) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 305+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(306) : doc_move_func.sql(5543) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 318+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(319) : doc_move_func.sql(5556) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_DOC(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_DOC(h_project_id, h_source_project_id, h_target_level
                                      , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 347+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(348) : doc_move_func.sql(5585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank
                                        , h_target_parent_id, h_source_id, h_target_type_id
                                        , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_DOC(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
         
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(376) : doc_move_func.sql(5613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 392+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(393) : doc_move_func.sql(5630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 407+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(408) : doc_move_func.sql(5645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_DOC(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank, h_target_id
                                        , h_source_id, h_target_type_id, h_rec_user, h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_DOC(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 442+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(443) : doc_move_func.sql(5680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 453+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(454) : doc_move_func.sql(5691) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 457+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(458) : doc_move_func.sql(5695) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_DOC;
ALTER FUNCTION FC_M_ATTACH_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_RES_DOC(50) : doc_move_func.sql(5753) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(71) : doc_move_func.sql(5774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(79) : doc_move_func.sql(5782) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(87) : doc_move_func.sql(5790) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(107) : doc_move_func.sql(5810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(115) : doc_move_func.sql(5818) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(124) : doc_move_func.sql(5827) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(132) : doc_move_func.sql(5835) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(151) : doc_move_func.sql(5854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(167) : doc_move_func.sql(5870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(185) : doc_move_func.sql(5888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(201) : doc_move_func.sql(5904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(209) : doc_move_func.sql(5912) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(225) : doc_move_func.sql(5928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(243) : doc_move_func.sql(5946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(259) : doc_move_func.sql(5962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(267) : doc_move_func.sql(5970) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(281) : doc_move_func.sql(5984) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(288) : doc_move_func.sql(5991) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(301) : doc_move_func.sql(6004) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(330) : doc_move_func.sql(6033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_RES_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(359) : doc_move_func.sql(6062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(376) : doc_move_func.sql(6079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(391) : doc_move_func.sql(6094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_RES_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(428) : doc_move_func.sql(6131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(439) : doc_move_func.sql(6142) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(443) : doc_move_func.sql(6146) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_RES_DOC;
ALTER FUNCTION FC_M_ATTACH_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_POL_DOC(50) : doc_move_func.sql(6204) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(71) : doc_move_func.sql(6225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(79) : doc_move_func.sql(6233) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(87) : doc_move_func.sql(6241) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(107) : doc_move_func.sql(6261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(115) : doc_move_func.sql(6269) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(124) : doc_move_func.sql(6278) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(132) : doc_move_func.sql(6286) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(151) : doc_move_func.sql(6305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(167) : doc_move_func.sql(6321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(185) : doc_move_func.sql(6339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(201) : doc_move_func.sql(6355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(209) : doc_move_func.sql(6363) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(225) : doc_move_func.sql(6379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_POOL_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(243) : doc_move_func.sql(6397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_POOL_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(259) : doc_move_func.sql(6413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(267) : doc_move_func.sql(6421) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(281) : doc_move_func.sql(6435) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(288) : doc_move_func.sql(6442) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(301) : doc_move_func.sql(6455) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(330) : doc_move_func.sql(6484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_POL_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(359) : doc_move_func.sql(6513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(376) : doc_move_func.sql(6530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(391) : doc_move_func.sql(6545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_POL_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(428) : doc_move_func.sql(6582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(439) : doc_move_func.sql(6593) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(443) : doc_move_func.sql(6597) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_POL_DOC;
ALTER FUNCTION FC_M_ATTACH_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_AST_DOC(50) : doc_move_func.sql(6655) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(71) : doc_move_func.sql(6676) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(79) : doc_move_func.sql(6684) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(87) : doc_move_func.sql(6692) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(107) : doc_move_func.sql(6712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(115) : doc_move_func.sql(6720) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(124) : doc_move_func.sql(6729) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(132) : doc_move_func.sql(6737) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(151) : doc_move_func.sql(6756) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(167) : doc_move_func.sql(6772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(185) : doc_move_func.sql(6790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(201) : doc_move_func.sql(6806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(209) : doc_move_func.sql(6814) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(225) : doc_move_func.sql(6830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_ASSET_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(243) : doc_move_func.sql(6848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_ASSET_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(259) : doc_move_func.sql(6864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(267) : doc_move_func.sql(6872) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(281) : doc_move_func.sql(6886) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(288) : doc_move_func.sql(6893) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(301) : doc_move_func.sql(6906) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(330) : doc_move_func.sql(6935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_AST_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(359) : doc_move_func.sql(6964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(376) : doc_move_func.sql(6981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(391) : doc_move_func.sql(6996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_AST_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(428) : doc_move_func.sql(7033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(439) : doc_move_func.sql(7044) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(443) : doc_move_func.sql(7048) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_AST_DOC;
ALTER FUNCTION FC_M_ATTACH_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_VDR_DOC(50) : doc_move_func.sql(7106) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(71) : doc_move_func.sql(7127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(79) : doc_move_func.sql(7135) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(87) : doc_move_func.sql(7143) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(107) : doc_move_func.sql(7163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(115) : doc_move_func.sql(7171) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(124) : doc_move_func.sql(7180) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(132) : doc_move_func.sql(7188) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(151) : doc_move_func.sql(7207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(167) : doc_move_func.sql(7223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(185) : doc_move_func.sql(7241) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(201) : doc_move_func.sql(7257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(209) : doc_move_func.sql(7265) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(225) : doc_move_func.sql(7281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_VENDOR_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(243) : doc_move_func.sql(7299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_VENDOR_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(259) : doc_move_func.sql(7315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(267) : doc_move_func.sql(7323) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(281) : doc_move_func.sql(7337) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(288) : doc_move_func.sql(7344) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(301) : doc_move_func.sql(7357) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(330) : doc_move_func.sql(7386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_VDR_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(359) : doc_move_func.sql(7415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(376) : doc_move_func.sql(7432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(391) : doc_move_func.sql(7447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_VDR_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(428) : doc_move_func.sql(7484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(439) : doc_move_func.sql(7495) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(443) : doc_move_func.sql(7499) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_VDR_DOC;
ALTER FUNCTION FC_M_ATTACH_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_CLN_DOC(50) : doc_move_func.sql(7557) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(71) : doc_move_func.sql(7578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(79) : doc_move_func.sql(7586) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(87) : doc_move_func.sql(7594) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(107) : doc_move_func.sql(7614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(115) : doc_move_func.sql(7622) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(124) : doc_move_func.sql(7631) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(132) : doc_move_func.sql(7639) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(151) : doc_move_func.sql(7658) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(167) : doc_move_func.sql(7674) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(185) : doc_move_func.sql(7692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(201) : doc_move_func.sql(7708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(209) : doc_move_func.sql(7716) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(225) : doc_move_func.sql(7732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_CLIENT_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(243) : doc_move_func.sql(7750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_CLIENT_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(259) : doc_move_func.sql(7766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(267) : doc_move_func.sql(7774) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(281) : doc_move_func.sql(7788) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(288) : doc_move_func.sql(7795) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(301) : doc_move_func.sql(7808) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(330) : doc_move_func.sql(7837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CLN_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(359) : doc_move_func.sql(7866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(376) : doc_move_func.sql(7883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(391) : doc_move_func.sql(7898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CLN_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(428) : doc_move_func.sql(7935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(439) : doc_move_func.sql(7946) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(443) : doc_move_func.sql(7950) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_CLN_DOC;
ALTER FUNCTION FC_M_ATTACH_CLN_DOC COMPILE DEBUG;

