-- already in pmo_sqlprep.h : #include "pmodefines.h"

Prompt == FUNCTION FC_I_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_WBS
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_WBS(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_WBS(27) : sc_def_func.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_WBS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_WBS (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_WBS WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(64) : sc_def_func.sql(67) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(79) : sc_def_func.sql(82) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(85) : sc_def_func.sql(88) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_WBS', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(105) : sc_def_func.sql(108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_WBS (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_WBS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(152) : sc_def_func.sql(155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(159) : sc_def_func.sql(162) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(163) : sc_def_func.sql(166) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_WBS;
ALTER FUNCTION FC_I_SC_DEF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_CRI
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_CRI(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_CRI(27) : sc_def_func.sql(201) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_CRI', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_CRI (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_CRI WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(64) : sc_def_func.sql(238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(79) : sc_def_func.sql(253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(85) : sc_def_func.sql(259) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_CRI', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(105) : sc_def_func.sql(279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_CRI (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_CRI WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(152) : sc_def_func.sql(326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(159) : sc_def_func.sql(333) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(163) : sc_def_func.sql(337) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_CRI;
ALTER FUNCTION FC_I_SC_DEF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_RES
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_RES(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_RES(27) : sc_def_func.sql(372) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_RES', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_RES (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_RES WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(64) : sc_def_func.sql(409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(79) : sc_def_func.sql(424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(85) : sc_def_func.sql(430) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_RES', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(105) : sc_def_func.sql(450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_RES (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_RES WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(152) : sc_def_func.sql(497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(159) : sc_def_func.sql(504) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(163) : sc_def_func.sql(508) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_RES;
ALTER FUNCTION FC_I_SC_DEF_RES COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_AST
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_AST(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_AST(27) : sc_def_func.sql(543) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_AST', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_AST (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_AST WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(64) : sc_def_func.sql(580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(79) : sc_def_func.sql(595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(85) : sc_def_func.sql(601) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_AST', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(105) : sc_def_func.sql(621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_AST (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_AST WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(152) : sc_def_func.sql(668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(159) : sc_def_func.sql(675) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(163) : sc_def_func.sql(679) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_AST;
ALTER FUNCTION FC_I_SC_DEF_AST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_WBS
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_WBS IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_WBS(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_WBS(38) : sc_def_func.sql(727) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(54) : sc_def_func.sql(743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(61) : sc_def_func.sql(750) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(86) : sc_def_func.sql(775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(109) : sc_def_func.sql(798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(145) : sc_def_func.sql(834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 182+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(183) : sc_def_func.sql(872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_WBS;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_WBS INTO h_description;
         IF C_ans_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(220) : sc_def_func.sql(909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 238+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(239) : sc_def_func.sql(928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 245+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(246) : sc_def_func.sql(935) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 250+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(251) : sc_def_func.sql(940) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_WBS;
ALTER FUNCTION FC_U_SC_DEF_WBS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_CRI
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_CRI IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_CRI(38) : sc_def_func.sql(988) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(54) : sc_def_func.sql(1004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(61) : sc_def_func.sql(1011) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(86) : sc_def_func.sql(1036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(109) : sc_def_func.sql(1059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(145) : sc_def_func.sql(1095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 182+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(183) : sc_def_func.sql(1133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_CRI;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_CRI INTO h_description;
         IF C_ans_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(220) : sc_def_func.sql(1170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 238+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(239) : sc_def_func.sql(1189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 245+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(246) : sc_def_func.sql(1196) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 250+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(251) : sc_def_func.sql(1201) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_CRI;
ALTER FUNCTION FC_U_SC_DEF_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_RES
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_RES IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_RES(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_RES(38) : sc_def_func.sql(1249) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(54) : sc_def_func.sql(1265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(60) : sc_def_func.sql(1271) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(85) : sc_def_func.sql(1296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 107+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(108) : sc_def_func.sql(1319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(144) : sc_def_func.sql(1355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(182) : sc_def_func.sql(1393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_RES;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_RES INTO h_description;
         IF C_ans_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 218+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(219) : sc_def_func.sql(1430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 237+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(238) : sc_def_func.sql(1449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 244+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(245) : sc_def_func.sql(1456) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 249+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(250) : sc_def_func.sql(1461) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_RES;
ALTER FUNCTION FC_U_SC_DEF_RES COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_AST
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_AST IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_AST(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_AST(38) : sc_def_func.sql(1509) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(54) : sc_def_func.sql(1525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(60) : sc_def_func.sql(1531) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(85) : sc_def_func.sql(1556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 107+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(108) : sc_def_func.sql(1579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(144) : sc_def_func.sql(1615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(182) : sc_def_func.sql(1653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_AST;
      
      WHILE PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS LOOP
         FETCH C_ans_AST INTO h_description;
         IF C_ans_AST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := h_ans_description || h_description;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_AST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 218+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(219) : sc_def_func.sql(1690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 237+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(238) : sc_def_func.sql(1709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 244+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(245) : sc_def_func.sql(1716) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 249+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(250) : sc_def_func.sql(1721) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_AST;
ALTER FUNCTION FC_U_SC_DEF_AST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_D_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DWBS IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_WBS IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_WBS(47) : sc_def_func.sql(1778) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(64) : sc_def_func.sql(1795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(70) : sc_def_func.sql(1801) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(75) : sc_def_func.sql(1806) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(93) : sc_def_func.sql(1824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(113) : sc_def_func.sql(1844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(119) : sc_def_func.sql(1850) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(133) : sc_def_func.sql(1864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(167) : sc_def_func.sql(1898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(189) : sc_def_func.sql(1920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(208) : sc_def_func.sql(1939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(229) : sc_def_func.sql(1960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(248) : sc_def_func.sql(1979) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DWBS;
         
         FETCH C_DWBS INTO h_answer_id;
         IF C_DWBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(280) : sc_def_func.sql(2011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DWBS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(294) : sc_def_func.sql(2025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(303) : sc_def_func.sql(2034) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(323) : sc_def_func.sql(2054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(342) : sc_def_func.sql(2073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(356) : sc_def_func.sql(2087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(390) : sc_def_func.sql(2121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(409) : sc_def_func.sql(2140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(427) : sc_def_func.sql(2158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_WBS;
      
      LOOP
         FETCH C_D_WBS INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(463) : sc_def_func.sql(2194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(488) : sc_def_func.sql(2219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(511) : sc_def_func.sql(2242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(536) : sc_def_func.sql(2267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(551) : sc_def_func.sql(2282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(558) : sc_def_func.sql(2289) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(562) : sc_def_func.sql(2293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_WBS;
ALTER FUNCTION FC_D_SC_DEF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DCRI IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_CRI IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_CRI(47) : sc_def_func.sql(2348) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(64) : sc_def_func.sql(2365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(70) : sc_def_func.sql(2371) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(75) : sc_def_func.sql(2376) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(93) : sc_def_func.sql(2394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(113) : sc_def_func.sql(2414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(119) : sc_def_func.sql(2420) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(133) : sc_def_func.sql(2434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(167) : sc_def_func.sql(2468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(189) : sc_def_func.sql(2490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(208) : sc_def_func.sql(2509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(229) : sc_def_func.sql(2530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(248) : sc_def_func.sql(2549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DCRI;
         
         FETCH C_DCRI INTO h_answer_id;
         IF C_DCRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(280) : sc_def_func.sql(2581) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DCRI ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(294) : sc_def_func.sql(2595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(303) : sc_def_func.sql(2604) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(323) : sc_def_func.sql(2624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(342) : sc_def_func.sql(2643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(356) : sc_def_func.sql(2657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(390) : sc_def_func.sql(2691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(409) : sc_def_func.sql(2710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(427) : sc_def_func.sql(2728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_CRI;
      
      LOOP
         FETCH C_D_CRI INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(463) : sc_def_func.sql(2764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(488) : sc_def_func.sql(2789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(511) : sc_def_func.sql(2812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(536) : sc_def_func.sql(2837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(551) : sc_def_func.sql(2852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(558) : sc_def_func.sql(2859) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(562) : sc_def_func.sql(2863) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_CRI;
ALTER FUNCTION FC_D_SC_DEF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DRES IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_RES
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_RES IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_RES(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_RES(47) : sc_def_func.sql(2918) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(64) : sc_def_func.sql(2935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(70) : sc_def_func.sql(2941) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(75) : sc_def_func.sql(2946) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(93) : sc_def_func.sql(2964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(113) : sc_def_func.sql(2984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(119) : sc_def_func.sql(2990) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(133) : sc_def_func.sql(3004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(167) : sc_def_func.sql(3038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(189) : sc_def_func.sql(3060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(208) : sc_def_func.sql(3079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(229) : sc_def_func.sql(3100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(248) : sc_def_func.sql(3119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DRES;
         
         FETCH C_DRES INTO h_answer_id;
         IF C_DRES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(280) : sc_def_func.sql(3151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DRES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(294) : sc_def_func.sql(3165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(303) : sc_def_func.sql(3174) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(323) : sc_def_func.sql(3194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(342) : sc_def_func.sql(3213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(356) : sc_def_func.sql(3227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(390) : sc_def_func.sql(3261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(409) : sc_def_func.sql(3280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(427) : sc_def_func.sql(3298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_RES;
      
      LOOP
         FETCH C_D_RES INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(463) : sc_def_func.sql(3334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_RES
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(488) : sc_def_func.sql(3359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(511) : sc_def_func.sql(3382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_RES
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(536) : sc_def_func.sql(3407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(551) : sc_def_func.sql(3422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(558) : sc_def_func.sql(3429) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(562) : sc_def_func.sql(3433) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_RES;
ALTER FUNCTION FC_D_SC_DEF_RES COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DAST IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_AST
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_AST IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_AST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_AST(47) : sc_def_func.sql(3488) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(64) : sc_def_func.sql(3505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(70) : sc_def_func.sql(3511) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(75) : sc_def_func.sql(3516) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(93) : sc_def_func.sql(3534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(113) : sc_def_func.sql(3554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(119) : sc_def_func.sql(3560) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(133) : sc_def_func.sql(3574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(167) : sc_def_func.sql(3608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(189) : sc_def_func.sql(3630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(208) : sc_def_func.sql(3649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(229) : sc_def_func.sql(3670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(248) : sc_def_func.sql(3689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DAST;
         
         FETCH C_DAST INTO h_answer_id;
         IF C_DAST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(280) : sc_def_func.sql(3721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DAST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(294) : sc_def_func.sql(3735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(303) : sc_def_func.sql(3744) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(323) : sc_def_func.sql(3764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(342) : sc_def_func.sql(3783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(356) : sc_def_func.sql(3797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(390) : sc_def_func.sql(3831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(409) : sc_def_func.sql(3850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(427) : sc_def_func.sql(3868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_AST;
      
      LOOP
         FETCH C_D_AST INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_AST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(463) : sc_def_func.sql(3904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_AST
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(488) : sc_def_func.sql(3929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(511) : sc_def_func.sql(3952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_AST
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(536) : sc_def_func.sql(3977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_AST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(551) : sc_def_func.sql(3992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(558) : sc_def_func.sql(3999) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(562) : sc_def_func.sql(4003) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_AST;
ALTER FUNCTION FC_D_SC_DEF_AST COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_WBS ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_WBS(18) : sc_def_func.sql(4029) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(32) : sc_def_func.sql(4043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(38) : sc_def_func.sql(4049) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(57) : sc_def_func.sql(4068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(79) : sc_def_func.sql(4090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(85) : sc_def_func.sql(4096) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(89) : sc_def_func.sql(4100) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_WBS;
ALTER FUNCTION FC_SET_SC_DEFAULT_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_CRI ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_CRI(18) : sc_def_func.sql(4126) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(32) : sc_def_func.sql(4140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(38) : sc_def_func.sql(4146) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(57) : sc_def_func.sql(4165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(79) : sc_def_func.sql(4187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(85) : sc_def_func.sql(4193) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(89) : sc_def_func.sql(4197) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_CRI;
ALTER FUNCTION FC_SET_SC_DEFAULT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_RES ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_RES(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_RES(18) : sc_def_func.sql(4223) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(32) : sc_def_func.sql(4237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(38) : sc_def_func.sql(4243) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(57) : sc_def_func.sql(4262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(79) : sc_def_func.sql(4284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(85) : sc_def_func.sql(4290) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(89) : sc_def_func.sql(4294) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_RES;
ALTER FUNCTION FC_SET_SC_DEFAULT_RES COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_AST ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_AST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_AST(18) : sc_def_func.sql(4320) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(32) : sc_def_func.sql(4334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(38) : sc_def_func.sql(4340) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(57) : sc_def_func.sql(4359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(79) : sc_def_func.sql(4381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(85) : sc_def_func.sql(4387) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(89) : sc_def_func.sql(4391) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_AST;
ALTER FUNCTION FC_SET_SC_DEFAULT_AST COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_WBS IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_WBS(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_WBS(30) : sc_def_func.sql(4429) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(46) : sc_def_func.sql(4445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(52) : sc_def_func.sql(4451) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(75) : sc_def_func.sql(4474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(94) : sc_def_func.sql(4493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_WBS;
   
   LOOP
      FETCH C_WBS INTO h_id, h_type_id, h_rank, h_weight;
      IF C_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(130) : sc_def_func.sql(4529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(155) : sc_def_func.sql(4554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(191) : sc_def_func.sql(4590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(216) : sc_def_func.sql(4615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_WBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(231) : sc_def_func.sql(4630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(237) : sc_def_func.sql(4636) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(241) : sc_def_func.sql(4640) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_WBS;
ALTER FUNCTION FC_U_SC_WEIGHT_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_CRI ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CRI IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_CRI(30) : sc_def_func.sql(4678) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(46) : sc_def_func.sql(4694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(52) : sc_def_func.sql(4700) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(75) : sc_def_func.sql(4723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(94) : sc_def_func.sql(4742) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_CRI;
   
   LOOP
      FETCH C_CRI INTO h_id, h_type_id, h_rank, h_weight;
      IF C_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(130) : sc_def_func.sql(4778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(155) : sc_def_func.sql(4803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(191) : sc_def_func.sql(4839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(216) : sc_def_func.sql(4864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(231) : sc_def_func.sql(4879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(237) : sc_def_func.sql(4885) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(241) : sc_def_func.sql(4889) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_CRI;
ALTER FUNCTION FC_U_SC_WEIGHT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_RES ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_RES IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_RES(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_RES(30) : sc_def_func.sql(4927) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(46) : sc_def_func.sql(4943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(52) : sc_def_func.sql(4949) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(75) : sc_def_func.sql(4972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_RES
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(94) : sc_def_func.sql(4991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_RES;
   
   LOOP
      FETCH C_RES INTO h_id, h_type_id, h_rank, h_weight;
      IF C_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(130) : sc_def_func.sql(5027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(155) : sc_def_func.sql(5052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(191) : sc_def_func.sql(5088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(216) : sc_def_func.sql(5113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_RES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(231) : sc_def_func.sql(5128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(237) : sc_def_func.sql(5134) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(241) : sc_def_func.sql(5138) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_RES;
ALTER FUNCTION FC_U_SC_WEIGHT_RES COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_AST ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_AST IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_AST(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_AST(30) : sc_def_func.sql(5176) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(46) : sc_def_func.sql(5192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(52) : sc_def_func.sql(5198) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(75) : sc_def_func.sql(5221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_AST
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(94) : sc_def_func.sql(5240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_AST;
   
   LOOP
      FETCH C_AST INTO h_id, h_type_id, h_rank, h_weight;
      IF C_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(130) : sc_def_func.sql(5276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(155) : sc_def_func.sql(5301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(191) : sc_def_func.sql(5337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(216) : sc_def_func.sql(5362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_AST ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(231) : sc_def_func.sql(5377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(237) : sc_def_func.sql(5383) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(241) : sc_def_func.sql(5387) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_AST;
ALTER FUNCTION FC_U_SC_WEIGHT_AST COMPILE DEBUG;

