/****************************************************************************************/

Prompt == FUNCTION SP_U_PBB ==
CREATE OR REPLACE FUNCTION SP_U_PBB
(
     p_project_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_chargecode_id VARCHAR2
   , p_budget_type PLS_INTEGER
   , p_month_01_amount NUMBER
   , p_month_02_amount NUMBER
   , p_month_03_amount NUMBER
   , p_month_04_amount NUMBER
   , p_month_05_amount NUMBER
   , p_month_06_amount NUMBER
   , p_month_07_amount NUMBER
   , p_month_08_amount NUMBER
   , p_month_09_amount NUMBER
   , p_month_10_amount NUMBER
   , p_month_11_amount NUMBER
   , p_month_12_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_chargecode_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_total_amount NUMBER := 0;
   h_pa_timephase VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PBB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PBB'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PBB(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_01_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_02_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_03_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_04_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_05_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_06_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_07_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_08_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_09_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_10_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_11_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_12_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PBB', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PBB(54) : timephase.sql(57) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_project_id IS NULL) OR (p_budget_year IS NULL) OR (p_chargecode_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PBB', 58+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PBB(59) : timephase.sql(62) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PBB', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PBB(62) : timephase.sql(65) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_project_id := p_project_id;
   h_budget_year := p_budget_year;
   h_chargecode_id := p_chargecode_id;
   
   h_count := 0;
   If ((PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR', 22) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_AVERAGE_RATE', 20) = PMO_CNST.SC_MATCH) 
         OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_FULL_TIME_EQUIVALENT'
         , 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
         , 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
         h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH)) AND (Coalesce(
         p_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET) Then
      BEGIN
         SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(98) : timephase.sql(101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (PMO_ORASTD.strncmp(h_pa_timephase, 'Y'
            , 1) = 0) Then
         BEGIN
            SELECT COUNT(TSK_ASSIGNMENT_ID) INTO h_count
            FROM TASK_ASSIGNMENTS
            WHERE PROJECT_ID = h_project_id
            AND TASK_ID = PROJECT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 115+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(116) : timephase.sql(119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_count, 0) > 0) Then
            h_count := 1;
         Else
            h_count := 0;
         End If;
      End If;
   End If;
   
   If Coalesce(h_count, 0) = 0 Then
      If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) 
            OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_AVERAGE_COST'
            , 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
            , 'BENEFIT_AVERAGE_RATE', 20) = PMO_CNST.SC_MATCH) Then
         h_total_amount := (Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                            p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                            p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                            p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                            p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                            p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0)) / 12;
      Else
         h_total_amount := Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                           p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                           p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                           p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                           p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                           p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0);
      End If;
      
      BEGIN
         UPDATE PROJECT_BUDGET_BREAKDOWN SET
         MONTH_01_AMOUNT = p_month_01_amount,
         MONTH_02_AMOUNT = p_month_02_amount,
         MONTH_03_AMOUNT = p_month_03_amount,
         MONTH_04_AMOUNT = p_month_04_amount,
         MONTH_05_AMOUNT = p_month_05_amount,
         MONTH_06_AMOUNT = p_month_06_amount,
         MONTH_07_AMOUNT = p_month_07_amount,
         MONTH_08_AMOUNT = p_month_08_amount,
         MONTH_09_AMOUNT = p_month_09_amount,
         MONTH_10_AMOUNT = p_month_10_amount,
         MONTH_11_AMOUNT = p_month_11_amount,
         MONTH_12_AMOUNT = p_month_12_amount,
         TOTAL_AMOUNT = h_total_amount
         WHERE PROJECT_ID = h_project_id
         AND BUDGET_YEAR = h_budget_year
         AND CHARGECODE_ID = h_chargecode_id
         AND BUDGET_TYPE = p_budget_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 177+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(178) : timephase.sql(181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN (
            ELEMENT_ID,
            PROJECT_ID,
            BUDGET_YEAR,
            CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT,
            MONTH_02_AMOUNT,
            MONTH_03_AMOUNT,
            MONTH_04_AMOUNT,
            MONTH_05_AMOUNT,
            MONTH_06_AMOUNT,
            MONTH_07_AMOUNT,
            MONTH_08_AMOUNT,
            MONTH_09_AMOUNT,
            MONTH_10_AMOUNT,
            MONTH_11_AMOUNT,
            MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            VALUES (
            h_project_id,
            h_project_id,
            h_budget_year,
            h_chargecode_id,
            p_budget_type,
            p_month_01_amount,
            p_month_02_amount,
            p_month_03_amount,
            p_month_04_amount,
            p_month_05_amount,
            p_month_06_amount,
            p_month_07_amount,
            p_month_08_amount,
            p_month_09_amount,
            p_month_10_amount,
            p_month_11_amount,
            p_month_12_amount,
            h_total_amount
            );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 233+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(234) : timephase.sql(237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PBB', 241+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PBB(242) : timephase.sql(245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 248+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(249) : timephase.sql(252) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 260+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(261) : timephase.sql(264) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PBB;
ALTER FUNCTION SP_U_PBB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PBB ==
CREATE OR REPLACE FUNCTION SP_S_PBB
(
     p_project_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_PBBA PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_PBB PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PBB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PBB'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PBB(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PBB(26) : timephase.sql(306) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   
   If (p_project_id IS NULL) OR (p_budget_year IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PBB', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PBB(33) : timephase.sql(313) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(36) : timephase.sql(316) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
   PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
   
   BEGIN
      DELETE FROM TIMEPHASED_PROJECT
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(57) : timephase.sql(337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(p_budget_year, 0) = 0 Then
      OPEN C_PBBA FOR SELECT
      (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
      AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
      CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
      PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, CC.CAPITAL_EXPENSE,
      CC.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
      PBB.ELEMENT_ID AS ASSOCIATE_ID,
      CASE WHEN B.ASSOCIATE_BUDGET_ID IS NULL THEN 0 ELSE
      (SELECT ABC.CAPITAL_EXPENSE FROM BUDGETS AB, TMT_CHARGECODES ABC
      WHERE AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID AND AB.PROJECT_ID = B.PROJECT_ID
      AND AB.ELEMENT_ID = B.ELEMENT_ID AND ABC.ELEMENT_ID = AB.CHARGECODE_ID) END
      AS ASSOCIATE_CAPITAL_EXPENSE,
      B.AUTO_FLAG,
      PBB.MONTH_01_AMOUNT,
      PBB.MONTH_02_AMOUNT,PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT,PBB.MONTH_05_AMOUNT,
      PBB.MONTH_06_AMOUNT,PBB.MONTH_07_AMOUNT,
      PBB.MONTH_08_AMOUNT,PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT,PBB.MONTH_11_AMOUNT,
      PBB.MONTH_12_AMOUNT,PBB.TOTAL_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN PBB
      JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
      JOIN BUDGETS B ON B.PROJECT_ID = PBB.PROJECT_ID AND B.CHARGECODE_ID = PBB.CHARGECODE_ID AND B.ELEMENT_ID = PBB.ELEMENT_ID
      WHERE PBB.PROJECT_ID = h_project_id
      AND PBB.PROJECT_ID = PBB.ELEMENT_ID
      ORDER BY PBB.BUDGET_YEAR, CC.CAPITAL_EXPENSE, CC.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(90) : timephase.sql(370) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PBBA;
   Else
      OPEN C_PBB FOR SELECT
      (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
      AS ELEMENT_ID,
      CC.ELEMENT_ID AS ORIGINAL_ID,
      CC.ELEMENT_NAME,
      PBB.BUDGET_TYPE AS TYPE_ID,
      PBB.PROJECT_ID,
      PBB.BUDGET_YEAR,
      PBB.CHARGECODE_ID,
      CC.CAPITAL_EXPENSE,
      CC.BILLABLE,
      CC.ELEMENT_NAME AS CHARGECODE_NAME,
      PBB.ELEMENT_ID AS ASSOCIATE_ID,
      CASE WHEN B.ASSOCIATE_BUDGET_ID IS NULL THEN 0 ELSE
      (SELECT ABC.CAPITAL_EXPENSE FROM BUDGETS AB, TMT_CHARGECODES ABC
      WHERE AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID AND AB.PROJECT_ID = B.PROJECT_ID
      AND AB.ELEMENT_ID = B.ELEMENT_ID AND ABC.ELEMENT_ID = AB.CHARGECODE_ID) END
      AS ASSOCIATE_CAPITAL_EXPENSE,
      B.AUTO_FLAG,
      PBB.MONTH_01_AMOUNT,
      PBB.MONTH_02_AMOUNT,
      PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT,
      PBB.MONTH_05_AMOUNT,
      PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT,
      PBB.MONTH_08_AMOUNT,
      PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT,
      PBB.MONTH_11_AMOUNT,
      PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN PBB ,TMT_CHARGECODES CC , BUDGETS B
      WHERE PBB.ELEMENT_ID = p_project_id
      AND PBB.BUDGET_YEAR = p_budget_year
      AND CC.ELEMENT_ID = PBB.CHARGECODE_ID
      AND B.PROJECT_ID = PBB.PROJECT_ID
      AND B.ELEMENT_ID = PBB.PROJECT_ID
      AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
      ORDER BY CC.CAPITAL_EXPENSE, CC.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 134+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(135) : timephase.sql(415) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PBB;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 143+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(144) : timephase.sql(424) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 155+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(156) : timephase.sql(436) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PBB;
ALTER FUNCTION SP_S_PBB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PBB_PIVOT ==
CREATE OR REPLACE FUNCTION SP_PBB_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_chargecode_id VARCHAR2(32);
   h_chargecode_name VARCHAR2(100);
   h_id VARCHAR2(32);
   h_ids VARCHAR2(4000);
   h_project_id VARCHAR2(32);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_month_01_amount NUMBER := 0;
   h_month_02_amount NUMBER := 0;
   h_month_03_amount NUMBER := 0;
   h_month_04_amount NUMBER := 0;
   h_month_05_amount NUMBER := 0;
   h_month_06_amount NUMBER := 0;
   h_month_07_amount NUMBER := 0;
   h_month_08_amount NUMBER := 0;
   h_month_09_amount NUMBER := 0;
   h_month_10_amount NUMBER := 0;
   h_month_11_amount NUMBER := 0;
   h_month_12_amount NUMBER := 0;
   h_budget_year PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PBB1 IS
         SELECT ELEMENT_ID, RANK
         FROM PMO_PBB_PORTFOLIOS
         ORDER BY RANK;

      CURSOR C_PBB2 IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_PBB_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR C_PBB_INSERT IS
         SELECT
         PBB.ELEMENT_ID,
         PPP.ELEMENT_NAME,
         PPP.RANK,
         PBB.CHARGECODE_ID,
         CC.CAPITAL_EXPENSE,
         CC.ELEMENT_NAME,
         BUDGET_YEAR,
         MONTH_01_AMOUNT,
         MONTH_02_AMOUNT,
         MONTH_03_AMOUNT,
         MONTH_04_AMOUNT,
         MONTH_05_AMOUNT,
         MONTH_06_AMOUNT,
         MONTH_07_AMOUNT,
         MONTH_08_AMOUNT,
         MONTH_09_AMOUNT,
         MONTH_10_AMOUNT,
         MONTH_11_AMOUNT,
         MONTH_12_AMOUNT
         FROM PROJECT_BUDGET_BREAKDOWN PBB
         JOIN PMO_PBB_PROJECTS PPP
         ON PPP.ELEMENT_ID = PBB.PROJECT_ID
         JOIN TMT_CHARGECODES CC
         ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
         ORDER BY PPP.RANK, PBB.BUDGET_YEAR, CC.CAPITAL_EXPENSE, CC.ELEMENT_NAME;

      -- Resultset Cursor Declaration
      C_PBB_PIVOT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PBB_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PBB_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_PBB_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 84+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PBB_PIVOT(85) : timephase.sql(537) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_ids IS NULL) OR (p_type IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PBB_PIVOT', 89+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PBB_PIVOT(90) : timephase.sql(542) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(93) : timephase.sql(545) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_type := p_type;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_TMP_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_PIVOT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --PROJECT
   If (Coalesce(h_type, 0) = 1) OR (Coalesce(h_type, 0) = 3) Then
      --PORTFOLIO Type
      h_total := 0;
      h_ids := p_ids;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PBB_PIVOT', 130+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PBB_PIVOT(131) : timephase.sql(583) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 133+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(134) : timephase.sql(586) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);       //   strncpy( h_id, h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                       //   h_id[32] = '\0';
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_PORTFOLIOS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(155) : timephase.sql(607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_PBB_PORTFOLIOS( ELEMENT_ID, RANK )
            SELECT ELEMENT_ID, RTRIM(RANK)
            FROM TMT_PORTFOLIOS
            WHERE RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(176) : timephase.sql(628) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
      
      OPEN C_PBB1;
      
      LOOP
         FETCH C_PBB1 INTO h_c_id, h_c_rank;
         IF C_PBB1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_PBB_TMP_PROJECTS( ELEMENT_ID, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.RANK)
            FROM TMT_PORTFOLIOS P
            JOIN TMT_WBS W
            ON W.ELEMENT_ID = P.ELEMENT_ID
            WHERE P.RANK LIKE h_c_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(214) : timephase.sql(666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_PBB1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 227+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(228) : timephase.sql(680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_PBB2;
      
      LOOP
         FETCH C_PBB2 INTO h_c_id, h_c_rank;
         IF C_PBB2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_PBB_PROJECTS( ELEMENT_ID, ELEMENT_NAME, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME), RTRIM(W.RANK)
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_c_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 261+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(262) : timephase.sql(714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_PBB2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 275+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(276) : timephase.sql(728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_type, 0) = 2) OR (Coalesce(h_type, 0) = 4) Then
      --PROJECT Type
      h_total := 0;
      h_ids := p_ids;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PBB_PIVOT', 286+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PBB_PIVOT(287) : timephase.sql(739) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 289+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(290) : timephase.sql(742) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);   //   strncpy( h_id, h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                   //   h_id[32] = '\0';
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(311) : timephase.sql(763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_PBB_PROJECTS( ELEMENT_ID, ELEMENT_NAME, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME), RTRIM(W.RANK)
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(332) : timephase.sql(784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   OPEN C_PBB_INSERT;
   
   LOOP
      FETCH C_PBB_INSERT INTO
      h_project_id,
      h_project_name,
      h_project_rank,
      h_chargecode_id,
      h_capital_expense,
      h_chargecode_name,
      h_budget_year,
      h_month_01_amount,
      h_month_02_amount,
      h_month_03_amount,
      h_month_04_amount,
      h_month_05_amount,
      h_month_06_amount,
      h_month_07_amount,
      h_month_08_amount,
      h_month_09_amount,
      h_month_10_amount,
      h_month_11_amount,
      h_month_12_amount;
      IF C_PBB_INSERT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 1, h_month_01_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(385) : timephase.sql(837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 2, h_month_02_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(403) : timephase.sql(855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 3, h_month_03_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 420+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(421) : timephase.sql(873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 4, h_month_04_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 438+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(439) : timephase.sql(891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 5, h_month_05_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 456+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(457) : timephase.sql(909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 6, h_month_06_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 474+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(475) : timephase.sql(927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 7, h_month_07_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 492+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(493) : timephase.sql(945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 8, h_month_08_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 510+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(511) : timephase.sql(963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 9, h_month_09_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 528+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(529) : timephase.sql(981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 10, h_month_10_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 546+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(547) : timephase.sql(999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 11, h_month_11_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 564+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(565) : timephase.sql(1017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 12, h_month_12_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 582+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(583) : timephase.sql(1035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_PBB_INSERT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 596+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(597) : timephase.sql(1049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_PBB_PIVOT FOR SELECT PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT
   FROM PMO_PBB_PIVOT
   ORDER BY PROJECT_RANK, CHAGECODE_NAME, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 605+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(606) : timephase.sql(1058) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_PBB_PIVOT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 613+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(614) : timephase.sql(1066) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 625+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(626) : timephase.sql(1078) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PBB_PIVOT;
ALTER FUNCTION SP_PBB_PIVOT COMPILE DEBUG;

/******************************************************************************/

Prompt == FUNCTION FC_UPDATE_LABOR_BUDGET_BITS ==
CREATE OR REPLACE FUNCTION FC_UPDATE_LABOR_BUDGET_BITS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_billable PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_billable PLS_INTEGER := sh_h_billable;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_LABOR_BUDGET_BITS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_LABOR_BUDGET_BITS'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_LABOR_BUDGET_BITS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_billable), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_LABOR_BUDGET_BITS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_LABOR_BUDGET_BITS(23) : timephase.sql(1117) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_capital_expense, 0) = 0 Then
      --EXPENSE_LABOR
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_LABOR';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 43+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(44) : timephase.sql(1138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'EXPENSE_LABOR', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 62+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(63) : timephase.sql(1157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_LABOR';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(85) : timephase.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --EXPENSE_HOURS
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(107) : timephase.sql(1201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'EXPENSE_HOURS', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 125+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(126) : timephase.sql(1220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 147+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(148) : timephase.sql(1242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --EXPENSE_AVERAGE_COST
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_AVERAGE_COST';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(170) : timephase.sql(1264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'EXPENSE_AVERAGE_COST', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(189) : timephase.sql(1283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_AVERAGE_COST';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(211) : timephase.sql(1305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --EXPENSE_FULL_TIME_EQUIVALENT
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 232+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(233) : timephase.sql(1327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'EXPENSE_FULL_TIME_EQUIVALENT', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 251+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(252) : timephase.sql(1346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 273+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(274) : timephase.sql(1368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_capital_expense, 0) = 1 Then
      --CAPITAL_LABOR
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_LABOR';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 295+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(296) : timephase.sql(1390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'CAPITAL_LABOR', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(315) : timephase.sql(1409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_LABOR';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 336+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(337) : timephase.sql(1431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --CAPITAL_HOURS
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 358+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(359) : timephase.sql(1453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'CAPITAL_HOURS', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 377+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(378) : timephase.sql(1472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 399+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(400) : timephase.sql(1494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --CAPITAL_AVERAGE_COST
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_AVERAGE_COST';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 421+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(422) : timephase.sql(1516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'CAPITAL_AVERAGE_COST', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 440+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(441) : timephase.sql(1535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_AVERAGE_COST';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 462+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(463) : timephase.sql(1557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --CAPITAL_FULL_TIME_EQUIVALENT
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 484+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(485) : timephase.sql(1579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'CAPITAL_FULL_TIME_EQUIVALENT', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 503+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(504) : timephase.sql(1598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 525+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(526) : timephase.sql(1620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --BENEFIT_LABOR
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = 'BILLABLE_BENEFIT_LABOR';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 548+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(549) : timephase.sql(1643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'BILLABLE_BENEFIT_LABOR', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 567+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(568) : timephase.sql(1662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --BENEFIT_HOURS
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = 'BENEFIT_HOURS';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 590+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(591) : timephase.sql(1685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'BENEFIT_HOURS', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 609+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(610) : timephase.sql(1704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --BENEFIT_AVERAGE_RATE
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = 'BENEFIT_AVERAGE_RATE';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 632+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(633) : timephase.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
         
         VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'BENEFIT_AVERAGE_RATE', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 652+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(653) : timephase.sql(1747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --BENEFIT_FULL_TIME_EQUIVALENT
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 675+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(676) : timephase.sql(1770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user, 'BENEFIT_FULL_TIME_EQUIVALENT', 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET_BITS', 694+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET_BITS(695) : timephase.sql(1789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_LABOR_BUDGET_BITS', 700+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_LABOR_BUDGET_BITS(701) : timephase.sql(1795) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_LABOR_BUDGET_BITS;
ALTER FUNCTION FC_UPDATE_LABOR_BUDGET_BITS COMPILE DEBUG;

-- {{ Vladimir Schneider, September 21, 2004

-- DELTA:

-- This function is gone, use the GET_FISCAL_DATE macro, which also handles no data

-- condition which requires the involvement of a DBA

-- BOOL_RETURN_CODE FC_FISCAL_DATE

-- }} Vladimir Schneider, September 21, 2004

/*************************************************************************************************
Timephase the amount budget (h_eac) between h_SD and h_FD
    insert in session.PMO_NEW_TIMEPHASE one row per fiscal year
**************************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_AMOUNT ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_AMOUNT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_total_amount NUMBER
   , h_period_start IN OUT NOCOPY DATE
   , h_period_finish IN OUT NOCOPY DATE
   , sh_h_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_total_amount NUMBER := sh_h_total_amount;
   h_type PLS_INTEGER := sh_h_type;
   h_SD DATE;
   h_FD DATE;
   h_count PLS_INTEGER := 0;
   h_bac NUMBER := 0;
   h_last_year PLS_INTEGER := 0;
   h_last_month PLS_INTEGER := 0;
   h_total_amount_new NUMBER := 0;
   h_total_amount_old NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_AMOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_AMOUNT'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_AMOUNT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_total_amount), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_period_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_period_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_AMOUNT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_AMOUNT(35) : timephase.sql(1855) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_total_amount IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_AMOUNT', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_AMOUNT(40) : timephase.sql(1860) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN -1;
   End If;
   
   BEGIN
      SELECT START_DATE INTO h_SD
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_start AND FINISH_DATE >= h_period_start;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(55) : timephase.sql(1875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT START_DATE, FISCAL_YEAR, FISCAL_MONTH
      INTO h_FD, h_last_year, h_last_month
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_finish AND FINISH_DATE >= h_period_finish;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(71) : timephase.sql(1891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.DAYS(h_period_finish) - PMO_ORASTD.DAYS(h_period_start) + 1 INTO h_count
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(85) : timephase.sql(1905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_bac := Coalesce(h_total_amount, 0) / Coalesce(h_count, 0);
   
   --trace_printf("h_bac: %.2f, h_total_amount: %.2f, h_count: %d\n",h_bac,h_total_amount,h_count);
   BEGIN
      INSERT INTO PMO_NEW_TIMEPHASE ( ELEMENT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_element_id, h_project_id, h_chargecode_id, h_type, FISCAL_YEAR,
      (PMO_ORASTD.DAYS(CASE WHEN MAX(FINISH_DATE) >= h_period_finish THEN h_period_finish ELSE MAX(FINISH_DATE) END) -
      PMO_ORASTD.DAYS(CASE WHEN MIN(START_DATE) <= h_period_start THEN h_period_start ELSE MIN(START_DATE) END) + 1) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 1 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 2 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 3 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 4 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 5 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 6 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 7 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 8 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 9 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 10 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 11 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 12 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac
      FROM FISCAL_CALENDAR
      WHERE START_DATE >= h_SD AND START_DATE <= h_FD
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 148+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(149) : timephase.sql(1969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_project_id: %s, h_SD: %s, h_FD: %s\n",SC_STATE,h_project_id,h_SD, h_FD);
   
   BEGIN
      SELECT TOTAL_AMOUNT INTO h_total_amount_old
      FROM PMO_NEW_TIMEPHASE
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type
      AND BUDGET_YEAR = h_last_year;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(169) : timephase.sql(1989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_NEW_TIMEPHASE
      SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_total_amount - (SELECT SUM(TOTAL_AMOUNT)
      FROM PMO_NEW_TIMEPHASE
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type)
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type
      AND BUDGET_YEAR = h_last_year;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 196+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(197) : timephase.sql(2017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT TOTAL_AMOUNT INTO h_total_amount_new
      FROM PMO_NEW_TIMEPHASE
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type
      AND BUDGET_YEAR = h_last_year;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 215+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(216) : timephase.sql(2036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_total_amount_new: %.2f", h_total_amount_new);
   --trace_printf("h_total_amount_old: %.2f", h_total_amount_old);
   If Coalesce(h_total_amount_new, 0) <> Coalesce(h_total_amount_new, 0) Then
      If Coalesce(h_last_month, 0) = 1 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_01_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(243) : timephase.sql(2063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 2 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_02_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 265+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(266) : timephase.sql(2086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 3 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_03_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 288+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(289) : timephase.sql(2109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 4 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_04_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 311+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(312) : timephase.sql(2132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 5 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_05_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 334+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(335) : timephase.sql(2155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 6 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_06_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 357+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(358) : timephase.sql(2178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 7 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_07_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 380+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(381) : timephase.sql(2201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 8 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_08_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 403+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(404) : timephase.sql(2224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 9 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_09_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 426+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(427) : timephase.sql(2247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 10 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_10_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 449+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(450) : timephase.sql(2270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 11 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_11_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 472+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(473) : timephase.sql(2293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 12 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_12_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 495+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(496) : timephase.sql(2316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_AMOUNT', 502+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_AMOUNT(503) : timephase.sql(2323) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_AMOUNT;
ALTER FUNCTION FC_TIMEPHASE_AMOUNT COMPILE DEBUG;

/******************************************************************************
  This function insert charge code delta amount to the TIMEPHASED_DELTA table
******************************************************************************/

Prompt == FUNCTION FC_I_TIMEPHASED_DELTA ==
CREATE OR REPLACE FUNCTION FC_I_TIMEPHASED_DELTA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_budget_type PLS_INTEGER
   , sh_h_delta_amount NUMBER
   , h_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_budget_type PLS_INTEGER := sh_h_budget_type;
   h_delta_amount NUMBER := sh_h_delta_amount;
   h_year PLS_INTEGER := 1;
   h_month PLS_INTEGER := 1;
   h_update_sql VARCHAR2(2048);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_TIMEPHASED_DELTA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_TIMEPHASED_DELTA'), '-- ' || SYSTIMESTAMP, ':r := FC_I_TIMEPHASED_DELTA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_budget_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_delta_amount), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_TIMEPHASED_DELTA', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_TIMEPHASED_DELTA(28) : timephase.sql(2363) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      BEGIN
         SELECT FISCAL_YEAR, FISCAL_MONTH INTO h_year, h_month 
                 FROM FISCAL_CALENDAR WHERE h_date BETWEEN START_DATE AND FINISH_DATE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_TIMEPHASED_DELTA', 40+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_TIMEPHASED_DELTA(41) : timephase.sql(2376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_TIMEPHASED_DELTA', 46+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_TIMEPHASED_DELTA(47) : timephase.sql(2382) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_TIMEPHASED_DELTA', 49+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_TIMEPHASED_DELTA(50) : timephase.sql(2385) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR, h_date
               , False);
      End If;
   END;
   --trace_printf("h_date: %d:%s, h_year: %d, h_month: %d\n",h_date_Ind,h_date,h_year, h_month);
   
   h_update_sql := '';
   h_update_sql := 'INSERT INTO TIMEPHASED_DELTA (';
   h_update_sql := h_update_sql || 
                                'PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR, TOTAL_AMOUNT, ';
   
   If Coalesce(h_month, 0) = 1 Then
      h_update_sql := h_update_sql || 'MONTH_01_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 2 Then
      h_update_sql := h_update_sql || 'MONTH_02_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 3 Then
      h_update_sql := h_update_sql || 'MONTH_03_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 4 Then
      h_update_sql := h_update_sql || 'MONTH_04_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 5 Then
      h_update_sql := h_update_sql || 'MONTH_05_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 6 Then
      h_update_sql := h_update_sql || 'MONTH_06_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 7 Then
      h_update_sql := h_update_sql || 'MONTH_07_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 8 Then
      h_update_sql := h_update_sql || 'MONTH_08_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 9 Then
      h_update_sql := h_update_sql || 'MONTH_09_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 10 Then
      h_update_sql := h_update_sql || 'MONTH_10_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 11 Then
      h_update_sql := h_update_sql || 'MONTH_11_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 12 Then
      h_update_sql := h_update_sql || 'MONTH_12_AMOUNT, ';
   End If;
   
   h_update_sql := h_update_sql || 'PROCESS_FLAG) VALUES (''';
   h_update_sql := h_update_sql || h_project_id;
   h_update_sql := h_update_sql || ''', ''';
   h_update_sql := h_update_sql || h_element_id;
   h_update_sql := h_update_sql || ''', ''';
   h_update_sql := h_update_sql || h_chargecode_id;
   h_update_sql := h_update_sql || ''', ';
   h_update_sql := h_update_sql || TO_CHAR(h_budget_type);
   h_update_sql := h_update_sql || ', ';
   h_update_sql := h_update_sql || TO_CHAR(h_year);
   h_update_sql := h_update_sql || ', ';
   h_update_sql := h_update_sql || TO_CHAR(h_delta_amount);
   h_update_sql := h_update_sql || 'e0, ';
   h_update_sql := h_update_sql || TO_CHAR(h_delta_amount);
   h_update_sql := h_update_sql || 'e0, ''I'') ';
   
   --trace_printf(h_update_sql); //trace_printf("\n"); //trace_flush();
   
   BEGIN
      EXECUTE IMMEDIATE h_update_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_TIMEPHASED_DELTA', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_TIMEPHASED_DELTA(119) : timephase.sql(2454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_update_sql);
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_chargecode_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_TIMEPHASED_DELTA', 139+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_TIMEPHASED_DELTA(140) : timephase.sql(2475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_TIMEPHASED_DELTA', 145+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_TIMEPHASED_DELTA(146) : timephase.sql(2481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_TIMEPHASED_DELTA;
ALTER FUNCTION FC_I_TIMEPHASED_DELTA COMPILE DEBUG;

/*************************************************************************************************
Timephase estimated_budget at project level when copy project
**************************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_ESTIMATED ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_ESTIMATED
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_chargecode_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_period_start DATE;
   h_period_finish DATE;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_total_amount NUMBER := 0;
   h_bac NUMBER := 0;
-- Declare Cursors
      CURSOR TP_ESTIMATED IS
         SELECT CHARGECODE_ID, ESTIMATED_BUDGET
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND ESTIMATED_BUDGET > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_ESTIMATED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_ESTIMATED'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_ESTIMATED(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_ESTIMATED(30) : timephase.sql(2523) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT START_FINISH_DATE, FINISH_START_DATE
      INTO h_period_start, h_period_finish
      FROM TMT_WBS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(45) : timephase.sql(2538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_ESTIMATED(52) : timephase.sql(2545) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_period_start IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 58+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_ESTIMATED(59) : timephase.sql(2552) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_period_finish IS NULL) Then
      h_period_finish := h_period_start;
   End If;
   
   h_type := PMO_CNST.SC_ESTIMATED_BUDGET;
   BEGIN
      SELECT START_DATE INTO h_SD
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_start AND FINISH_DATE >= h_period_start;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(79) : timephase.sql(2572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT START_DATE INTO h_FD
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_finish AND FINISH_DATE >= h_period_finish;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(94) : timephase.sql(2587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.DAYS(h_period_finish) - PMO_ORASTD.DAYS(h_period_start) + 1 INTO h_count
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(108) : timephase.sql(2601) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN TP_ESTIMATED;
   
   LOOP
      FETCH TP_ESTIMATED INTO h_chargecode_id, h_total_amount;
      IF TP_ESTIMATED%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_bac := Coalesce(h_total_amount, 0) / Coalesce(h_count, 0);
      
      --trace_printf("h_bac: %.2f, h_total_amount: %.2f, h_count: %d\n",h_bac,h_total_amount,h_count);
      BEGIN
         INSERT INTO PROJECT_BUDGET_BREAKDOWN (ELEMENT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_project_id, h_chargecode_id, h_type, FISCAL_YEAR,
         (PMO_ORASTD.DAYS(CASE WHEN MAX(FINISH_DATE) >= h_period_finish THEN h_period_finish ELSE MAX(FINISH_DATE) END) -
         PMO_ORASTD.DAYS(CASE WHEN MIN(START_DATE) <= h_period_start THEN h_period_start ELSE MIN(START_DATE) END) + 1) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 1 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 2 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 3 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 4 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 5 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 6 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 7 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 8 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 9 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 10 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 11 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 12 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac
         FROM FISCAL_CALENDAR
         WHERE START_DATE >= h_SD AND START_DATE <= h_FD
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(185) : timephase.sql(2678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE TP_ESTIMATED ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(198) : timephase.sql(2691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_ESTIMATED(204) : timephase.sql(2697) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_ESTIMATED;
ALTER FUNCTION FC_TIMEPHASE_ESTIMATED COMPILE DEBUG;

/*******************************************************************************
Create timephase delta for labor related actual
h_update_bits:
    0:  create positive delta;
    -1: create negative delta
********************************************************************************/

Prompt == FUNCTION FC_TPHASE_ACTUAL_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_TPHASE_ACTUAL_ASSIGN
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_start_DT IN OUT NOCOPY TIMESTAMP
   , h_finish_DT IN OUT NOCOPY TIMESTAMP
   , sh_h_update_bits PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_billable PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_update_bits PLS_INTEGER := sh_h_update_bits;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_billable PLS_INTEGER := sh_h_billable;
   h_new_chargecode_hours VARCHAR2(32);
   h_new_chargecode_labor VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TPHASE_ACTUAL_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TPHASE_ACTUAL_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_TPHASE_ACTUAL_ASSIGN(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_update_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_billable), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_ACTUAL_ASSIGN', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TPHASE_ACTUAL_ASSIGN(32) : timephase.sql(2744) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TPHASE_ACTUAL';
   PMO_DB2M.SC_STATE := 0;
   
   If ((h_start_DT IS NOT NULL)) AND ((h_finish_DT IS NOT NULL)) Then
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10)) AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10))
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10)) AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(74) : timephase.sql(2786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_start_DT IS NOT NULL) Then
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10))
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(113) : timephase.sql(2825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_finish_DT IS NOT NULL) Then
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10))
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0
         AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(152) : timephase.sql(2864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(189) : timephase.sql(2901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_capital_expense, 0) = 0 Then
      h_new_chargecode_hours := 'EXPENSE_HOURS';
      h_new_chargecode_labor := 'EXPENSE_LABOR';
   Else
      h_new_chargecode_hours := 'CAPITAL_HOURS';
      h_new_chargecode_labor := 'CAPITAL_LABOR';
   End If;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_new_chargecode_hours, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
      (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 232+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(233) : timephase.sql(2945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_new_chargecode_hours, FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 267+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(268) : timephase.sql(2980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_new_chargecode_labor, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
      (-1) * SUM(REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) / 60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 302+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(303) : timephase.sql(3015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_new_chargecode_labor, FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      (-1) * SUM(REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) / 60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 337+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(338) : timephase.sql(3050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_new_chargecode_hours;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 357+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(358) : timephase.sql(3070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_new_chargecode_labor;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 377+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(378) : timephase.sql(3090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_billable, 0) = 1 Then
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, 'BENEFIT_HOURS', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(414) : timephase.sql(3126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, 'BENEFIT_HOURS', FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
         (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 448+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(449) : timephase.sql(3161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, 'BILLABLE_BENEFIT_LABOR', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         (-1) * SUM(REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) / 60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 483+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(484) : timephase.sql(3196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, 'BILLABLE_BENEFIT_LABOR', FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
         (-1) * SUM(REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) / 60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 518+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(519) : timephase.sql(3231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 538+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(539) : timephase.sql(3251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BILLABLE_BENEFIT_LABOR';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 558+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(559) : timephase.sql(3271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 578+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(579) : timephase.sql(3291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_ACTUAL_ASSIGN', 584+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_ACTUAL_ASSIGN(585) : timephase.sql(3297) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TPHASE_ACTUAL_ASSIGN;
ALTER FUNCTION FC_TPHASE_ACTUAL_ASSIGN COMPILE DEBUG;

/*************************************************************************************************
Create timephase delta for labor related actual
    when changing Capital<-->Expense and/or Billable<-->Non-Billable
h_update_bits:
    first bit for Capital<-->Expense
    second bit for Billable<-->Non-Billable

h_capital_expense: old capital_expense type.
h_billable: old billable type.
**************************************************************************************************/

Prompt == FUNCTION FC_RE_TPHASE_ACTUAL_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_RE_TPHASE_ACTUAL_ASSIGN
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , sh_h_update_bits PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_billable PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_update_bits PLS_INTEGER := sh_h_update_bits;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_billable PLS_INTEGER := sh_h_billable;
   h_old_chargecode_hours VARCHAR2(32);
   h_new_chargecode_hours VARCHAR2(32);
   h_old_chargecode_labor VARCHAR2(32);
   h_new_chargecode_labor VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RE_TPHASE_ACTUAL_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RE_TPHASE_ACTUAL_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_RE_TPHASE_ACTUAL_ASSIGN(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_update_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_billable), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RE_TPHASE_ACTUAL_ASSIGN(30) : timephase.sql(3346) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TPHASE_ACTUAL';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_TPHASE_ACTUAL
      (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
      T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
      T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
      T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
      FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
      WHERE T.PROJECT_ID = h_project_id
      AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
      AND T.MONTH1_REGULAR_HRS > 0
      UNION ALL
      SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
      T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
      T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
      T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
      FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
      WHERE T.PROJECT_ID = h_project_id
      AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
      AND F2.START_DATE <= (T.WEEK_OF + 6     )
      AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
      AND T.MONTH2_REGULAR_HRS > 0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(69) : timephase.sql(3385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_FUNC.BIT_OR(Coalesce(h_update_bits, 0), 1)) = 1 Then
      If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_CAPITAL Then
         h_old_chargecode_hours := 'CAPITAL_HOURS';
         h_new_chargecode_hours := 'EXPENSE_HOURS';
         
         h_old_chargecode_labor := 'CAPITAL_LABOR';
         h_new_chargecode_labor := 'EXPENSE_LABOR';
      Else
         h_old_chargecode_hours := 'EXPENSE_HOURS';
         h_new_chargecode_hours := 'CAPITAL_HOURS';
         
         h_old_chargecode_labor := 'EXPENSE_LABOR';
         h_new_chargecode_labor := 'CAPITAL_LABOR';
      End If;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, h_old_chargecode_hours, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(119) : timephase.sql(3435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, h_old_chargecode_labor, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         (-1) * SUM(REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) / 60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(154) : timephase.sql(3470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, h_new_chargecode_hours, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(189) : timephase.sql(3505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, h_new_chargecode_labor, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         SUM(REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) / 60.00,
         SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
         SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(224) : timephase.sql(3540) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_FUNC.BIT_OR(Coalesce(h_update_bits, 0), 2)) = 2 Then
      If Coalesce(h_billable, 0) = 1 Then
         BEGIN
            INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
            MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
            SELECT h_project_id, h_element_id, 'BENEFIT_HOURS', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
            (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
            FROM PMO_TMP_TPHASE_ACTUAL
            GROUP BY FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 261+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(262) : timephase.sql(3578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
            MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
            SELECT h_project_id, h_element_id, 'BILLABLE_BENEFIT_LABOR', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
            (-1) * SUM(REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) / 60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00
            FROM PMO_TMP_TPHASE_ACTUAL
            GROUP BY FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(297) : timephase.sql(3613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
            MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
            SELECT h_project_id, h_element_id, 'BENEFIT_HOURS', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
            SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
            FROM PMO_TMP_TPHASE_ACTUAL
            GROUP BY FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(332) : timephase.sql(3648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
            MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
            SELECT h_project_id, h_element_id, 'BILLABLE_BENEFIT_LABOR', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
            SUM(REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) / 60.00,
            SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00
            FROM PMO_TMP_TPHASE_ACTUAL
            GROUP BY FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 366+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(367) : timephase.sql(3683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 387+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RE_TPHASE_ACTUAL_ASSIGN(388) : timephase.sql(3704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RE_TPHASE_ACTUAL_ASSIGN', 393+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RE_TPHASE_ACTUAL_ASSIGN(394) : timephase.sql(3710) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_RE_TPHASE_ACTUAL_ASSIGN;
ALTER FUNCTION FC_RE_TPHASE_ACTUAL_ASSIGN COMPILE DEBUG;

-- BEGIN TIMEPHASE

/*****************************************************************************************/

-- Update task timephase based on the delta_timephase records and new timephase records

-- Generate project delta_timephase records

/*****************************************************************************************/

Prompt == FUNCTION FC_Update_Timephase ==
CREATE OR REPLACE FUNCTION FC_Update_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_chargecode_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_budget_type PLS_INTEGER := 0;
   h_project_id_actual VARCHAR2(32);
   h_id_actual VARCHAR2(32);
   h_chargecode_id_actual VARCHAR2(32);
   h_budget_year_actual PLS_INTEGER := 0;
   h_month_01_actual NUMBER := 0;
   h_month_02_actual NUMBER := 0;
   h_month_03_actual NUMBER := 0;
   h_month_04_actual NUMBER := 0;
   h_month_05_actual NUMBER := 0;
   h_month_06_actual NUMBER := 0;
   h_month_07_actual NUMBER := 0;
   h_month_08_actual NUMBER := 0;
   h_month_09_actual NUMBER := 0;
   h_month_10_actual NUMBER := 0;
   h_month_11_actual NUMBER := 0;
   h_month_12_actual NUMBER := 0;
   h_total_amount_actual NUMBER := 0;
   h_month_01_old NUMBER := 0;
   h_month_02_old NUMBER := 0;
   h_month_03_old NUMBER := 0;
   h_month_04_old NUMBER := 0;
   h_month_05_old NUMBER := 0;
   h_month_06_old NUMBER := 0;
   h_month_07_old NUMBER := 0;
   h_month_08_old NUMBER := 0;
   h_month_09_old NUMBER := 0;
   h_month_10_old NUMBER := 0;
   h_month_11_old NUMBER := 0;
   h_month_12_old NUMBER := 0;
   h_total_amount_old NUMBER := 0;
   h_count_old PLS_INTEGER := 0;
   h_month_01_new NUMBER := 0;
   h_month_02_new NUMBER := 0;
   h_month_03_new NUMBER := 0;
   h_month_04_new NUMBER := 0;
   h_month_05_new NUMBER := 0;
   h_month_06_new NUMBER := 0;
   h_month_07_new NUMBER := 0;
   h_month_08_new NUMBER := 0;
   h_month_09_new NUMBER := 0;
   h_month_10_new NUMBER := 0;
   h_month_11_new NUMBER := 0;
   h_month_12_new NUMBER := 0;
   h_total_amount_new NUMBER := 0;
   h_count_new PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TASK_TP IS
         SELECT DISTINCT CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE
         FROM PMO_CHANGED_TIMEPHASE
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         ORDER BY CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Update_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Update_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_Update_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Update_Timephase', 69+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Update_Timephase(70) : timephase.sql(3798) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id_actual := '';
   
   --trace_printf("h_element_id_id: %d;%s\n", h_id_Ind, h_id);
   -- merge PMO_NEW_TIMEPHASE and PMO_DELTA_TIMEPHASE tables
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT * FROM PMO_NEW_TIMEPHASE
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(91) : timephase.sql(3819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add change timephase
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      SELECT DISTINCT PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID
      FROM PMO_DELTA_TIMEPHASE
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(112) : timephase.sql(3840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add all actual timephase if the sched timephase changed
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT PBB.PROJECT_ID, PBB.ELEMENT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE, PBB.CHARGECODE_ID
      FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_CHANGED_TIMEPHASE C
      WHERE PBB.PROJECT_ID = h_project_id AND PBB.ELEMENT_ID = h_id
      AND C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.CHARGECODE_ID = PBB.CHARGECODE_ID AND C.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND C.CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__')
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND NOT EXISTS(SELECT CC.ELEMENT_ID FROM PMO_CHANGED_TIMEPHASE CC
      WHERE CC.PROJECT_ID = h_project_id AND CC.ELEMENT_ID = h_id
      AND CC.CHARGECODE_ID = C.CHARGECODE_ID AND CC.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(144) : timephase.sql(3872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add all sched timephase if the actual timephase changed
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT PBB.PROJECT_ID, PBB.ELEMENT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE, PBB.CHARGECODE_ID
      FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_CHANGED_TIMEPHASE C
      WHERE PBB.PROJECT_ID = h_project_id AND PBB.ELEMENT_ID = h_id
      AND C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.CHARGECODE_ID = PBB.CHARGECODE_ID AND C.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND C.CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__')
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND NOT EXISTS(SELECT CC.ELEMENT_ID FROM PMO_CHANGED_TIMEPHASE CC
      WHERE CC.PROJECT_ID = h_project_id AND CC.ELEMENT_ID = h_id
      AND CC.CHARGECODE_ID = C.CHARGECODE_ID AND CC.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(176) : timephase.sql(3904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add all years of the changed timephase
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT PBB.PROJECT_ID, PBB.ELEMENT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE, PBB.CHARGECODE_ID
      FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_CHANGED_TIMEPHASE C
      WHERE PBB.PROJECT_ID = h_project_id AND PBB.ELEMENT_ID = h_id
      AND C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.CHARGECODE_ID = PBB.CHARGECODE_ID AND C.BUDGET_TYPE = PBB.BUDGET_TYPE
      AND C.CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__')
      AND C.BUDGET_YEAR <> PBB.BUDGET_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 204+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(205) : timephase.sql(3933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add sched if actual timephase changed
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT C.PROJECT_ID, C.ELEMENT_ID, C.BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET, C.CHARGECODE_ID
      FROM PMO_CHANGED_TIMEPHASE C
      WHERE C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND NOT EXISTS(SELECT D.PROJECT_ID FROM PMO_CHANGED_TIMEPHASE D
      WHERE D.PROJECT_ID = C.PROJECT_ID AND D.ELEMENT_ID = C.ELEMENT_ID
      AND D.CHARGECODE_ID = C.CHARGECODE_ID AND D.BUDGET_YEAR = C.BUDGET_YEAR
      AND D.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(231) : timephase.sql(3959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TASK_TP;
   
   LOOP
      FETCH C_TASK_TP INTO h_chargecode_id, h_budget_year, h_budget_type;
      IF C_TASK_TP%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      --trace_printf("h_element_id_id: %d;%s\n", h_id_Ind, h_id);
      --trace_printf("h_chargecode_id: %d;%s\n", h_chargecode_id_Ind, h_chargecode_id);
      --trace_printf("h_budget_year: %d;%d\n", h_budget_year_Ind, h_budget_year);
      --trace_printf("h_budget_type: %d;%d\n", h_budget_type_Ind, h_budget_type);
      
      --trace_printf("Actual project_id00: %d;%s\n", h_project_id_actual_Ind, h_project_id_actual);
      If (PMO_ORASTD.strcmp(h_project_id, h_project_id_actual) <> PMO_CNST.SC_MATCH) 
            OR (PMO_ORASTD.strcmp(h_id, h_id_actual) <> PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(
            h_chargecode_id, h_chargecode_id_actual) <> PMO_CNST.SC_MATCH) OR (Coalesce(
            h_budget_year, 0) <> Coalesce(h_budget_year_actual, 0)) Then
         --trace_printf("Actual project_id11: %d;%s\n", h_project_id_actual_Ind, h_project_id_actual);
         h_month_01_actual := 0.00;
         h_month_02_actual := 0.00;
         h_month_03_actual := 0.00;
         h_month_04_actual := 0.00;
         h_month_05_actual := 0.00;
         h_month_06_actual := 0.00;
         h_month_07_actual := 0.00;
         h_month_08_actual := 0.00;
         h_month_09_actual := 0.00;
         h_month_10_actual := 0.00;
         h_month_11_actual := 0.00;
         h_month_12_actual := 0.00;
      End If;
      
      h_month_01_old := 0.00;
      h_month_02_old := 0.00;
      h_month_03_old := 0.00;
      h_month_04_old := 0.00;
      h_month_05_old := 0.00;
      h_month_06_old := 0.00;
      h_month_07_old := 0.00;
      h_month_08_old := 0.00;
      h_month_09_old := 0.00;
      h_month_10_old := 0.00;
      h_month_11_old := 0.00;
      h_month_12_old := 0.00;
      
      -- read old actual timephase
      BEGIN
         SELECT SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT),
         SUM(MONTH_04_AMOUNT), SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT),
         SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT), SUM(MONTH_09_AMOUNT),
         SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT),
         SUM(TOTAL_AMOUNT), COUNT(*)
         INTO h_month_01_old, h_month_02_old, h_month_03_old,
         h_month_04_old, h_month_05_old, h_month_06_old,
         h_month_07_old, h_month_08_old, h_month_09_old,
         h_month_10_old, h_month_11_old, h_month_12_old,
         h_total_amount_old, h_count_old
         FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID = h_chargecode_id AND BUDGET_YEAR = h_budget_year
         AND BUDGET_TYPE = h_budget_type;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 309+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(310) : timephase.sql(4038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("h_count_old: %d;%d\n", h_count_old_Ind, h_count_old);
      
      -- read delta timephase
      --trace_printf("Read Delta\n");
      BEGIN
         SELECT SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT),
         SUM(MONTH_04_AMOUNT), SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT),
         SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT), SUM(MONTH_09_AMOUNT),
         SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT),
         SUM(TOTAL_AMOUNT), COUNT(*)
         INTO h_month_01_new, h_month_02_new, h_month_03_new,
         h_month_04_new, h_month_05_new, h_month_06_new,
         h_month_07_new, h_month_08_new, h_month_09_new,
         h_month_10_new, h_month_11_new, h_month_12_new,
         h_total_amount_new, h_count_new
         FROM PMO_DELTA_TIMEPHASE
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID = h_chargecode_id AND BUDGET_YEAR = h_budget_year
         AND BUDGET_TYPE = h_budget_type;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 338+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(339) : timephase.sql(4067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count_new, 0) > 0 Then
         --trace_printf("Exists Delta\n");
         If PMO_ORASTD.strcmp(h_project_id, h_id) <> PMO_CNST.SC_MATCH Then
            --trace_printf("Insert Project Delta\n");
            BEGIN
               INSERT INTO PMO_DELTA_TIMEPHASE (
               ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               VALUES (
               h_project_id, h_project_id, h_budget_year,
               h_budget_type, h_chargecode_id,
               h_month_01_new,
               h_month_02_new,
               h_month_03_new,
               h_month_04_new,
               h_month_05_new,
               h_month_06_new,
               h_month_07_new,
               h_month_08_new,
               h_month_09_new,
               h_month_10_new,
               h_month_11_new,
               h_month_12_new,
               h_total_amount_new);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 380+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(381) : timephase.sql(4109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_count_old, 0) > 0 Then
            --trace_printf("Exists Actual Timephase\n");
            If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                  , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                  , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                  , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                  h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
               BEGIN
                  UPDATE PROJECT_BUDGET_BREAKDOWN
                  SET MONTH_01_AMOUNT = MONTH_01_AMOUNT + h_month_01_new + h_month_01_actual,
                  MONTH_02_AMOUNT = MONTH_02_AMOUNT + h_month_02_new + h_month_02_actual,
                  MONTH_03_AMOUNT = MONTH_03_AMOUNT + h_month_03_new + h_month_03_actual,
                  MONTH_04_AMOUNT = MONTH_04_AMOUNT + h_month_04_new + h_month_04_actual,
                  MONTH_05_AMOUNT = MONTH_05_AMOUNT + h_month_05_new + h_month_05_actual,
                  MONTH_06_AMOUNT = MONTH_06_AMOUNT + h_month_06_new + h_month_06_actual,
                  MONTH_07_AMOUNT = MONTH_07_AMOUNT + h_month_07_new + h_month_07_actual,
                  MONTH_08_AMOUNT = MONTH_08_AMOUNT + h_month_08_new + h_month_08_actual,
                  MONTH_09_AMOUNT = MONTH_09_AMOUNT + h_month_09_new + h_month_09_actual,
                  MONTH_10_AMOUNT = MONTH_10_AMOUNT + h_month_10_new + h_month_10_actual,
                  MONTH_11_AMOUNT = MONTH_11_AMOUNT + h_month_11_new + h_month_11_actual,
                  MONTH_12_AMOUNT = MONTH_12_AMOUNT + h_month_12_new + h_month_12_actual,
                  TOTAL_AMOUNT = TOTAL_AMOUNT + h_total_amount_new + h_total_amount_actual
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_YEAR = h_budget_year
                  AND BUDGET_TYPE = h_budget_type;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 423+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(424) : timephase.sql(4152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PROJECT_BUDGET_BREAKDOWN
                  SET MONTH_01_AMOUNT = MONTH_01_AMOUNT + h_month_01_new,
                  MONTH_02_AMOUNT = MONTH_02_AMOUNT + h_month_02_new,
                  MONTH_03_AMOUNT = MONTH_03_AMOUNT + h_month_03_new,
                  MONTH_04_AMOUNT = MONTH_04_AMOUNT + h_month_04_new,
                  MONTH_05_AMOUNT = MONTH_05_AMOUNT + h_month_05_new,
                  MONTH_06_AMOUNT = MONTH_06_AMOUNT + h_month_06_new,
                  MONTH_07_AMOUNT = MONTH_07_AMOUNT + h_month_07_new,
                  MONTH_08_AMOUNT = MONTH_08_AMOUNT + h_month_08_new,
                  MONTH_09_AMOUNT = MONTH_09_AMOUNT + h_month_09_new,
                  MONTH_10_AMOUNT = MONTH_10_AMOUNT + h_month_10_new,
                  MONTH_11_AMOUNT = MONTH_11_AMOUNT + h_month_11_new,
                  MONTH_12_AMOUNT = MONTH_12_AMOUNT + h_month_12_new,
                  TOTAL_AMOUNT = TOTAL_AMOUNT + h_total_amount_new
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_YEAR = h_budget_year
                  AND BUDGET_TYPE = h_budget_type;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 458+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(459) : timephase.sql(4187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
                  h_project_id_actual := h_project_id;
                  h_id_actual := h_id;
                  h_chargecode_id_actual := h_chargecode_id;
                  h_budget_year_actual := h_budget_year;
                  
                  If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
                        OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS'
                        , 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                        , 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                        h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
                        OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
                        , 22) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                        , 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) Then
                     h_month_01_actual := 0.00;
                     h_month_02_actual := 0.00;
                     h_month_03_actual := 0.00;
                     h_month_04_actual := 0.00;
                     h_month_05_actual := 0.00;
                     h_month_06_actual := 0.00;
                     h_month_07_actual := 0.00;
                     h_month_08_actual := 0.00;
                     h_month_09_actual := 0.00;
                     h_month_10_actual := 0.00;
                     h_month_11_actual := 0.00;
                     h_month_12_actual := 0.00;
                     h_total_amount_actual := 0.00;
                  Else
                     If PMO_ORASTD.strcmp(h_project_id, h_id) = PMO_CNST.SC_MATCH Then
                        h_month_01_actual := Coalesce(h_month_01_new, 0);
                        h_month_02_actual := Coalesce(h_month_02_new, 0);
                        h_month_03_actual := Coalesce(h_month_03_new, 0);
                        h_month_04_actual := Coalesce(h_month_04_new, 0);
                        h_month_05_actual := Coalesce(h_month_05_new, 0);
                        h_month_06_actual := Coalesce(h_month_06_new, 0);
                        h_month_07_actual := Coalesce(h_month_07_new, 0);
                        h_month_08_actual := Coalesce(h_month_08_new, 0);
                        h_month_09_actual := Coalesce(h_month_09_new, 0);
                        h_month_10_actual := Coalesce(h_month_10_new, 0);
                        h_month_11_actual := Coalesce(h_month_11_new, 0);
                        h_month_12_actual := Coalesce(h_month_12_new, 0);
                        h_total_amount_actual := Coalesce(h_total_amount_new, 0);
                     Else
                        h_month_01_actual := (Coalesce(h_month_01_new, 0) + Coalesce(h_month_01_old, 0));
                        h_month_02_actual := (Coalesce(h_month_02_new, 0) + Coalesce(h_month_02_old, 0));
                        h_month_03_actual := (Coalesce(h_month_03_new, 0) + Coalesce(h_month_03_old, 0));
                        h_month_04_actual := (Coalesce(h_month_04_new, 0) + Coalesce(h_month_04_old, 0));
                        h_month_05_actual := (Coalesce(h_month_05_new, 0) + Coalesce(h_month_05_old, 0));
                        h_month_06_actual := (Coalesce(h_month_06_new, 0) + Coalesce(h_month_06_old, 0));
                        h_month_07_actual := (Coalesce(h_month_07_new, 0) + Coalesce(h_month_07_old, 0));
                        h_month_08_actual := (Coalesce(h_month_08_new, 0) + Coalesce(h_month_08_old, 0));
                        h_month_09_actual := (Coalesce(h_month_09_new, 0) + Coalesce(h_month_09_old, 0));
                        h_month_10_actual := (Coalesce(h_month_10_new, 0) + Coalesce(h_month_10_old, 0));
                        h_month_11_actual := (Coalesce(h_month_11_new, 0) + Coalesce(h_month_11_old, 0));
                        h_month_12_actual := (Coalesce(h_month_12_new, 0) + Coalesce(h_month_12_old, 0));
                        h_total_amount_actual := (Coalesce(h_total_amount_new, 0) + Coalesce(h_total_amount_old, 0));
                     End If;
                  End If;
               End If;
            End If;
         Else
            If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                  , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                  , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                  , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                  h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                  MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                  MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                  TOTAL_AMOUNT)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, h_chargecode_id,
                  h_month_01_new + h_month_01_actual,
                  h_month_02_new + h_month_02_actual,
                  h_month_03_new + h_month_03_actual,
                  h_month_04_new + h_month_04_actual,
                  h_month_05_new + h_month_05_actual,
                  h_month_06_new + h_month_06_actual,
                  h_month_07_new + h_month_07_actual,
                  h_month_08_new + h_month_08_actual,
                  h_month_09_new + h_month_09_actual,
                  h_month_10_new + h_month_10_actual,
                  h_month_11_new + h_month_11_actual,
                  h_month_12_new + h_month_12_actual,
                  h_total_amount_new + h_total_amount_actual);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 562+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(563) : timephase.sql(4291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                  MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                  MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                  TOTAL_AMOUNT)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, h_chargecode_id,
                  h_month_01_new, h_month_02_new,
                  h_month_03_new, h_month_04_new,
                  h_month_05_new, h_month_06_new,
                  h_month_07_new, h_month_08_new,
                  h_month_09_new, h_month_10_new,
                  h_month_11_new, h_month_12_new,
                  h_total_amount_new);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 594+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(595) : timephase.sql(4323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
                  h_project_id_actual := h_project_id;
                  h_id_actual := h_id;
                  h_chargecode_id_actual := h_chargecode_id;
                  h_budget_year_actual := h_budget_year;
                  
                  If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
                        OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS'
                        , 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                        , 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                        h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
                        OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
                        , 22) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                        , 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) Then
                     h_month_01_actual := 0.00;
                     h_month_02_actual := 0.00;
                     h_month_03_actual := 0.00;
                     h_month_04_actual := 0.00;
                     h_month_05_actual := 0.00;
                     h_month_06_actual := 0.00;
                     h_month_07_actual := 0.00;
                     h_month_08_actual := 0.00;
                     h_month_09_actual := 0.00;
                     h_month_10_actual := 0.00;
                     h_month_11_actual := 0.00;
                     h_month_12_actual := 0.00;
                     h_total_amount_actual := 0.00;
                  Else
                     h_month_01_actual := h_month_01_new;
                     h_month_02_actual := h_month_02_new;
                     h_month_03_actual := h_month_03_new;
                     h_month_04_actual := h_month_04_new;
                     h_month_05_actual := h_month_05_new;
                     h_month_06_actual := h_month_06_new;
                     h_month_07_actual := h_month_07_new;
                     h_month_08_actual := h_month_08_new;
                     h_month_09_actual := h_month_09_new;
                     h_month_10_actual := h_month_10_new;
                     h_month_11_actual := h_month_11_new;
                     h_month_12_actual := h_month_12_new;
                     h_total_amount_actual := h_total_amount_new;
                  End If;
               End If;
            End If;
            
            -- insert average and FTE rows
            If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS'
                  , 13) = PMO_CNST.SC_MATCH) Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_COST'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 664+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(665) : timephase.sql(4393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 685+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(686) : timephase.sql(4414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_RATE'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 706+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(707) : timephase.sql(4435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 727+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(728) : timephase.sql(4456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         --trace_printf("No Delta Timephase records\n");
         If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) <> PMO_CNST.SC_MATCH) 
               AND (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) <> PMO_CNST.SC_MATCH) 
               AND (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) <> PMO_CNST.SC_MATCH) 
               AND (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS', 13) <> PMO_CNST.SC_MATCH) 
               AND (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
               , 22) <> PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS'
               , 13) <> PMO_CNST.SC_MATCH) AND (Coalesce(h_count_old, 0) > 0) Then
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id
               AND CHARGECODE_ID = h_chargecode_id
               AND BUDGET_YEAR = h_budget_year
               AND BUDGET_TYPE = h_budget_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 759+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(760) : timephase.sql(4488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_ORASTD.strcmp(h_project_id, h_id) <> PMO_CNST.SC_MATCH Then
               If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                     , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                     , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                     , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                     h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_actual, h_month_02_actual,
                     h_month_03_actual, h_month_04_actual,
                     h_month_05_actual, h_month_06_actual,
                     h_month_07_actual, h_month_08_actual,
                     h_month_09_actual, h_month_10_actual,
                     h_month_11_actual, h_month_12_actual,
                     h_total_amount_actual);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 797+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(798) : timephase.sql(4526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_old,
                     h_month_02_old,
                     h_month_03_old,
                     h_month_04_old,
                     h_month_05_old,
                     h_month_06_old,
                     h_month_07_old,
                     h_month_08_old,
                     h_month_09_old,
                     h_month_10_old,
                     h_month_11_old,
                     h_month_12_old,
                     h_total_amount_old);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 835+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(836) : timephase.sql(4564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
                     h_project_id_actual := h_project_id;
                     h_id_actual := h_id;
                     h_chargecode_id_actual := h_chargecode_id;
                     h_budget_year_actual := h_budget_year;
                     
                     h_month_01_actual := h_month_01_old;
                     h_month_02_actual := h_month_02_old;
                     h_month_03_actual := h_month_03_old;
                     h_month_04_actual := h_month_04_old;
                     h_month_05_actual := h_month_05_old;
                     h_month_06_actual := h_month_06_old;
                     h_month_07_actual := h_month_07_old;
                     h_month_08_actual := h_month_08_old;
                     h_month_09_actual := h_month_09_old;
                     h_month_10_actual := h_month_10_old;
                     h_month_11_actual := h_month_11_old;
                     h_month_12_actual := h_month_12_old;
                     h_total_amount_actual := h_total_amount_old;
                  End If;
               End If;
            Else
               If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                     , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                     , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                     , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                     h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_old + h_month_01_actual,
                     h_month_02_old + h_month_02_actual,
                     h_month_03_old + h_month_03_actual,
                     h_month_04_old + h_month_04_actual,
                     h_month_05_old + h_month_05_actual,
                     h_month_06_old + h_month_06_actual,
                     h_month_07_old + h_month_07_actual,
                     h_month_08_old + h_month_08_actual,
                     h_month_09_old + h_month_09_actual,
                     h_month_10_old + h_month_10_actual,
                     h_month_11_old + h_month_11_actual,
                     h_month_12_old + h_month_12_actual,
                     h_total_amount_old + h_total_amount_actual);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 900+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(901) : timephase.sql(4629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_old,
                     h_month_02_old,
                     h_month_03_old,
                     h_month_04_old,
                     h_month_05_old,
                     h_month_06_old,
                     h_month_07_old,
                     h_month_08_old,
                     h_month_09_old,
                     h_month_10_old,
                     h_month_11_old,
                     h_month_12_old,
                     h_total_amount_old);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 938+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(939) : timephase.sql(4667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                  , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                  , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                  , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                  h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) AND (Coalesce(
                  h_total_amount_actual, 0) > 0.0) Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                  MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                  MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                  TOTAL_AMOUNT)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, h_chargecode_id,
                  h_month_01_actual,
                  h_month_02_actual,
                  h_month_03_actual,
                  h_month_04_actual,
                  h_month_05_actual,
                  h_month_06_actual,
                  h_month_07_actual,
                  h_month_08_actual,
                  h_month_09_actual,
                  h_month_10_actual,
                  h_month_11_actual,
                  h_month_12_actual,
                  h_total_amount_actual);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 984+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(985) : timephase.sql(4713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- insert average and FTE rows
               If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                     OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS'
                     , 13) = PMO_CNST.SC_MATCH) Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_COST'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1009+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1010) : timephase.sql(4738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1030+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1031) : timephase.sql(4759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_RATE'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1051+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1052) : timephase.sql(4780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1072+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1073) : timephase.sql(4801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_TASK_TP;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1089+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1090) : timephase.sql(4818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Update_Timephase', 1095+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Update_Timephase(1096) : timephase.sql(4824) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Update_Timephase;
ALTER FUNCTION FC_Update_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Copy delta timephase from physical table the temporary table

/*****************************************************************************************/

Prompt == FUNCTION FC_C_Delta_Timephase ==
CREATE OR REPLACE FUNCTION FC_C_Delta_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_Delta_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_Delta_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_C_Delta_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_chargecode_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_Delta_Timephase', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_Delta_Timephase(17) : timephase.sql(4855) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TIMEPHASED_DELTA
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND CHARGECODE_ID = h_chargecode_id AND PROCESS_FLAG = 'I';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_Delta_Timephase', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_Delta_Timephase(36) : timephase.sql(4874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
      MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
      MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND CHARGECODE_ID = h_chargecode_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_Delta_Timephase', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_Delta_Timephase(62) : timephase.sql(4900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND CHARGECODE_ID = h_chargecode_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_Delta_Timephase', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_Delta_Timephase(82) : timephase.sql(4920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_Delta_Timephase', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_Delta_Timephase(88) : timephase.sql(4926) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_Delta_Timephase;
ALTER FUNCTION FC_C_Delta_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Update project timephase after delete tasks.

-- Copy all task timephase marked as 'D' to project delta timephase with reversed value.

-- Delete task timephase

/*****************************************************************************************/

Prompt == FUNCTION FC_D_Task_Timephase ==
CREATE OR REPLACE FUNCTION FC_D_Task_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_Task_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_Task_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_D_Task_Timephase(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_Task_Timephase', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_Task_Timephase(13) : timephase.sql(4957) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'D';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 29+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(30) : timephase.sql(4974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT P1.PROJECT_ID, P1.PROJECT_ID, P1.BUDGET_YEAR, P1.BUDGET_TYPE, P1.CHARGECODE_ID,
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_01_AMOUNT
      ELSE (P1.MONTH_01_AMOUNT - COALESCE(P2.MONTH_01_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_02_AMOUNT
      ELSE (P1.MONTH_02_AMOUNT - COALESCE(P2.MONTH_02_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_03_AMOUNT
      ELSE (P1.MONTH_03_AMOUNT - COALESCE(P2.MONTH_03_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_04_AMOUNT
      ELSE (P1.MONTH_04_AMOUNT - COALESCE(P2.MONTH_04_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_05_AMOUNT
      ELSE (P1.MONTH_05_AMOUNT - COALESCE(P2.MONTH_05_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_06_AMOUNT
      ELSE (P1.MONTH_06_AMOUNT - COALESCE(P2.MONTH_06_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_07_AMOUNT
      ELSE (P1.MONTH_07_AMOUNT - COALESCE(P2.MONTH_07_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_08_AMOUNT
      ELSE (P1.MONTH_08_AMOUNT - COALESCE(P2.MONTH_08_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_09_AMOUNT
      ELSE (P1.MONTH_09_AMOUNT - COALESCE(P2.MONTH_09_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_10_AMOUNT
      ELSE (P1.MONTH_10_AMOUNT - COALESCE(P2.MONTH_10_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_11_AMOUNT
      ELSE (P1.MONTH_11_AMOUNT - COALESCE(P2.MONTH_11_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.MONTH_12_AMOUNT
      ELSE (P1.MONTH_12_AMOUNT - COALESCE(P2.MONTH_12_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN P1.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                      'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                      'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                      'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                      'PMO_PROJECT_TIMEPHASE_CALENDAR__') THEN P1.TOTAL_AMOUNT
      ELSE (P1.TOTAL_AMOUNT - COALESCE(P2.TOTAL_AMOUNT, 0.00)) END) * (-1)
      FROM PROJECT_BUDGET_BREAKDOWN P1 LEFT JOIN PROJECT_BUDGET_BREAKDOWN P2
      ON P1.PROJECT_ID = P2.PROJECT_ID AND P1.ELEMENT_ID = P2.ELEMENT_ID
      AND P1.CHARGECODE_ID = P2.CHARGECODE_ID AND P1.BUDGET_YEAR = P2.BUDGET_YEAR
      AND P2.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET AND P2.PROCESS_FLAG = 'X'
      WHERE P1.PROJECT_ID = h_project_id AND P1.PROCESS_FLAG = 'X'
      AND P1.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 131+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(132) : timephase.sql(5076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1), MONTH_04_AMOUNT * (-1),
      MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1), MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1),
      MONTH_09_AMOUNT * (-1), MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
      TOTAL_AMOUNT * (-1)
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'X' AND BUDGET_TYPE <> PMO_CNST.SC_SCHED_BUDGET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 155+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(156) : timephase.sql(5100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(174) : timephase.sql(5118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_Task_Timephase', 179+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_Task_Timephase(180) : timephase.sql(5124) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_Task_Timephase;
ALTER FUNCTION FC_D_Task_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Transfer a cri task to wbs. Copy existing timephase of the cri task as delta timephase of the project.

/*****************************************************************************************/

Prompt == FUNCTION FC_T_Cri_Timephase ==
CREATE OR REPLACE FUNCTION FC_T_Cri_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_T_Cri_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_T_Cri_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_T_Cri_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_Cri_Timephase', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_T_Cri_Timephase(15) : timephase.sql(5153) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND PROCESS_FLAG = 'T';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(33) : timephase.sql(5171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
      MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
      MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND PROCESS_FLAG = 'X'
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(62) : timephase.sql(5200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT S.PROJECT_ID, S.PROJECT_ID, S.BUDGET_YEAR, S.BUDGET_TYPE, S.CHARGECODE_ID,
      S.MONTH_01_AMOUNT - COALESCE(A.MONTH_01_AMOUNT, 0.00),
      S.MONTH_02_AMOUNT - COALESCE(A.MONTH_02_AMOUNT, 0.00),
      S.MONTH_03_AMOUNT - COALESCE(A.MONTH_03_AMOUNT, 0.00),
      S.MONTH_04_AMOUNT - COALESCE(A.MONTH_04_AMOUNT, 0.00),
      S.MONTH_05_AMOUNT - COALESCE(A.MONTH_05_AMOUNT, 0.00),
      S.MONTH_06_AMOUNT - COALESCE(A.MONTH_06_AMOUNT, 0.00),
      S.MONTH_07_AMOUNT - COALESCE(A.MONTH_07_AMOUNT, 0.00),
      S.MONTH_08_AMOUNT - COALESCE(A.MONTH_08_AMOUNT, 0.00),
      S.MONTH_09_AMOUNT - COALESCE(A.MONTH_09_AMOUNT, 0.00),
      S.MONTH_10_AMOUNT - COALESCE(A.MONTH_10_AMOUNT, 0.00),
      S.MONTH_11_AMOUNT - COALESCE(A.MONTH_11_AMOUNT, 0.00),
      S.MONTH_12_AMOUNT - COALESCE(A.MONTH_12_AMOUNT, 0.00),
      S.TOTAL_AMOUNT - COALESCE(A.TOTAL_AMOUNT, 0.00)
      FROM PROJECT_BUDGET_BREAKDOWN S LEFT JOIN PROJECT_BUDGET_BREAKDOWN A
      ON S.PROJECT_ID = A.PROJECT_ID AND S.ELEMENT_ID = A.ELEMENT_ID
      AND S.CHARGECODE_ID = A.CHARGECODE_ID AND S.BUDGET_YEAR = A.BUDGET_YEAR
      AND A.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET AND A.PROCESS_FLAG = 'X'
      WHERE S.PROJECT_ID = h_project_id
      AND S.ELEMENT_ID = h_id AND S.PROCESS_FLAG = 'X'
      AND S.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND S.CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(103) : timephase.sql(5241) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'I'
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 122+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(123) : timephase.sql(5261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
      MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
      MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(152) : timephase.sql(5290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT S.ELEMENT_ID, S.PROJECT_ID, S.BUDGET_YEAR, S.BUDGET_TYPE, S.CHARGECODE_ID,
      S.MONTH_01_AMOUNT - COALESCE(A.MONTH_01_AMOUNT, 0.00),
      S.MONTH_02_AMOUNT - COALESCE(A.MONTH_02_AMOUNT, 0.00),
      S.MONTH_03_AMOUNT - COALESCE(A.MONTH_03_AMOUNT, 0.00),
      S.MONTH_04_AMOUNT - COALESCE(A.MONTH_04_AMOUNT, 0.00),
      S.MONTH_05_AMOUNT - COALESCE(A.MONTH_05_AMOUNT, 0.00),
      S.MONTH_06_AMOUNT - COALESCE(A.MONTH_06_AMOUNT, 0.00),
      S.MONTH_07_AMOUNT - COALESCE(A.MONTH_07_AMOUNT, 0.00),
      S.MONTH_08_AMOUNT - COALESCE(A.MONTH_08_AMOUNT, 0.00),
      S.MONTH_09_AMOUNT - COALESCE(A.MONTH_09_AMOUNT, 0.00),
      S.MONTH_10_AMOUNT - COALESCE(A.MONTH_10_AMOUNT, 0.00),
      S.MONTH_11_AMOUNT - COALESCE(A.MONTH_11_AMOUNT, 0.00),
      S.MONTH_12_AMOUNT - COALESCE(A.MONTH_12_AMOUNT, 0.00),
      S.TOTAL_AMOUNT - COALESCE(A.TOTAL_AMOUNT, 0.00)
      FROM TIMEPHASED_DELTA S LEFT JOIN TIMEPHASED_DELTA A
      ON S.PROJECT_ID = A.PROJECT_ID AND S.ELEMENT_ID = A.ELEMENT_ID
      AND S.CHARGECODE_ID = A.CHARGECODE_ID AND S.BUDGET_YEAR = A.BUDGET_YEAR
      AND A.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      WHERE S.PROJECT_ID = h_project_id
      AND S.ELEMENT_ID = h_id
      AND S.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND S.CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(193) : timephase.sql(5331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(212) : timephase.sql(5350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_Cri_Timephase', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_Cri_Timephase(218) : timephase.sql(5356) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_T_Cri_Timephase;
ALTER FUNCTION FC_T_Cri_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Update project timephase after delete transferred tasks.

-- Copy all task timephase marked as 'D' to project delta timephase with reversed value.

/*****************************************************************************************/

Prompt == FUNCTION FC_UT_Task_Timephase ==
CREATE OR REPLACE FUNCTION FC_UT_Task_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UT_Task_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UT_Task_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_UT_Task_Timephase(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UT_Task_Timephase', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UT_Task_Timephase(13) : timephase.sql(5385) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'U';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 29+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(30) : timephase.sql(5402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1), MONTH_04_AMOUNT * (-1),
      MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1), MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1),
      MONTH_09_AMOUNT * (-1), MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
      TOTAL_AMOUNT * (-1)
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(56) : timephase.sql(5428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT S.PROJECT_ID, S.PROJECT_ID, S.BUDGET_YEAR, S.BUDGET_TYPE, S.CHARGECODE_ID,
      COALESCE(A.MONTH_01_AMOUNT, 0.00) - S.MONTH_01_AMOUNT,
      COALESCE(A.MONTH_02_AMOUNT, 0.00) - S.MONTH_02_AMOUNT,
      COALESCE(A.MONTH_03_AMOUNT, 0.00) - S.MONTH_03_AMOUNT,
      COALESCE(A.MONTH_04_AMOUNT, 0.00) - S.MONTH_04_AMOUNT,
      COALESCE(A.MONTH_05_AMOUNT, 0.00) - S.MONTH_05_AMOUNT,
      COALESCE(A.MONTH_06_AMOUNT, 0.00) - S.MONTH_06_AMOUNT,
      COALESCE(A.MONTH_07_AMOUNT, 0.00) - S.MONTH_07_AMOUNT,
      COALESCE(A.MONTH_08_AMOUNT, 0.00) - S.MONTH_08_AMOUNT,
      COALESCE(A.MONTH_09_AMOUNT, 0.00) - S.MONTH_09_AMOUNT,
      COALESCE(A.MONTH_10_AMOUNT, 0.00) - S.MONTH_10_AMOUNT,
      COALESCE(A.MONTH_11_AMOUNT, 0.00) - S.MONTH_11_AMOUNT,
      COALESCE(A.MONTH_12_AMOUNT, 0.00) - S.MONTH_12_AMOUNT,
      COALESCE(A.TOTAL_AMOUNT, 0.00) - S.TOTAL_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN S LEFT JOIN PROJECT_BUDGET_BREAKDOWN A
      ON S.PROJECT_ID = A.PROJECT_ID AND S.ELEMENT_ID = A.ELEMENT_ID
      AND S.CHARGECODE_ID = A.CHARGECODE_ID AND S.BUDGET_YEAR = A.BUDGET_YEAR
      AND A.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET AND A.PROCESS_FLAG = 'X'
      WHERE S.PROJECT_ID = h_project_id
      AND S.PROCESS_FLAG = 'X'
      AND S.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(94) : timephase.sql(5466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  BEGIN_SQL
   --      UPDATE PROJECT_BUDGET_BREAKDOWN
   --      SET PROCESS_FLAG = 'I'
   --      WHERE PROJECT_ID = HOST(h_project_id) AND PROCESS_FLAG = 'X';
   --  END_SQL;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(118) : timephase.sql(5490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UT_Task_Timephase', 123+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UT_Task_Timephase(124) : timephase.sql(5496) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UT_Task_Timephase;
ALTER FUNCTION FC_UT_Task_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Delete physical delta timephase when actual_edit flag is 1 (edit actual budget in budget view)

/*****************************************************************************************/

Prompt == FUNCTION FC_Delete_Delta ==
CREATE OR REPLACE FUNCTION FC_Delete_Delta
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Delete_Delta') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Delete_Delta'), '-- ' || SYSTIMESTAMP, ':r := FC_Delete_Delta(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_chargecode_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Delete_Delta', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Delete_Delta(17) : timephase.sql(5527) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      DELETE FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND CHARGECODE_ID = h_chargecode_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Delete_Delta', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Delete_Delta(34) : timephase.sql(5544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Delete_Delta', 39+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Delete_Delta(40) : timephase.sql(5550) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Delete_Delta;
ALTER FUNCTION FC_Delete_Delta COMPILE DEBUG;

/*****************************************************************************************/

-- Copy timephase record to delta table with reversed values and delete from timephase table

-- when actual edit is 0 (input in expense view) with update_bit on

/*****************************************************************************************/

Prompt == FUNCTION FC_C_D_Timephase ==
CREATE OR REPLACE FUNCTION FC_C_D_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_budget_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_budget_type PLS_INTEGER := sh_h_budget_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_D_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_D_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_C_D_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_budget_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_D_Timephase', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_D_Timephase(20) : timephase.sql(5586) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET Then
      BEGIN
         INSERT INTO PMO_DELTA_TIMEPHASE
         SELECT P1.PROJECT_ID, P1.PROJECT_ID, P1.BUDGET_YEAR, P1.BUDGET_TYPE, P1.CHARGECODE_ID,
         (P1.MONTH_01_AMOUNT - COALESCE(P2.MONTH_01_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_02_AMOUNT - COALESCE(P2.MONTH_02_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_03_AMOUNT - COALESCE(P2.MONTH_03_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_04_AMOUNT - COALESCE(P2.MONTH_04_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_05_AMOUNT - COALESCE(P2.MONTH_05_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_06_AMOUNT - COALESCE(P2.MONTH_06_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_07_AMOUNT - COALESCE(P2.MONTH_07_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_08_AMOUNT - COALESCE(P2.MONTH_08_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_09_AMOUNT - COALESCE(P2.MONTH_09_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_10_AMOUNT - COALESCE(P2.MONTH_10_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_11_AMOUNT - COALESCE(P2.MONTH_11_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_12_AMOUNT - COALESCE(P2.MONTH_12_AMOUNT, 0.00))  * (-1),
         (P1.TOTAL_AMOUNT - COALESCE(P2.TOTAL_AMOUNT, 0.00))  * (-1)
         FROM PROJECT_BUDGET_BREAKDOWN P1 LEFT JOIN PROJECT_BUDGET_BREAKDOWN P2
         ON P1.PROJECT_ID = P2.PROJECT_ID AND P1.ELEMENT_ID = P2.ELEMENT_ID
         AND P1.CHARGECODE_ID = P2.CHARGECODE_ID AND P1.BUDGET_YEAR = P2.BUDGET_YEAR
         AND P2.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
         WHERE P1.PROJECT_ID = h_project_id
         AND P1.ELEMENT_ID = h_id AND P1.CHARGECODE_ID = h_chargecode_id
         AND P1.BUDGET_TYPE = h_budget_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_D_Timephase', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_D_Timephase(57) : timephase.sql(5623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_DELTA_TIMEPHASE
         SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
         MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1), MONTH_04_AMOUNT * (-1),
         MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1), MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1),
         MONTH_09_AMOUNT * (-1), MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
         TOTAL_AMOUNT * (-1)
         FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_id AND CHARGECODE_ID = h_chargecode_id
         AND BUDGET_TYPE = h_budget_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_D_Timephase', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_D_Timephase(83) : timephase.sql(5649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_budget_type;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_D_Timephase', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_D_Timephase(104) : timephase.sql(5670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_D_Timephase', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_D_Timephase(110) : timephase.sql(5676) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_D_Timephase;
ALTER FUNCTION FC_C_D_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Rollup Task TimePhase to Project TimePhase

/*****************************************************************************************/

Prompt == FUNCTION FC_Timephase_CRI_Task ==
CREATE OR REPLACE FUNCTION FC_Timephase_CRI_Task
(
     h_p_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_column_type PLS_INTEGER := 0;
   h_timephase_bits PLS_INTEGER := 0;
   h_budget_timephase_bits PLS_INTEGER := 0;
   h_unresolved_start TIMESTAMP;
   h_unresolved_finish TIMESTAMP;
   h_chargecode_id VARCHAR2(32);
   h_current_budget NUMBER := 0;
   h_actual_budget NUMBER := 0;
   h_actual_edited PLS_INTEGER := 0;
   h_previous_project_id VARCHAR2(32);
   h_timephase_flag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      CURSOR C_CRITASK IS
         SELECT W1.PROJECT_ID, W1.ELEMENT_ID, W1.TIMEPHASED_BITS,
         TO_DATE(SubStr(W1.UNRESOLVED_START, 1, 10)), TO_DATE(SubStr(W1.UNRESOLVED_FINISH, 1, 10))
         FROM TMT_CRI W1
         WHERE W1.PROJECT_ID = h_project_id
         AND WBS_ID IS NuLL AND W1.TIMEPHASED_BITS > 0 AND W1.LEVEL_ID > 1
         AND TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,PMO_CNST.SC_CRI_ACTION_ITEM_TASK,PMO_CNST.SC_CRI_RISK_TASK,PMO_CNST.SC_CRI_ISSUE_TASK,PMO_CNST.SC_CRI_REQUIREMENT_TASK,PMO_CNST.SC_CRI_DEFECT_TASK,PMO_CNST.SC_SERVICE_REQUEST_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE)
         ORDER BY W1.PROJECT_ID;

      CURSOR C_CRIBUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS
         FROM BUDGETS B
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID = h_id;

      CURSOR C_U_CRIBUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS
         FROM BUDGETS B
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID = h_id AND B.TIMEPHASED_BITS > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Timephase_CRI_Task') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Timephase_CRI_Task'), '-- ' || SYSTIMESTAMP, ':r := FC_Timephase_CRI_Task(' || 
       '''' || h_p_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Timephase_CRI_Task', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Timephase_CRI_Task(47) : timephase.sql(5737) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := h_p_project_id;
   h_previous_project_id := '';
   
   -- select all (dirty) projects under the current rank
   
   OPEN C_CRITASK;
   
   LOOP
      FETCH C_CRITASK INTO h_project_id, h_id, h_timephase_bits,
      h_unresolved_start, h_unresolved_finish;
      IF C_CRITASK%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_previous_project_id, h_project_id) <> PMO_CNST.SC_MATCH Then
         h_previous_project_id := h_project_id;
         
         If PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH Then
            COMMIT;
         End If;
      End If;
      
      If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_UPDATE_DATE_BIT)) > 0 Then
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_CRIBUDGETS;
         
         LOOP
            FETCH C_CRIBUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited, h_budget_timephase_bits;
            IF C_CRIBUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               EXIT;
            End If;
            
            If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
                  , 22) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'CAPITAL_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_AVERAGE_RATE'
                  , 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'EXPENSE_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT'
                  , 28) = PMO_CNST.SC_MATCH) Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            Else
               If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.0 Then
                  h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                  h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                  --                      h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
               End If;
               
               If Coalesce(h_actual_edited, 0) = 1 Then
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                     h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
                  End If;
                  
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                  --if (h_actual_budget > 0)
                  --{
                  --                          h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_actual_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                  --}
               Else
                  --                      InitializeHost(SC_PARAM(h_column_type), SC_ACTUAL_BUDGET);
                  --                      if ((h_budget_timephase_bits  SC_UPDATE_ACTUAL_BUDGET_BIT) > 0)
                  --                      {
                  --                          h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                  --                      }
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            End If;
            
            If Coalesce(h_budget_timephase_bits, 0) > 0 Then
               BEGIN
                  UPDATE BUDGETS
                  SET TIMEPHASED_BITS = 0
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 162+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(163) : timephase.sql(5853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CRIBUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 176+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(177) : timephase.sql(5867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         
         BEGIN
            UPDATE TMT_CRI SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(197) : timephase.sql(5887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_U_CRIBUDGETS;
         
         LOOP
            FETCH C_U_CRIBUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited, h_budget_timephase_bits;
            IF C_U_CRIBUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               EXIT;
            End If;
            
            If (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
                  , 22) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'EXPENSE_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_AVERAGE_COST'
                  , 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'BENEFIT_AVERAGE_RATE', 20) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT'
                  , 28) = PMO_CNST.SC_MATCH) Then
               h_actual_edited := 0;
            End If;
            
            If Coalesce(h_actual_edited, 0) = 1 Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
               End If;
               
               If (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT)) > 0 Then
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  --if (h_actual_budget > 0.00)
                  --{
                  --                          h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_actual_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                  --}
                  
                  If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                     h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                     h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                     --                          h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                  End If;
               End If;
            Else
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               Else
                  h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                  h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
               End If;
            End If;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = 0
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
               AND CHARGECODE_ID = h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 282+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(283) : timephase.sql(5973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         BEGIN
            CLOSE C_U_CRIBUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 295+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(296) : timephase.sql(5986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         
         BEGIN
            UPDATE TMT_CRI SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(316) : timephase.sql(6006) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_CRITASK ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(330) : timephase.sql(6020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Timephase_CRI_Task', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Timephase_CRI_Task(336) : timephase.sql(6026) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Timephase_CRI_Task;
ALTER FUNCTION FC_Timephase_CRI_Task COMPILE DEBUG;

/*****************************************************************************************/

-- Rollup Task TimePhase to Project TimePhase

/*****************************************************************************************/

Prompt == FUNCTION FC_Rollup_Timephase ==
CREATE OR REPLACE FUNCTION FC_Rollup_Timephase
(
     h_p_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_previous_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_column_type PLS_INTEGER := 0;
   h_timephase_bits PLS_INTEGER := 0;
   h_budget_timephase_bits PLS_INTEGER := 0;
   h_start_finish_date DATE;
   h_finish_start_date DATE;
   h_unresolved_start TIMESTAMP;
   h_unresolved_finish TIMESTAMP;
   h_previous_project_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_current_budget NUMBER := 0;
   h_actual_budget NUMBER := 0;
   h_actual_edited PLS_INTEGER := 0;
   h_timephase_flag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      CURSOR C_TIMEPHASE IS
         SELECT W1.PROJECT_ID, W1.TYPE_ID, W1.ELEMENT_ID, W1.TIMEPHASED_BITS,
         TO_DATE(SubStr(W1.UNRESOLVED_START, 1, 10)), TO_DATE(SubStr(W1.UNRESOLVED_FINISH, 1, 10)),
         TO_DATE(SubStr(W1.START_FINISH_DATE, 1, 10)), TO_DATE(SubStr(W1.FINISH_START_DATE, 1, 10))
         FROM TMT_WBS W1
         WHERE W1.PROJECT_ID = h_project_id AND W1.TIMEPHASED_BITS > 0
         ORDER BY PROJECT_ID, W1.RANK DESC;

      CURSOR C_BUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS
         FROM BUDGETS B
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID = h_id;

      CURSOR C_U_BUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS
         FROM BUDGETS B
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_id
         AND B.TIMEPHASED_BITS > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Rollup_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Rollup_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_Rollup_Timephase(' || 
       '''' || h_p_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rollup_Timephase', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Rollup_Timephase(52) : timephase.sql(6092) : ' || SYSTIMESTAMP);
   END IF; 

   h_previous_project_id := '';
   h_project_id := h_p_project_id;
   
   --trace_printf("***** h_project_id = %d:%s *****\n",h_project_id_Ind,h_project_id);
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NEW_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DELTA_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CHANGED_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- select all (dirty) projects under the current rank
   
   OPEN C_TIMEPHASE;
   
   LOOP
      FETCH C_TIMEPHASE INTO h_project_id, h_type, h_id, h_timephase_bits,
      h_unresolved_start, h_unresolved_finish,
      h_start_finish_date, h_finish_start_date;
      IF C_TIMEPHASE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         If PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH Then
            If PMO_ORASTD.strcmp(h_previous_project_id, h_previous_id) <> PMO_CNST.SC_MATCH Then
               h_temp_sc_state := FC_Update_Timephase(h_previous_project_id, h_previous_project_id);
            End If;
            
            /*              BEGIN_SQL
                                DELETE FROM SESSION.PMO_NEW_TIMEPHASE;
                            END_SQL;
            
                            BEGIN_SQL
                                DELETE FROM SESSION.PMO_DELTA_TIMEPHASE;
                            END_SQL;
            
                            BEGIN_SQL
                                DELETE FROM SESSION.PMO_CHANGED_TIMEPHASE;
                            END_SQL;
            */
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_FLAG = 0
               WHERE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID) IN
               (SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND CHARGECODE_ID NOT LIKE '%_AVERAGE%'
               GROUP BY PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               HAVING SUM(TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 122+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(123) : timephase.sql(6163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND (ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE)
               IN (SELECT ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                               'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                               'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                               'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                               'PMO_PROJECT_TIMEPHASE_CALENDAR__')
               GROUP BY ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE
               HAVING SUM(TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 151+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(152) : timephase.sql(6192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         EXIT;
      End If;
      
      --trace_printf("***** h_project_id = %d:%s *****\n",h_project_id_Ind,h_project_id);
      --trace_printf("***** h_element_id = %d:%s *****\n",h_id_Ind,h_id);
      --trace_printf("***** h_timephase_bits = %d:%d *****\n",h_timephase_bits_Ind,h_timephase_bits);
      --trace_printf("***** h_type = %d:%d *****\n",h_type_Ind,h_type);
      --trace_printf("***** h_unresolved_start = %d:%s *****\n",h_unresolved_start_Ind,h_unresolved_start);
      --trace_printf("***** h_unresolved_finish = %d:%s *****\n",h_unresolved_finish_Ind,h_unresolved_finish);
      --trace_printf("***** h_start_finish_date = %d:%s *****\n",h_start_finish_date_Ind,h_start_finish_date);
      --trace_printf("***** h_finish_start_date = %d:%s *****\n",h_finish_start_date_Ind,h_finish_start_date);
      If PMO_ORASTD.strcmp(h_project_id, h_previous_project_id) <> PMO_CNST.SC_MATCH Then
         If (PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(
               h_previous_project_id, h_previous_id) <> PMO_CNST.SC_MATCH) Then
            h_temp_sc_state := FC_Update_Timephase(h_previous_project_id, h_previous_project_id);
            
            BEGIN
               DELETE FROM PMO_NEW_TIMEPHASE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 184+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(185) : timephase.sql(6225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PMO_DELTA_TIMEPHASE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 201+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(202) : timephase.sql(6242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PMO_CHANGED_TIMEPHASE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 218+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(219) : timephase.sql(6259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_FLAG = 0
               WHERE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID) IN
               (SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND CHARGECODE_ID NOT LIKE '%_AVERAGE%'
               GROUP BY PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               HAVING SUM(TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 243+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(244) : timephase.sql(6284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND (ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE)
               IN (SELECT ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND CHARGECODE_ID NOT IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR', 
                               'EXPENSE_HOURS', 'EXPENSE_AVERAGE_COST', 'EXPENSE_FULL_TIME_EQUIVALENT', 
                               'CAPITAL_HOURS', 'CAPITAL_AVERAGE_COST', 'CAPITAL_FULL_TIME_EQUIVALENT', 
                               'BENEFIT_HOURS', 'BENEFIT_AVERAGE_RATE', 'BENEFIT_FULL_TIME_EQUIVALENT', 
                               'PMO_PROJECT_TIMEPHASE_CALENDAR__')
               GROUP BY ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE
               HAVING SUM(TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 272+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(273) : timephase.sql(6313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH Then
            COMMIT;
         End If;
         
         h_previous_project_id := h_project_id;
      End If;
      h_previous_id := h_id;
      
      If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_UPDATE_DATE_BIT)) > 0 Then
         --trace_printf("Dates changed\n");
         -- transferred a cri task to wbs,
         -- set flag in timephase table to T if the original flag is not 'U' else set to null
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_TRANSFERRED_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_T_Cri_Timephase(h_project_id, h_id);
         End If;
         
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_BUDGETS;
         
         LOOP
            FETCH C_BUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited, h_budget_timephase_bits;
            IF C_BUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               EXIT;
            End If;
            
            --trace_printf("***** h_current_budget = %d:%f *****\n",h_current_budget_Ind,h_current_budget);
            --trace_printf("***** h_actual_budget = %d:%f *****\n",h_actual_budget_Ind,h_actual_budget);
            --trace_printf("***** h_chargecode_id = %d:%s *****\n",h_chargecode_id_Ind,h_chargecode_id);
            --trace_printf("***** h_actual_edited = %d:%d *****\n",h_actual_edited_Ind,h_actual_edited);
            --trace_printf("***** h_timephase_bits = %d:%d *****\n",h_timephase_bits_Ind,h_timephase_bits);
            If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
                  , 22) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'CAPITAL_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_AVERAGE_RATE'
                  , 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'EXPENSE_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT'
                  , 28) = PMO_CNST.SC_MATCH) Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            Else
               h_column_type := PMO_CNST.SC_SCHED_BUDGET;
               h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
               If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                  h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                  h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                  h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
               End If;
               
               If Coalesce(h_actual_edited, 0) = 1 Then
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                     h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
                  End If;
                  
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                  If Coalesce(h_actual_budget, 0) > 0.00 Then
                     h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                  End If;
               Else
                  --                      InitializeHost(SC_PARAM(h_column_type), SC_ACTUAL_BUDGET);
                  --                      if ((h_budget_timephase_bits  SC_UPDATE_ACTUAL_BUDGET_BIT) > 0)
                  --                      {
                  --                          h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                  --                      }
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            End If;
            
            If Coalesce(h_budget_timephase_bits, 0) > 0 Then
               BEGIN
                  UPDATE BUDGETS
                  SET TIMEPHASED_BITS = 0
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 386+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(387) : timephase.sql(6427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE C_BUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 400+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(401) : timephase.sql(6441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         
         BEGIN
            UPDATE TMT_WBS SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 420+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(421) : timephase.sql(6461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- transferred a cri task to wbs,
         -- set flag in timephase table to T if the original flag is not 'U' else set to null
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_TRANSFERRED_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_T_Cri_Timephase(h_project_id, h_id);
            
            h_budget_timephase_bits := PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT;
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = h_budget_timephase_bits
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 446+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(447) : timephase.sql(6487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_DELETE_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_D_Task_Timephase(h_project_id);
         End If;
         
         -- delete a transferred task from wbs,
         -- set flag in timephase table to U if the original flag is not 'T' else set to 'I'
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_DELETE_TRANSFERRED_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_UT_Task_Timephase(h_project_id);
         End If;
         
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_U_BUDGETS;
         
         LOOP
            FETCH C_U_BUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited, h_budget_timephase_bits;
            IF C_U_BUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               EXIT;
            End If;
            
            --trace_printf("***** h_current_budget = %d:%f *****\n",h_current_budget_Ind,h_current_budget);
            --trace_printf("***** h_actual_budget = %d:%f *****\n",h_actual_budget_Ind,h_actual_budget);
            --trace_printf("***** h_chargecode_id = %d:%s *****\n",h_chargecode_id_Ind,h_chargecode_id);
            --trace_printf("***** h_actual_edited = %d:%d *****\n",h_actual_edited_Ind,h_actual_edited);
            --trace_printf("***** h_timephase_bits = %d:%d *****\n",h_timephase_bits_Ind,h_timephase_bits);
            
            If (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_LABOR', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BILLABLE_BENEFIT_LABOR'
                  , 22) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'EXPENSE_AVERAGE_COST', 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'EXPENSE_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_AVERAGE_COST'
                  , 20) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(h_chargecode_id
                  , 'CAPITAL_FULL_TIME_EQUIVALENT', 28) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strncmp(
                  h_chargecode_id, 'BENEFIT_AVERAGE_RATE', 20) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_FULL_TIME_EQUIVALENT'
                  , 28) = PMO_CNST.SC_MATCH) Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            Else
               If Coalesce(h_actual_edited, 0) = 1 Then
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                     --                          h_temp_sc_state = FC_C_Delta_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id));
                     h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
                  End If;
                  
                  --                      if ((h_budget_timephase_bits  SC_UPDATE_ACTUAL_BUDGET_BIT) > 0)
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT)) > 0) Then
                     --trace_printf("Actual Changed\n");
                     If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_finish_start_date, h_column_type);
                        End If;
                        --                              else if (h_current_budget == 0.00)
                        --                              {
                        --                                  InitializeHost(SC_PARAM(h_column_type), SC_SCHED_BUDGET);
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                        
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If Coalesce(h_actual_budget, 0) > 0.00 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_finish_start_date, h_column_type);
                        End If;
                        --                              else
                        --                              {
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                     Else
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                        --                              else if (h_current_budget == 0.00)
                        --                              {
                        --                                  InitializeHost(SC_PARAM(h_column_type), SC_SCHED_BUDGET);
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                        
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        --                              if ((h_budget_timephase_bits  SC_ACTUAL_DELTA_BIT) == 0)
                        --                              {
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        --                              }
                        
                        If Coalesce(h_actual_budget, 0) > 0.00 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                        --                              else
                        --                              {
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                     End If;
                  ElsIf (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT)) > 0 Then
                     --trace_printf("Sched Changed\n");
                     If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        
                        --trace_printf("h_current_budget: %d;%f\n", h_current_budget_Ind, h_current_budget);
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                        
                        If Coalesce(h_actual_budget, 0) > 0.00 Then
                           h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                           h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                           
                           If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                           Else
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                           End If;
                        End If;
                     ElsIf Coalesce(h_current_budget, 0) = 0.00 Then
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                     Else
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                        
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        --                              if (isProjectType(h_type))
                        --                                  h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_start_finish_date), SC_PARAM(h_start_finish_date), SC_PARAM(h_column_type));
                        --                              else
                        --                                  h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                        
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                     End If;
                  End If;
               Else
                  --trace_printf("Auto edit actual\n");
                  If (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0 Then
                     h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
                     
                     h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                     h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                     If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                        h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                     End If;
                  ElsIf (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0 Then
                     h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
                  Else
                     --trace_printf("Changed\n");
                     If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT)) > 0) 
                           AND (Coalesce(h_actual_budget, 0) > 0.00) Then
                        --trace_printf("Actual Changed\n");
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                     End If;
                     
                     If (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT)) > 0 Then
                        --trace_printf("Sched Changed\n");
                        If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.00 Then
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                           h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                           If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                           Else
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                           End If;
                        Else
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           If NOT isProjectType(Coalesce(h_type, 0)) <> 0 Then
                              h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                           End If;
                        End If;
                     End If;
                  End If;
               End If;
            End If;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = 0
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
               AND CHARGECODE_ID = h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 701+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(702) : timephase.sql(6742) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         BEGIN
            CLOSE C_U_BUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 714+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(715) : timephase.sql(6755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         BEGIN
            UPDATE TMT_WBS SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 733+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(734) : timephase.sql(6774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_TIMEPHASE ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 747+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(748) : timephase.sql(6788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rollup_Timephase', 753+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Rollup_Timephase(754) : timephase.sql(6794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Rollup_Timephase;
ALTER FUNCTION FC_Rollup_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Rollup TimePhase to Project TimePhase

/*****************************************************************************************/

Prompt == FUNCTION SP_ROLLUP_TIMEPHASE ==
CREATE OR REPLACE FUNCTION SP_ROLLUP_TIMEPHASE
(
     p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TP_PROJECT IS
         SELECT PROJECT_ID
         FROM TIMEPHASED_PROJECT
         WHERE FLAG = 'X';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ROLLUP_TIMEPHASE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ROLLUP_TIMEPHASE'), '-- ' || SYSTIMESTAMP, ':r := SP_ROLLUP_TIMEPHASE(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ROLLUP_TIMEPHASE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ROLLUP_TIMEPHASE(24) : timephase.sql(6832) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_project_id := p_project_id;
   
   If (h_project_id IS NULL) Then
      BEGIN
         UPDATE TIMEPHASED_PROJECT
         SET FLAG = 'X'
         WHERE FLAG = 'I';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 45+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(46) : timephase.sql(6854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_TP_PROJECT;
      
      LOOP
         FETCH C_TP_PROJECT INTO h_project_id;
         IF C_TP_PROJECT%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         --trace_printf("h_project_id: %d;%s\n", h_project_id_Ind, h_project_id);
         PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
         PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE C_TP_PROJECT ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(79) : timephase.sql(6887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TIMEPHASED_PROJECT WHERE FLAG = 'X';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(96) : timephase.sql(6904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --trace_printf("h_project_id: %d;%s\n", h_project_id_Ind, h_project_id);
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
      
      BEGIN
         DELETE FROM TIMEPHASED_PROJECT
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(118) : timephase.sql(6926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   End If;
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ROLLUP_TIMEPHASE', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ROLLUP_TIMEPHASE(130) : timephase.sql(6938) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(137) : timephase.sql(6945) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(149) : timephase.sql(6957) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ROLLUP_TIMEPHASE;
ALTER FUNCTION SP_ROLLUP_TIMEPHASE COMPILE DEBUG;

-- END TIMEPHASE

/*****************************************************************************************/

-- rebuild sched timephase records for labor related chargecodes from task_day_of_year

/*****************************************************************************************/

Prompt == FUNCTION FC_Rebuild_Labor_Timephase ==
CREATE OR REPLACE FUNCTION FC_Rebuild_Labor_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_timephase_flag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Rebuild_Labor_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Rebuild_Labor_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_Rebuild_Labor_Timephase(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rebuild_Labor_Timephase', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Rebuild_Labor_Timephase(14) : timephase.sql(6993) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
   PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM Lev_delta_tmy';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- expense
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'EXPENSE_HOURS', 
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN), SUM(TDY.SCHED_MIN * TA.REGULAR_COST)/60.00
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID <> TA.TASK_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_EXPENSE
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(51) : timephase.sql(7030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'EXPENSE_HOURS', 
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN-TA.LAST_SCHED_MIN), SUM((TDY.SCHED_MIN-TA.LAST_SCHED_MIN) * TA.REGULAR_COST)/60.00
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID = h_project_id AND TA.LAST_SCHED_MIN > 0
      AND TA.PROJECT_ID <> TA.TASK_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.LAST_SUBMITTED = TDY.DAY_YEAR
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_EXPENSE
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(78) : timephase.sql(7057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- capital
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'CAPITAL_HOURS', 
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN), SUM(TDY.SCHED_MIN * TA.REGULAR_COST)/60.00
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID <> TA.TASK_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_CAPITAL
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 105+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(106) : timephase.sql(7085) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'EXPENSE_HOURS', 
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN-TA.LAST_SCHED_MIN), SUM((TDY.SCHED_MIN-TA.LAST_SCHED_MIN) * TA.REGULAR_COST)/60.00
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID = h_project_id AND TA.LAST_SCHED_MIN > 0
      AND TA.PROJECT_ID <> TA.TASK_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.LAST_SUBMITTED = TDY.DAY_YEAR
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_CAPITAL
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 132+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(133) : timephase.sql(7112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- benefits
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'BENEFIT_HOURS', 
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN), SUM(TDY.SCHED_MIN * TA.REGULAR_RATE)/60.00
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID <> TA.TASK_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.BILLABLE = PMO_CNST.SC_BILLABLE_YES
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 160+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(161) : timephase.sql(7140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'EXPENSE_HOURS', 
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN-TA.LAST_SCHED_MIN), SUM((TDY.SCHED_MIN-TA.LAST_SCHED_MIN) * TA.REGULAR_COST)/60.00
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id
      AND TA.PROJECT_ID = h_project_id AND TA.LAST_SCHED_MIN > 0
      AND TA.PROJECT_ID <> TA.TASK_ID
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.LAST_SUBMITTED = TDY.DAY_YEAR
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_BILLABLE_YES
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 187+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(188) : timephase.sql(7167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_timephase_flag := 0;
   BEGIN
      SELECT SETTING_VALUE + 1 INTO h_timephase_flag
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_PERIOD';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 203+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(204) : timephase.sql(7183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- for latest version we have to join to fiscal calendar table to fix year and month!!!!!!!!!
   If Coalesce(h_timephase_flag, 0) > 1 Then
      BEGIN
         UPDATE Lev_delta_tmy
         SET BUDGET_YEAR = CASE WHEN BUDGET_MONTH < h_timephase_flag THEN (BUDGET_YEAR - 1) ELSE BUDGET_YEAR END,
         BUDGET_MONTH = CASE WHEN BUDGET_MONTH >= h_timephase_flag
         THEN (BUDGET_MONTH - h_timephase_flag + 1)
         ELSE (BUDGET_MONTH + 12 - h_timephase_flag + 1) END
         WHERE 1 = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 227+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(228) : timephase.sql(7207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR','EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 248+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(249) : timephase.sql(7228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_TIMEPHASE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, TASK_ID, CHARGECODE_ID, BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      SUM(BUDGET_HOURS)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 1 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 2 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 3 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 4 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 5 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 6 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 7 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 8 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 9 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 10 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 11 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 12 THEN BUDGET_HOURS ELSE 0 END)/60.00
      FROM Lev_delta_tmy
      GROUP BY TASK_ID, CHARGECODE_ID, BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 283+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(284) : timephase.sql(7263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_TIMEPHASE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, TASK_ID,
      CASE WHEN CHARGECODE_ID = 'BENEFIT_HOURS' THEN 'BILLABLE_BENEFIT_LABOR' ELSE REPLACE(CHARGECODE_ID, '_HOURS', '_LABOR') END,
      BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      SUM(BUDGET_AMOUNT),
      SUM(CASE WHEN BUDGET_MONTH = 1 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 2 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 3 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 4 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 5 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 6 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 7 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 8 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 9 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 10 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 11 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 12 THEN BUDGET_AMOUNT ELSE 0 END)
      FROM Lev_delta_tmy
      GROUP BY TASK_ID, CHARGECODE_ID, BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 320+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(321) : timephase.sql(7300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_TIMEPHASE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND PROJECT_ID <> ELEMENT_ID
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR','EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 347+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(348) : timephase.sql(7327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      (SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE,
      SUM(TOTAL_AMOUNT),
      SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT), SUM(MONTH_04_AMOUNT),
      SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT), SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT),
      SUM(MONTH_09_AMOUNT), SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT)
      FROM PMO_TMP_TIMEPHASE
      GROUP BY PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 373+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(374) : timephase.sql(7353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      (SELECT PROJECT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE,
      SUM(TOTAL_AMOUNT),
      SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT), SUM(MONTH_04_AMOUNT),
      SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT), SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT),
      SUM(MONTH_09_AMOUNT), SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT)
      FROM PMO_TMP_TIMEPHASE
      GROUP BY PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 399+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(400) : timephase.sql(7379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --BEGIN_SQL
   --    INSERT INTO PROJECT_BUDGET_BREAKDOWN (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
   --        MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
   --        MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
   --    (SELECT PROJECT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE,
   --        SUM(TOTAL_AMOUNT),
   --        SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT), SUM(MONTH_04_AMOUNT),
   --        SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT), SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT),
   --        SUM(MONTH_09_AMOUNT), SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT)
   --    FROM PROJECT_BUDGET_BREAKDOWN
   --    WHERE PROJECT_ID = HOST(h_project_id)
   --        AND PROJECT_ID != ELEMENT_ID
   --        AND BUDGET_TYPE = SC_SCHED_BUDGET
   --        AND CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR','EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS')
   --    GROUP BY PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE);
   --END_SQL;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rebuild_Labor_Timephase', 422+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Rebuild_Labor_Timephase(423) : timephase.sql(7402) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Rebuild_Labor_Timephase;
ALTER FUNCTION FC_Rebuild_Labor_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- rebuild sched timephase records for labor related chargecodes from task_day_of_year

/*****************************************************************************************/

Prompt == FUNCTION SP_REBUILD_LABOR_TIMEPHASE ==
CREATE OR REPLACE FUNCTION SP_REBUILD_LABOR_TIMEPHASE
(
     p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_c_chargecode_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER;
   null_return LONG;
   ora_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR CB_PRJ IS
         select DISTINCT b.PROJECT_ID from BUDGETS b 
         where b.PROJECT_ID = b.ELEMENT_ID AND b.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR','EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS')
         AND EXISTS (SELECT pb.PROJECT_ID FROM PROJECT_BUDGET_BREAKDOWN pb 
         WHERE b.PROJECT_ID = pb.PROJECT_ID AND b.ELEMENT_ID = pb.ELEMENT_ID AND pb.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET AND pb.CHARGECODE_ID = b.CHARGECODE_ID)
         AND b.BUDGET <> (SELECT SUM(pbb.TOTAL_AMOUNT) FROM PROJECT_BUDGET_BREAKDOWN pbb 
         WHERE b.PROJECT_ID = pbb.PROJECT_ID AND b.ELEMENT_ID = pbb.ELEMENT_ID AND pbb.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET AND pbb.CHARGECODE_ID = b.CHARGECODE_ID);

      CURSOR CB_CHARGECODES IS
         select b.ELEMENT_ID, b.CHARGECODE_ID from BUDGETS b 
         where b.PROJECT_ID = h_project_id AND b.CHARGECODE_ID IN ('EXPENSE_LABOR', 'CAPITAL_LABOR', 'BILLABLE_BENEFIT_LABOR','EXPENSE_HOURS', 'CAPITAL_HOURS', 'BENEFIT_HOURS')
         AND b.BUDGET <> COALESCE((SELECT SUM(pbb.TOTAL_AMOUNT) FROM PROJECT_BUDGET_BREAKDOWN pbb 
         WHERE pbb.PROJECT_ID = h_project_id AND pbb.ELEMENT_ID = b.ELEMENT_ID AND pbb.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET AND pbb.CHARGECODE_ID = b.CHARGECODE_ID),0)
         ORDER BY b.ELEMENT_ID;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_REBUILD_LABOR_TIMEPHASE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_REBUILD_LABOR_TIMEPHASE'), '-- ' || SYSTIMESTAMP, ':r := SP_REBUILD_LABOR_TIMEPHASE(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_REBUILD_LABOR_TIMEPHASE', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_REBUILD_LABOR_TIMEPHASE(41) : timephase.sql(7457) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_project_id IS NULL) Then
      --RETURN_ERROR(INVALID_PARAMS, *p_project_id);
      h_project_id := NULL;
      
      OPEN CB_PRJ;
      
      LOOP
         FETCH CB_PRJ INTO h_project_id;
         IF CB_PRJ%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            EXIT;
         End If;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_WBS
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 73+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(74) : timephase.sql(7490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_count := 0;
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_WBS 
               WHERE RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 90+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(91) : timephase.sql(7507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) = 1 Then
               -- Fix project time phase
               ora_temp_sc_state := PMO_DB2M.SC_STATE;
               null_return := FC_Rebuild_Labor_Timephase(h_project_id);
               PMO_DB2M.SC_STATE := ora_temp_sc_state;
               
               -- Fix project budgets
               h_id := NULL;
               
               OPEN CB_CHARGECODES;
               
               LOOP
                  FETCH CB_CHARGECODES INTO h_task_id, h_c_chargecode_id;
                  IF CB_CHARGECODES%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                     EXIT;
                  End If;
                  
                  BEGIN
                     UPDATE BUDGETS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_UPDATE_BUDGET_BIT)
                     WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id AND CHARGECODE_ID = h_c_chargecode_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(132) : timephase.sql(7548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (h_id IS NULL) OR (PMO_ORASTD.strcmp(h_id, h_task_id) <> 0) Then
                     If (h_id IS NOT NULL) Then
                        BEGIN
                           UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_UPDATE_BUDGET_BIT)
                           WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 151+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(152) : timephase.sql(7568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     
                     h_id := h_task_id;
                  End If;
               END LOOP;
               
               If (h_id IS NOT NULL) Then
                  BEGIN
                     UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_UPDATE_BUDGET_BIT)
                     WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 175+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(176) : timephase.sql(7592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               BEGIN
                  CLOSE CB_CHARGECODES ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 189+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(190) : timephase.sql(7606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If (h_project_id IS NOT NULL) Then
               ora_temp_sc_state := PMO_DB2M.SC_STATE;
               null_return := FC_Rollup(h_project_id);
               PMO_DB2M.SC_STATE := ora_temp_sc_state;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE CB_PRJ ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 211+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(212) : timephase.sql(7628) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_project_id := p_project_id;
      PMO_DB2M.SC_STATE := FC_Rebuild_Labor_Timephase(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_REBUILD_LABOR_TIMEPHASE', 221+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_REBUILD_LABOR_TIMEPHASE(222) : timephase.sql(7638) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 228+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(229) : timephase.sql(7645) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 240+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(241) : timephase.sql(7657) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_REBUILD_LABOR_TIMEPHASE;
ALTER FUNCTION SP_REBUILD_LABOR_TIMEPHASE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_LEVELED_EX ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_LEVELED_EX RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_SD DATE;
   h_FD DATE;
   h_period_start DATE;
   h_period_finish DATE;
   h_chargecode_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_total_amount NUMBER := 0;
   h_month_01_flag PLS_INTEGER := 0;
   h_month_02_flag PLS_INTEGER := 0;
   h_month_03_flag PLS_INTEGER := 0;
   h_month_04_flag PLS_INTEGER := 0;
   h_month_05_flag PLS_INTEGER := 0;
   h_month_06_flag PLS_INTEGER := 0;
   h_month_07_flag PLS_INTEGER := 0;
   h_month_08_flag PLS_INTEGER := 0;
   h_month_09_flag PLS_INTEGER := 0;
   h_month_10_flag PLS_INTEGER := 0;
   h_month_11_flag PLS_INTEGER := 0;
   h_month_12_flag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CTPLF_A1 IS
         SELECT	PROJECT_ID, 
         ELEMENT_ID, 
         TYPE_ID, 
         TO_DATE(SubStr(UNRESOLVED_START, 1, 10)),
         TO_DATE(SubStr(UNRESOLVED_FINISH, 1, 10)),
         TO_DATE(SubStr(LEVEL_START, 1, 10)), 
         TO_DATE(SubStr(LEVEL_FINISH, 1, 10))  
         FROM LEV_TMT_WBS 
         WHERE LEVEL_START IS NOT NULL 
         AND LEVEL_FINISH IS NOT NULL 
         ORDER BY PROJECT_ID, RANK DESC;

      CURSOR CTPLF_A2 IS
         SELECT CHARGECODE_ID, (BUDGET-ACTUAL)   
         FROM BUDGETS 
         WHERE PROJECT_ID = h_project_id 
         AND ELEMENT_ID = h_element_id 
         AND CHARGECODE_ID NOT IN (	SELECT ELEMENT_ID 
         FROM TMT_CHARGECODES 
         WHERE RANK < '0000' );

      CURSOR CTPLF_A3 IS
         SELECT	BUDGET_TYPE, 
         BUDGET_YEAR, 
         SIGN(MONTH_01_AMOUNT), 
         SIGN(MONTH_02_AMOUNT), 
         SIGN(MONTH_03_AMOUNT), 
         SIGN(MONTH_04_AMOUNT), 
         SIGN(MONTH_05_AMOUNT), 
         SIGN(MONTH_06_AMOUNT), 
         SIGN(MONTH_07_AMOUNT), 
         SIGN(MONTH_08_AMOUNT), 
         SIGN(MONTH_09_AMOUNT), 
         SIGN(MONTH_10_AMOUNT), 
         SIGN(MONTH_11_AMOUNT), 
         SIGN(MONTH_12_AMOUNT) 
         FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id 
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_chargecode_id
         AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET 
         AND TOTAL_AMOUNT > 0 
         ORDER BY BUDGET_YEAR DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_LEVELED_EX') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_LEVELED_EX'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_LEVELED_EX();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_LEVELED_EX', 78+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_LEVELED_EX(79) : timephase.sql(7752) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NEW_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_LABOR_BUDGETS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CTPLF_A1;
   
   LOOP
      FETCH CTPLF_A1 INTO	h_project_id, 
      h_element_id, 
      h_type_id, 
      h_SD, 
      h_FD, 
      h_period_start, 
      h_period_finish;
      IF CTPLF_A1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      -- Non-Labor Charge Codes
      
      OPEN CTPLF_A2;
      
      LOOP
         FETCH CTPLF_A2 INTO h_chargecode_id, h_total_amount;
         IF CTPLF_A2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If isTask(Coalesce(h_type_id, 0)) <> 0 Then
            -- time-phase WBS remaining
            h_type := PMO_CNST.SC_WBS_LEVELED_BUDGET;
         Else
            OPEN CTPLF_A3;
            
            FETCH CTPLF_A3 INTO	h_type, 
            h_year, 
            h_month_01_flag, 
            h_month_02_flag, 
            h_month_03_flag, 
            h_month_04_flag, 
            h_month_05_flag, 
            h_month_06_flag, 
            h_month_07_flag, 
            h_month_08_flag, 
            h_month_09_flag, 
            h_month_10_flag, 
            h_month_11_flag, 
            h_month_12_flag;
            IF CTPLF_A3%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               BEGIN
                  SELECT	MONTH_01_AMOUNT*h_month_01_flag+
                  MONTH_02_AMOUNT*h_month_02_flag+ 
                  MONTH_03_AMOUNT*h_month_03_flag+ 
                  MONTH_04_AMOUNT*h_month_04_flag+ 
                  MONTH_05_AMOUNT*h_month_05_flag+ 
                  MONTH_06_AMOUNT*h_month_06_flag+ 
                  MONTH_07_AMOUNT*h_month_07_flag+ 
                  MONTH_08_AMOUNT*h_month_08_flag+ 
                  MONTH_09_AMOUNT*h_month_09_flag+ 
                  MONTH_10_AMOUNT*h_month_10_flag+ 
                  MONTH_11_AMOUNT*h_month_11_flag+ 
                  MONTH_12_AMOUNT*h_month_12_flag 
                  INTO	h_total_amount 
                  FROM PROJECT_BUDGET_BREAKDOWN
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET 
                  AND BUDGET_YEAR = h_year;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 181+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(182) : timephase.sql(7855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT SUM(TOTAL_AMOUNT) + h_total_amount
                  INTO h_total_amount 
                  FROM PROJECT_BUDGET_BREAKDOWN
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET 
                  AND BUDGET_YEAR > h_year;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 201+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(202) : timephase.sql(7875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT COALESCE(SUM(TOTAL_AMOUNT),0) 
                  INTO h_total_amount 
                  FROM PROJECT_BUDGET_BREAKDOWN
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 220+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(221) : timephase.sql(7894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               CLOSE CTPLF_A3 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 234+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(235) : timephase.sql(7908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- time-phase WS remaining
            h_type := PMO_CNST.SC_WS_LEVELED_BUDGET;
         End If;
         
         -- Go time-phase
         If Coalesce(h_total_amount, 0) > 0.0 Then
            PMO_DB2M.SC_STATE := FC_TIMEPHASE_AMOUNT(h_project_id, h_element_id, h_chargecode_id, h_total_amount
                                         , h_period_start, h_period_finish, h_type);
         End If;
      END LOOP;
      
      BEGIN
         CLOSE CTPLF_A2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 258+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(259) : timephase.sql(7932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
      -- Labor Charge Codes
      If isTask(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         BEGIN
            INSERT INTO PMO_LABOR_BUDGETS 
            SELECT  FC.FISCAL_YEAR, 
            FC.FISCAL_MONTH, 
            TDY.PROJECT_ID, 
            TA.TASK_ID, 
            TA.CAPITAL_EXPENSE, 
            TA.BILLABLE, 
            (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_COST AS LABOR_COST, 
            (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_RATE AS LABOR_RATE  
            FROM TASK_ASSIGNMENTS TA 
            JOIN LEVEL_TASK_DAY_OF_YEAR TDY 
            ON TDY.PROJECT_ID = TA.PROJECT_ID 
            AND TDY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID 
            JOIN FISCAL_CALENDAR FC 
            ON TDY.DAY_YEAR BETWEEN FC.START_DATE AND FC.FINISH_DATE  
            WHERE TA.PROJECT_ID = h_project_id 
            AND TA.TASK_ID = h_element_id 
            GROUP BY	FC.FISCAL_YEAR, 
            FC.FISCAL_MONTH, 
            TDY.PROJECT_ID, 
            TA.TASK_ID, 
            TA.CAPITAL_EXPENSE,
            TA.BILLABLE, 
            TA.REGULAR_COST, 
            TA.REGULAR_RATE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 302+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(303) : timephase.sql(7976) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	PROJECT_ID, 
            TASK_ID,
            CASE WHEN CAPITAL_EXPENSE = 0 THEN 'EXPENSE_LABOR' WHEN CAPITAL_EXPENSE = 1 THEN 'CAPITAL_LABOR' WHEN CAPITAL_EXPENSE = 2 THEN 'BENEFIT_LABOR' END, 
            FISCAL_YEAR, 
            CASE WHEN PROJECT_ID = TASK_ID THEN PMO_CNST.SC_WS_LEVELED_BUDGET ELSE PMO_CNST.SC_WBS_LEVELED_BUDGET END, 
            SUM(CASE WHEN FISCAL_MONTH =  1 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  2 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  3 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  4 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  5 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  6 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  7 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  8 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  9 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),  
            SUM(CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END) 
            FROM PMO_LABOR_BUDGETS 
            GROUP BY	PROJECT_ID, 
            TASK_ID, 
            CAPITAL_EXPENSE, 
            FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 360+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(361) : timephase.sql(8034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If NOT (isTask(Coalesce(h_type_id, 0))) <> 0 Then
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	h_project_id, 
            h_element_id, 
            F.CHARGECODE_ID, 
            F.BUDGET_YEAR, 
            F.BUDGET_TYPE, 
            SUM(F.MONTH_01_AMOUNT), 
            SUM(F.MONTH_02_AMOUNT), 
            SUM(F.MONTH_03_AMOUNT), 
            SUM(F.MONTH_04_AMOUNT), 
            SUM(F.MONTH_05_AMOUNT), 
            SUM(F.MONTH_06_AMOUNT), 
            SUM(F.MONTH_07_AMOUNT), 
            SUM(F.MONTH_08_AMOUNT), 
            SUM(F.MONTH_09_AMOUNT), 
            SUM(F.MONTH_10_AMOUNT), 
            SUM(F.MONTH_11_AMOUNT), 
            SUM(F.MONTH_12_AMOUNT), 
            SUM(F.TOTAL_AMOUNT) 
            FROM TMT_WBS W 
            JOIN TMT_WBS T
            ON W.RANK < T.RANK
            AND LENGTH(W.RANK) < LENGTH(T.RANK) 
            AND (LENGTH(T.RANK)-LENGTH(W.RANK)) = 4
            AND PMO_ORASTD.LEFT(T.RANK,LENGTH(W.RANK)) = W.RANK 
            JOIN PMO_NEW_TIMEPHASE F 
            ON F.PROJECT_ID = T.PROJECT_ID	
            AND F.ELEMENT_ID = T.ELEMENT_ID 
            AND F.BUDGET_TYPE = PMO_CNST.SC_WBS_LEVELED_BUDGET
            WHERE W.PROJECT_ID = h_project_id 
            AND W.ELEMENT_ID = h_element_id 
            GROUP BY	F.CHARGECODE_ID, 
            F.BUDGET_YEAR, 
            F.BUDGET_TYPE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 430+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(431) : timephase.sql(8104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN 
         WHERE PROJECT_ID = h_project_id 
         AND ELEMENT_ID = h_element_id 
         AND BUDGET_TYPE IN (PMO_CNST.SC_WS_LEVELED_BUDGET, PMO_CNST.SC_WBS_LEVELED_BUDGET);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 451+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(452) : timephase.sql(8125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CTPLF_A1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 465+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(466) : timephase.sql(8139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Update Physical Table
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN ( 
      PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE, 
      MONTH_01_AMOUNT, 
      MONTH_02_AMOUNT, 
      MONTH_03_AMOUNT, 
      MONTH_04_AMOUNT, 
      MONTH_05_AMOUNT, 
      MONTH_06_AMOUNT, 
      MONTH_07_AMOUNT, 
      MONTH_08_AMOUNT, 
      MONTH_09_AMOUNT, 
      MONTH_10_AMOUNT, 
      MONTH_11_AMOUNT, 
      MONTH_12_AMOUNT, 
      TOTAL_AMOUNT,
      PROCESS_FLAG ) 
      SELECT 	PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE, 
      SUM(MONTH_01_AMOUNT), 
      SUM(MONTH_02_AMOUNT), 
      SUM(MONTH_03_AMOUNT), 
      SUM(MONTH_04_AMOUNT), 
      SUM(MONTH_05_AMOUNT), 
      SUM(MONTH_06_AMOUNT), 
      SUM(MONTH_07_AMOUNT), 
      SUM(MONTH_08_AMOUNT), 
      SUM(MONTH_09_AMOUNT), 
      SUM(MONTH_10_AMOUNT), 
      SUM(MONTH_11_AMOUNT), 
      SUM(MONTH_12_AMOUNT), 
      SUM(TOTAL_AMOUNT), 
      'I' 
      FROM PMO_NEW_TIMEPHASE
      GROUP BY	PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED_EX', 527+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED_EX(528) : timephase.sql(8201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_LEVELED_EX', 533+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_LEVELED_EX(534) : timephase.sql(8207) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_LEVELED_EX;
ALTER FUNCTION FC_TIMEPHASE_LEVELED_EX COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_LEVELED ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_LEVELED RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_SD DATE;
   h_FD DATE;
   h_period_start DATE;
   h_period_finish DATE;
   h_first_year PLS_INTEGER := 0;
   h_first_month PLS_INTEGER := 0;
   h_timephase_start DATE;
   h_chargecode_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_total_amount NUMBER := 0;
   h_month_01_flag PLS_INTEGER := 0;
   h_month_02_flag PLS_INTEGER := 0;
   h_month_03_flag PLS_INTEGER := 0;
   h_month_04_flag PLS_INTEGER := 0;
   h_month_05_flag PLS_INTEGER := 0;
   h_month_06_flag PLS_INTEGER := 0;
   h_month_07_flag PLS_INTEGER := 0;
   h_month_08_flag PLS_INTEGER := 0;
   h_month_09_flag PLS_INTEGER := 0;
   h_month_10_flag PLS_INTEGER := 0;
   h_month_11_flag PLS_INTEGER := 0;
   h_month_12_flag PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_labor_flag PLS_INTEGER := 0;
   h_date_new DATE;
   h_date_old DATE;
-- Declare Cursors
      CURSOR CTPLF_B1 IS
         SELECT	PROJECT_ID, 
         ELEMENT_ID, 
         TYPE_ID, 
         TO_DATE(SubStr(UNRESOLVED_START, 1, 10)),
         TO_DATE(SubStr(UNRESOLVED_FINISH, 1, 10)),
         TO_DATE(SubStr(LEVEL_START, 1, 10)), 
         TO_DATE(SubStr(LEVEL_FINISH, 1, 10))  
         FROM LEV_TMT_WBS 
         WHERE LEVEL_START IS NOT NULL 
         AND LEVEL_FINISH IS NOT NULL 
         ORDER BY PROJECT_ID, RANK DESC;

      CURSOR CTPLF_B2 IS
         SELECT B.CHARGECODE_ID, (B.BUDGET-B.ACTUAL), SIGN(InStr(C.RANK, '!!!!'))
         FROM BUDGETS B 
         JOIN TMT_CHARGECODES C 
         ON C.ELEMENT_ID = B.CHARGECODE_ID 
         WHERE B.PROJECT_ID = h_project_id 
         AND B.ELEMENT_ID = h_element_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_LEVELED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_LEVELED'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_LEVELED();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_LEVELED', 61+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_LEVELED(62) : timephase.sql(8279) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_MONTH_FLAGS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_BUDGETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NEW_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_LABOR_BUDGETS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Populate monthly flag utility table
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(1,1,0,0,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(98) : timephase.sql(8315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(2,0,1,0,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(114) : timephase.sql(8331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(3,0,0,1,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 129+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(130) : timephase.sql(8347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(4,0,0,0,1,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(146) : timephase.sql(8363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(5,0,0,0,0,1,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(162) : timephase.sql(8379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(6,0,0,0,0,0,1,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(178) : timephase.sql(8395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(7,0,0,0,0,0,0,1,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(194) : timephase.sql(8411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(8,0,0,0,0,0,0,0,1,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(210) : timephase.sql(8427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(9,0,0,0,0,0,0,0,0,1,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 225+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(226) : timephase.sql(8443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(10,0,0,0,0,0,0,0,0,0,1,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 241+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(242) : timephase.sql(8459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(11,0,0,0,0,0,0,0,0,0,0,1,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(258) : timephase.sql(8475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(12,0,0,0,0,0,0,0,0,0,0,0,1);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 273+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(274) : timephase.sql(8491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CTPLF_B1;
   
   LOOP
      FETCH CTPLF_B1 INTO	h_project_id, 
      h_element_id, 
      h_type_id, 
      h_SD, 
      h_FD, 
      h_period_start, 
      h_period_finish;
      IF CTPLF_B1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      --AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      -- Non-Labor Charge Codes
      
      OPEN CTPLF_B2;
      
      LOOP
         FETCH CTPLF_B2 INTO h_chargecode_id, h_total_amount, h_labor_flag;
         IF CTPLF_B2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If isTask(Coalesce(h_type_id, 0)) <> 0 Then
            If (Coalesce(h_total_amount, 0) > 0.0) AND (Coalesce(h_labor_flag, 0) = 0) Then
               -- time-phase WBS remaining
               h_type := PMO_CNST.SC_WBS_LEVELED_BUDGET;
               
               -- Go time-phase
               PMO_DB2M.SC_STATE := FC_TIMEPHASE_AMOUNT(h_project_id, h_element_id, h_chargecode_id, h_total_amount
                                         , h_period_start, h_period_finish, h_type);
            End If;
         Else
            If Coalesce(h_labor_flag, 0) = 1 Then
               BEGIN
                  SELECT COUNT(TSK_ASSIGNMENT_ID) 
                  INTO h_labor_flag 
                  FROM TASK_ASSIGNMENTS 
                  WHERE PROJECT_ID = h_project_id
                  AND TASK_ID = h_element_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 336+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(337) : timephase.sql(8554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If Coalesce(h_labor_flag, 0) = 0 Then
               -- time-phase WS remaining
               h_type := PMO_CNST.SC_WS_LEVELED_BUDGET;
               
               -- fetch time-phase data into monthly rows
               BEGIN
                  INSERT INTO PMO_BUDGETS 
                  SELECT	PBB.PROJECT_ID, 
                  PBB.ELEMENT_ID, 
                  PBB.CHARGECODE_ID, 
                  PBB.BUDGET_YEAR, 
                  MF.MID, 
                  SUM(
                  (CASE WHEN PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET THEN 1 ELSE 0 END) * (
                  PBB.MONTH_01_AMOUNT*MF.M01+PBB.MONTH_02_AMOUNT*MF.M02+PBB.MONTH_03_AMOUNT*MF.M03+ 
                  PBB.MONTH_04_AMOUNT*MF.M04+PBB.MONTH_05_AMOUNT*MF.M05+PBB.MONTH_06_AMOUNT*MF.M06+  
                  PBB.MONTH_07_AMOUNT*MF.M07+PBB.MONTH_08_AMOUNT*MF.M08+PBB.MONTH_09_AMOUNT*MF.M09+ 
                  PBB.MONTH_10_AMOUNT*MF.M10+PBB.MONTH_11_AMOUNT*MF.M11+PBB.MONTH_12_AMOUNT*MF.M12
                  )) AS MONTHLY_ESTIMATE,  
                  SUM(
                  (CASE WHEN PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET THEN 1 ELSE 0 END) * (
                  PBB.MONTH_01_AMOUNT*MF.M01+PBB.MONTH_02_AMOUNT*MF.M02+PBB.MONTH_03_AMOUNT*MF.M03+ 
                  PBB.MONTH_04_AMOUNT*MF.M04+PBB.MONTH_05_AMOUNT*MF.M05+PBB.MONTH_06_AMOUNT*MF.M06+  
                  PBB.MONTH_07_AMOUNT*MF.M07+PBB.MONTH_08_AMOUNT*MF.M08+PBB.MONTH_09_AMOUNT*MF.M09+ 
                  PBB.MONTH_10_AMOUNT*MF.M10+PBB.MONTH_11_AMOUNT*MF.M11+PBB.MONTH_12_AMOUNT*MF.M12
                  )) AS MONTHLY_ACTUAL,  
                  0 AS MONTHLY_AMOUNT
                  FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_MONTH_FLAGS MF 
                  WHERE PBB.PROJECT_ID = h_project_id 
                  AND PBB.ELEMENT_ID = h_element_id
                  AND PBB.CHARGECODE_ID = h_chargecode_id 
                  AND PBB.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) 
                  GROUP BY    PBB.PROJECT_ID, 
                  PBB.ELEMENT_ID, 
                  PBB.CHARGECODE_ID, 
                  PBB.BUDGET_YEAR, 
                  MF.MID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 389+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(390) : timephase.sql(8607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- get the difference between the old and new dates
               BEGIN
                  SELECT	PMO_ORASTD.LEFT(h_period_start, 8) || '01',  
                  PMO_ORASTD.LEFT(h_SD, 8) || '01' 
                  INTO	h_date_new, 
                  h_date_old 
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 407+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(408) : timephase.sql(8625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT	CASE 
                  WHEN h_date_new >= h_date_old 
                  THEN PMO_ORASTD.DB2TIMESTAMPDIFF(64, TO_DATE(SubStr(h_date_new, 1, 10)), TO_DATE(SubStr(h_date_old, 1, 10))) 
                  ELSE PMO_ORASTD.DB2TIMESTAMPDIFF(64, TO_DATE(SubStr(h_date_new, 1, 10)), TO_DATE(SubStr(h_date_old, 1, 10))) 
                  END
                  INTO	h_diff 
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 426+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(427) : timephase.sql(8644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- trace_printf("h_date_new: %s; h_date_old: %s; h_diff: %d\n", h_date_new, h_date_old, h_diff);
               -- update SESSION.PMO_BUDGETS using the difference
               BEGIN
                  UPDATE PMO_BUDGETS SET 
                  BUDGET_YEAR		=   BUDGET_YEAR + (
                  CASE 
                  WHEN (BUDGET_MONTH+h_diff) > 12 THEN (BUDGET_MONTH+h_diff)/12
                  WHEN (BUDGET_MONTH+h_diff) BETWEEN 1 AND 12 THEN 0 
                  WHEN (BUDGET_MONTH+h_diff) < 0 THEN ((BUDGET_MONTH+h_diff)/12) - 1 
                  END), 
                  BUDGET_MONTH	=	CASE 
                  WHEN (BUDGET_MONTH+h_diff) > 12 THEN MOD((BUDGET_MONTH+h_diff),12) 
                  WHEN (BUDGET_MONTH+h_diff) BETWEEN 1 AND 12 THEN (BUDGET_MONTH+h_diff)
                  WHEN (BUDGET_MONTH+h_diff) < 0 THEN 12+(BUDGET_MONTH+h_diff)
                  END, 
                  MONTHLY_AMOUNT	=	CASE WHEN (MONTHLY_ESTIMATE - MONTHLY_ACTUAL) < 0 THEN 0 ELSE (MONTHLY_ESTIMATE - MONTHLY_ACTUAL) END 
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 460+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(461) : timephase.sql(8678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- pivot back into the 12 months per record format
               BEGIN
                  INSERT INTO PMO_NEW_TIMEPHASE 
                  SELECT  B.PROJECT_ID, 
                  B.ELEMENT_ID, 
                  B.BUDGET_YEAR, 
                  h_type, 
                  B.CHARGECODE_ID, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-1)))*B.MONTHLY_AMOUNT), -- AS MONTH_01_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-2)))*B.MONTHLY_AMOUNT), -- AS MONTH_02_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-3)))*B.MONTHLY_AMOUNT), -- AS MONTH_03_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-4)))*B.MONTHLY_AMOUNT), -- AS MONTH_04_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-5)))*B.MONTHLY_AMOUNT), -- AS MONTH_05_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-6)))*B.MONTHLY_AMOUNT), -- AS MONTH_06_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-7)))*B.MONTHLY_AMOUNT), -- AS MONTH_07_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-8)))*B.MONTHLY_AMOUNT), -- AS MONTH_08_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-9)))*B.MONTHLY_AMOUNT), -- AS MONTH_09_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-10)))*B.MONTHLY_AMOUNT), -- AS MONTH_10_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-11)))*B.MONTHLY_AMOUNT), -- AS MONTH_11_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-12)))*B.MONTHLY_AMOUNT), -- AS MONTH_12_AMOUNT, 
                  SUM(B.MONTHLY_AMOUNT)
                  FROM PMO_BUDGETS B 
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id 
                  GROUP BY    B.PROJECT_ID, 
                  B.ELEMENT_ID, 
                  B.CHARGECODE_ID, 
                  B.BUDGET_YEAR;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 504+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(505) : timephase.sql(8722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE CTPLF_B2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 520+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(521) : timephase.sql(8738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
      -- Labor Charge Codes
      If isTask(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         BEGIN
            INSERT INTO PMO_LABOR_BUDGETS 
            SELECT  FC.FISCAL_YEAR, 
            FC.FISCAL_MONTH, 
            TDY.PROJECT_ID, 
            TA.TASK_ID, 
            TA.CAPITAL_EXPENSE, 
            TA.BILLABLE, 
            (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_COST AS LABOR_COST, 
            (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_RATE AS LABOR_RATE  
            FROM TASK_ASSIGNMENTS TA 
            JOIN LEVEL_TASK_DAY_OF_YEAR TDY 
            ON TDY.PROJECT_ID = TA.PROJECT_ID 
            AND TDY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID 
            JOIN FISCAL_CALENDAR FC 
            ON TDY.DAY_YEAR BETWEEN FC.START_DATE AND FC.FINISH_DATE  
            WHERE TA.PROJECT_ID = h_project_id 
            AND TA.TASK_ID = h_element_id 
            GROUP BY	FC.FISCAL_YEAR, 
            FC.FISCAL_MONTH, 
            TDY.PROJECT_ID, 
            TA.TASK_ID, 
            TA.CAPITAL_EXPENSE,
            TA.BILLABLE, 
            TA.REGULAR_COST, 
            TA.REGULAR_RATE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 564+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(565) : timephase.sql(8782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Expense and Capital
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	PROJECT_ID, 
            TASK_ID,
            CASE WHEN CAPITAL_EXPENSE = 0 THEN 'EXPENSE_LABOR' WHEN CAPITAL_EXPENSE = 1 THEN 'CAPITAL_LABOR' /*WHEN CAPITAL_EXPENSE = 2 THEN 'BENEFIT_LABOR'*/ END, 
            FISCAL_YEAR, 
            CASE WHEN PROJECT_ID = TASK_ID THEN PMO_CNST.SC_WS_LEVELED_BUDGET ELSE PMO_CNST.SC_WBS_LEVELED_BUDGET END, 
            SUM(CASE WHEN FISCAL_MONTH =  1 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  2 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  3 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  4 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  5 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  6 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  7 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  8 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  9 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN LABOR_COST ELSE 0.00 END), 
            SUM(LABOR_COST) 
            FROM PMO_LABOR_BUDGETS 
            WHERE PROJECT_ID = h_project_id 
            AND TASK_ID = h_element_id 
            GROUP BY	PROJECT_ID, 
            TASK_ID, 
            CAPITAL_EXPENSE, 
            FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 625+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(626) : timephase.sql(8843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Benefit
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	PROJECT_ID, 
            TASK_ID,
            'BILLABLE_BENEFIT_LABOR', 
            FISCAL_YEAR, 
            CASE WHEN PROJECT_ID = TASK_ID THEN PMO_CNST.SC_WS_LEVELED_BUDGET ELSE PMO_CNST.SC_WBS_LEVELED_BUDGET END, 
            SUM(CASE WHEN FISCAL_MONTH =  1 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  2 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  3 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  4 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  5 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  6 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  7 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  8 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  9 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(LABOR_RATE) 
            FROM PMO_LABOR_BUDGETS 
            WHERE PROJECT_ID = h_project_id 
            AND TASK_ID = h_element_id 
            AND LABOR_RATE > 0
            GROUP BY	PROJECT_ID, 
            TASK_ID, 
            FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 686+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(687) : timephase.sql(8904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If NOT (isTask(Coalesce(h_type_id, 0))) <> 0 Then
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	h_project_id, 
            h_element_id, 
            F.CHARGECODE_ID, 
            F.BUDGET_YEAR, 
            F.BUDGET_TYPE, 
            SUM(F.MONTH_01_AMOUNT), 
            SUM(F.MONTH_02_AMOUNT), 
            SUM(F.MONTH_03_AMOUNT), 
            SUM(F.MONTH_04_AMOUNT), 
            SUM(F.MONTH_05_AMOUNT), 
            SUM(F.MONTH_06_AMOUNT), 
            SUM(F.MONTH_07_AMOUNT), 
            SUM(F.MONTH_08_AMOUNT), 
            SUM(F.MONTH_09_AMOUNT), 
            SUM(F.MONTH_10_AMOUNT), 
            SUM(F.MONTH_11_AMOUNT), 
            SUM(F.MONTH_12_AMOUNT), 
            SUM(F.TOTAL_AMOUNT) 
            FROM TMT_WBS W 
            JOIN TMT_WBS T
            ON W.RANK < T.RANK
            AND LENGTH(W.RANK) < LENGTH(T.RANK) 
            AND (LENGTH(T.RANK)-LENGTH(W.RANK)) = 4
            AND PMO_ORASTD.LEFT(T.RANK,LENGTH(W.RANK)) = W.RANK 
            JOIN PMO_NEW_TIMEPHASE F 
            ON F.PROJECT_ID = T.PROJECT_ID	
            AND F.ELEMENT_ID = T.ELEMENT_ID 
            AND F.BUDGET_TYPE = PMO_CNST.SC_WBS_LEVELED_BUDGET
            WHERE W.PROJECT_ID = h_project_id 
            AND W.ELEMENT_ID = h_element_id 
            GROUP BY	F.CHARGECODE_ID, 
            F.BUDGET_YEAR, 
            F.BUDGET_TYPE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 756+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(757) : timephase.sql(8974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN 
         WHERE PROJECT_ID = h_project_id 
         AND ELEMENT_ID = h_element_id 
         AND BUDGET_TYPE IN (PMO_CNST.SC_WS_LEVELED_BUDGET, PMO_CNST.SC_WBS_LEVELED_BUDGET);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 777+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(778) : timephase.sql(8995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CTPLF_B1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 791+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(792) : timephase.sql(9009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Update Physical Table
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN ( 
      PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE, 
      MONTH_01_AMOUNT, 
      MONTH_02_AMOUNT, 
      MONTH_03_AMOUNT, 
      MONTH_04_AMOUNT, 
      MONTH_05_AMOUNT, 
      MONTH_06_AMOUNT, 
      MONTH_07_AMOUNT, 
      MONTH_08_AMOUNT, 
      MONTH_09_AMOUNT, 
      MONTH_10_AMOUNT, 
      MONTH_11_AMOUNT, 
      MONTH_12_AMOUNT, 
      TOTAL_AMOUNT,
      PROCESS_FLAG ) 
      SELECT 	PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE, 
      SUM(MONTH_01_AMOUNT), 
      SUM(MONTH_02_AMOUNT), 
      SUM(MONTH_03_AMOUNT), 
      SUM(MONTH_04_AMOUNT), 
      SUM(MONTH_05_AMOUNT), 
      SUM(MONTH_06_AMOUNT), 
      SUM(MONTH_07_AMOUNT), 
      SUM(MONTH_08_AMOUNT), 
      SUM(MONTH_09_AMOUNT), 
      SUM(MONTH_10_AMOUNT), 
      SUM(MONTH_11_AMOUNT), 
      SUM(MONTH_12_AMOUNT), 
      SUM(TOTAL_AMOUNT), 
      'I' 
      FROM PMO_NEW_TIMEPHASE
      GROUP BY	PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 853+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(854) : timephase.sql(9071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_LEVELED', 859+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_LEVELED(860) : timephase.sql(9077) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_LEVELED;
ALTER FUNCTION FC_TIMEPHASE_LEVELED COMPILE DEBUG;

